/* A Bison parser, made by GNU Bison 3.5.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2019 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Undocumented macros, especially those whose name start with YY_,
   are private implementation details.  Do not rely on them.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.5"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 30 "parser.yy"


#define yyerror Lily_parser::parser_error

/* We use custom location type: Input objects */
#define YYLTYPE Input
#define YYSTYPE SCM
#define YYLLOC_DEFAULT(Current,Rhs,N) \
	((Current).set_location ((Rhs)[1], (Rhs)[N]))

#define YYPRINT(file, type, value)					\
	do {								\
		if (scm_is_eq (value, SCM_UNSPECIFIED))			\
			break;						\
		SCM s = Display::value_to_lily_string (value);		\
		char *p = scm_to_locale_string (s);			\
		fputs (p, file);					\
		free (p);						\
	} while (0)

#line 103 "parser.yy"
 // -*-Fundamental-*-

/*
FIXME:

   * The rules for who is protecting what are very shady.  Uniformise
     this.

   * There are too many lexical modes?
*/

#include "config.hh"

#include <cctype>
#include <cstdlib>
#include <cstdio>
using namespace std;

#include "book.hh"
#include "context.hh"
#include "context-def.hh"
#include "context-mod.hh"
#include "dimensions.hh"
#include "file-path.hh"
#include "input.hh"
#include "international.hh"
#include "lily-guile.hh"
#include "lily-lexer.hh"
#include "lily-parser.hh"
#include "ly-module.hh"
#include "main.hh"
#include "misc.hh"
#include "music.hh"
#include "output-def.hh"
#include "paper-book.hh"
#include "scm-hash.hh"
#include "score.hh"
#include "text-interface.hh"
#include "warn.hh"
#include "lily-imports.hh"

void
Lily_parser::parser_error (Input const *i, Lily_parser *parser, SCM *, const string &s)
{
	parser->parser_error (*i, s);
}

// The following are somewhat precarious constructs as they may change
// the value of the lookahead token.  That implies that the lookahead
// token must not yet have made an impact on the state stack other
// than causing the reduction of the current rule, or switching the
// lookahead token while Bison is mulling it over will cause trouble.

#define MYBACKUP(Token, Value, Location)				\
	do {								\
		if (yychar != YYEMPTY)					\
			parser->lexer_->push_extra_token		\
				(yylloc, yychar, yylval);		\
		if (Token)						\
			parser->lexer_->push_extra_token		\
				(Location, Token, Value);		\
		parser->lexer_->push_extra_token (Location, BACKUP);	\
		yychar = YYEMPTY;					\
	} while (0)


#define MYREPARSE(Location, Pred, Token, Value)				\
	do {								\
		if (yychar != YYEMPTY)					\
			parser->lexer_->push_extra_token		\
				(yylloc, yychar, yylval);		\
		parser->lexer_->push_extra_token			\
			(Location, Token, Value);			\
		parser->lexer_->push_extra_token			\
			(Location, REPARSE, Pred);			\
		yychar = YYEMPTY;					\
	} while (0)

#line 184 "parser.yy"


#define MY_MAKE_MUSIC(x, spot) \
	make_music_with_input (ly_symbol2scm (x), \
			       parser->lexer_->override_input (spot))

/* ES TODO:
- delay application of the function
*/

#define LOWLEVEL_MAKE_SYNTAX(location, proc, ...)			\
	with_location							\
		(parser->lexer_->override_input (location).smobbed_copy (), \
		 proc,							\
		 ##__VA_ARGS__)

/* Syntactic Sugar. */
#define MAKE_SYNTAX(name, location, ...)				\
	LOWLEVEL_MAKE_SYNTAX (location, Syntax::name, ##__VA_ARGS__)

#define START_MAKE_SYNTAX(name, ...)					\
	scm_list_n (Syntax::name, ##__VA_ARGS__, SCM_UNDEFINED)

#define FINISH_MAKE_SYNTAX(start, location, ...)			\
	LOWLEVEL_MAKE_SYNTAX						\
		(location,						\
		 Guile_user::apply,					\
		 scm_car (start),					\
		 scm_append_x						\
		 (scm_list_2 (scm_cdr (start),				\
			      scm_list_n (__VA_ARGS__, SCM_UNDEFINED))))

SCM get_next_unique_context_id ();
SCM get_next_unique_lyrics_context_id ();

#undef _
#if !HAVE_GETTEXT
#define _(x) x
#else
#include <libintl.h>
#define _(x) gettext (x)
#endif


static Music *make_music_with_input (SCM name, Input where);
bool add_post_events (Music *music, SCM events);
SCM reverse_music_list (Lily_parser *parser, Input loc, SCM lst, bool preserve, bool compress);
SCM check_scheme_arg (Lily_parser *parser, Input loc,
		      SCM arg, SCM args, SCM pred, SCM disp = SCM_UNDEFINED);
SCM make_music_from_simple (Lily_parser *parser, Input loc, SCM pitch);
SCM loc_on_copy (Lily_parser *parser, Input loc, SCM arg);
SCM make_chord_elements (Input loc, SCM pitch, SCM dur, SCM modification_list);
SCM make_chord_step (SCM step, Rational alter);
SCM make_simple_markup (SCM a);
SCM make_duration (SCM t, int dots = 0, SCM factor = SCM_UNDEFINED);
bool is_regular_identifier (SCM id, bool multiple=false);
SCM make_reverse_key_list (SCM keys);
SCM try_word_variants (SCM pred, SCM str);
SCM try_string_variants (SCM pred, SCM str);
int yylex (YYSTYPE *s, YYLTYPE *loc, Lily_parser *parser);


#line 233 "./out/parser.cc"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 1
#endif

/* Use api.header.include to #include this header
   instead of duplicating it here.  */
#ifndef YY_YY_OUT_PARSER_HH_INCLUDED
# define YY_YY_OUT_PARSER_HH_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    END_OF_FILE = 0,
    PREC_BOT = 258,
    REPEAT = 259,
    ALTERNATIVE = 260,
    COMPOSITE = 261,
    ADDLYRICS = 262,
    UNSIGNED = 263,
    REAL = 264,
    E_UNSIGNED = 265,
    EVENT_IDENTIFIER = 266,
    EVENT_FUNCTION = 267,
    HYPHEN = 268,
    EXTENDER = 269,
    DURATION_IDENTIFIER = 270,
    NUMBER_IDENTIFIER = 271,
    PREC_TOP = 272,
    ACCEPTS = 273,
    ALIAS = 274,
    BOOK = 275,
    BOOKPART = 276,
    CHANGE = 277,
    CHORDMODE = 278,
    CHORDS = 279,
    CONSISTS = 280,
    CONTEXT = 281,
    DEFAULT = 282,
    DEFAULTCHILD = 283,
    DENIES = 284,
    DESCRIPTION = 285,
    DRUMMODE = 286,
    DRUMS = 287,
    ETC = 288,
    FIGUREMODE = 289,
    FIGURES = 290,
    HEADER = 291,
    INVALID = 292,
    LAYOUT = 293,
    LYRICMODE = 294,
    LYRICS = 295,
    LYRICSTO = 296,
    MARKUP = 297,
    MARKUPLIST = 298,
    MIDI = 299,
    NAME = 300,
    NOTEMODE = 301,
    OVERRIDE = 302,
    PAPER = 303,
    REMOVE = 304,
    REST = 305,
    REVERT = 306,
    SCORE = 307,
    SCORELINES = 308,
    SEQUENTIAL = 309,
    SET = 310,
    SIMULTANEOUS = 311,
    TEMPO = 312,
    TYPE = 313,
    UNSET = 314,
    WITH = 315,
    NEWCONTEXT = 316,
    CHORD_BASS = 317,
    CHORD_CARET = 318,
    CHORD_COLON = 319,
    CHORD_MINUS = 320,
    CHORD_SLASH = 321,
    ANGLE_OPEN = 322,
    ANGLE_CLOSE = 323,
    DOUBLE_ANGLE_OPEN = 324,
    DOUBLE_ANGLE_CLOSE = 325,
    E_BACKSLASH = 326,
    E_EXCLAMATION = 327,
    E_PLUS = 328,
    FIGURE_CLOSE = 329,
    FIGURE_OPEN = 330,
    FIGURE_SPACE = 331,
    MULTI_MEASURE_REST = 332,
    EXPECT_MARKUP = 333,
    EXPECT_SCM = 334,
    BACKUP = 335,
    REPARSE = 336,
    EXPECT_MARKUP_LIST = 337,
    EXPECT_OPTIONAL = 338,
    EXPECT_NO_MORE_ARGS = 339,
    EMBEDDED_LILY = 340,
    BOOK_IDENTIFIER = 341,
    CHORD_MODIFIER = 342,
    CHORD_REPETITION = 343,
    DRUM_PITCH = 344,
    DURATION_ARG = 345,
    FRACTION = 346,
    LOOKUP_IDENTIFIER = 347,
    LYRIC_ELEMENT = 348,
    MARKUP_FUNCTION = 349,
    MARKUP_LIST_FUNCTION = 350,
    MARKUP_IDENTIFIER = 351,
    MARKUPLIST_IDENTIFIER = 352,
    MUSIC_FUNCTION = 353,
    MUSIC_IDENTIFIER = 354,
    NOTENAME_PITCH = 355,
    PITCH_IDENTIFIER = 356,
    RESTNAME = 357,
    SCM_ARG = 358,
    SCM_FUNCTION = 359,
    SCM_IDENTIFIER = 360,
    SCM_TOKEN = 361,
    STRING = 362,
    SYMBOL_LIST = 363,
    TONICNAME_PITCH = 364,
    SYMBOL = 365,
    UNARY_MINUS = 366
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef int YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif

/* Location type.  */
#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE YYLTYPE;
struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
};
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif



int yyparse (Lily_parser *parser, SCM *retval);

#endif /* !YY_YY_OUT_PARSER_HH_INCLUDED  */



#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))

/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                            \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
             && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE) \
             + YYSIZEOF (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  5
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   4231

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  129
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  200
/* YYNRULES -- Number of rules.  */
#define YYNRULES  599
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  888

#define YYUNDEFTOK  2
#define YYMAXUTOK   366


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    19,     2,     2,     2,     2,     2,    20,
       2,     2,   124,   118,    21,   117,   120,   126,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     8,     2,
       2,   123,     2,   128,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   127,     2,   125,    14,    15,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   121,     2,   122,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     9,    10,    11,    12,    13,    16,    17,
      18,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   119
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   392,   392,   393,   393,   401,   402,   404,   406,   409,
     416,   419,   423,   427,   434,   438,   442,   446,   450,   454,
     489,   505,   506,   514,   518,   522,   523,   524,   528,   529,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   549,   550,   551,   564,   565,   566,   570,   577,   581,
     582,   590,   597,   598,   599,   604,   616,   634,   638,   646,
     647,   650,   654,   663,   669,   669,   680,   684,   691,   695,
     700,   705,   720,   721,   722,   726,   730,   755,   756,   757,
     758,   759,   760,   761,   762,   763,   764,   765,   766,   767,
     768,   769,   779,   783,   787,   791,   795,   799,   803,   807,
     811,   818,   819,   829,   839,   849,   860,   870,   876,   885,
     898,   900,   900,   912,   915,   925,   936,   964,   976,   986,
     989,   993,   997,  1001,  1005,  1009,  1013,  1017,  1046,  1045,
    1049,  1058,  1066,  1071,  1074,  1077,  1081,  1085,  1089,  1093,
    1097,  1127,  1126,  1133,  1141,  1148,  1165,  1171,  1172,  1173,
    1178,  1181,  1241,  1240,  1263,  1276,  1286,  1292,  1297,  1306,
    1318,  1319,  1323,  1330,  1334,  1363,  1370,  1369,  1387,  1393,
    1396,  1399,  1408,  1411,  1415,  1425,  1431,  1432,  1433,  1437,
    1449,  1450,  1451,  1455,  1459,  1474,  1492,  1493,  1497,  1501,
    1508,  1511,  1517,  1520,  1528,  1529,  1530,  1535,  1534,  1542,
    1561,  1562,  1570,  1584,  1587,  1600,  1603,  1607,  1621,  1624,
    1630,  1633,  1655,  1656,  1657,  1658,  1661,  1668,  1669,  1670,
    1674,  1681,  1685,  1692,  1693,  1694,  1701,  1702,  1703,  1707,
    1708,  1765,  1766,  1770,  1777,  1778,  1782,  1791,  1792,  1804,
    1808,  1813,  1822,  1829,  1830,  1834,  1846,  1852,  1858,  1868,
    1872,  1882,  1886,  1890,  1894,  1898,  1902,  1910,  1923,  1940,
    1951,  1962,  1979,  1996,  2009,  2032,  2050,  2051,  2066,  2076,
    2092,  2108,  2117,  2144,  2155,  2165,  2184,  2195,  2205,  2219,
    2234,  2249,  2264,  2274,  2279,  2284,  2289,  2296,  2297,  2304,
    2305,  2324,  2328,  2332,  2336,  2343,  2347,  2351,  2355,  2362,
    2365,  2375,  2380,  2385,  2390,  2395,  2400,  2410,  2415,  2420,
    2425,  2432,  2450,  2461,  2472,  2490,  2508,  2522,  2545,  2557,
    2573,  2582,  2583,  2587,  2591,  2592,  2599,  2607,  2608,  2620,
    2620,  2627,  2631,  2642,  2653,  2658,  2664,  2669,  2676,  2683,
    2688,  2693,  2699,  2706,  2713,  2719,  2722,  2725,  2736,  2765,
    2772,  2784,  2785,  2789,  2793,  2800,  2801,  2803,  2804,  2805,
    2807,  2808,  2809,  2810,  2814,  2815,  2818,  2821,  2839,  2857,
    2865,  2880,  2912,  2930,  2939,  2942,  2951,  2962,  2963,  2964,
    2968,  2969,  2970,  2971,  2982,  2983,  2984,  2996,  2999,  3005,
    3021,  3022,  3023,  3024,  3032,  3036,  3037,  3041,  3048,  3055,
    3059,  3063,  3064,  3069,  3087,  3093,  3100,  3101,  3108,  3134,
    3144,  3160,  3164,  3165,  3166,  3170,  3177,  3180,  3201,  3204,
    3216,  3221,  3226,  3236,  3243,  3250,  3260,  3261,  3268,  3276,
    3277,  3280,  3285,  3289,  3292,  3313,  3314,  3319,  3322,  3323,
    3328,  3335,  3338,  3344,  3347,  3353,  3368,  3379,  3380,  3391,
    3392,  3396,  3401,  3407,  3414,  3422,  3430,  3433,  3436,  3439,
    3442,  3445,  3448,  3454,  3455,  3456,  3460,  3463,  3471,  3479,
    3487,  3493,  3499,  3502,  3509,  3512,  3519,  3530,  3533,  3545,
    3546,  3547,  3548,  3549,  3564,  3565,  3566,  3570,  3574,  3585,
    3589,  3600,  3608,  3611,  3614,  3617,  3623,  3626,  3633,  3636,
    3642,  3643,  3651,  3710,  3730,  3737,  3753,  3758,  3763,  3768,
    3772,  3782,  3788,  3795,  3798,  3804,  3807,  3810,  3813,  3819,
    3822,  3825,  3831,  3832,  3838,  3841,  3844,  3850,  3853,  3865,
    3868,  3871,  3875,  3878,  3881,  3887,  3890,  3894,  3895,  3896,
    3903,  3904,  3905,  3911,  3912,  3921,  3933,  3934,  3950,  3951,
    3962,  3961,  3970,  3986,  3995,  3999,  4006,  4014,  4017,  4022,
    4029,  4028,  4043,  4046,  4050,  4053,  4056,  4060,  4060,  4076,
    4083,  4089,  4090,  4093,  4099,  4105,  4108,  4111,  4114,  4120,
    4121,  4127,  4131,  4139,  4143,  4147,  4151,  4158,  4164,  4167,
    4173,  4174,  4178,  4182,  4186,  4186,  4199,  4202,  4209,  4214
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 1
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of input\"", "error", "$undefined", "PREC_BOT", "\"\\\\repeat\"",
  "\"\\\\alternative\"", "COMPOSITE", "\"\\\\addlyrics\"", "':'",
  "UNSIGNED", "REAL", "E_UNSIGNED", "EVENT_IDENTIFIER", "EVENT_FUNCTION",
  "'^'", "'_'", "\"--\"", "\"__\"", "DURATION_IDENTIFIER", "'!'", "'\\''",
  "','", "NUMBER_IDENTIFIER", "PREC_TOP", "\"\\\\accepts\"",
  "\"\\\\alias\"", "\"\\\\book\"", "\"\\\\bookpart\"", "\"\\\\change\"",
  "\"\\\\chordmode\"", "\"\\\\chords\"", "\"\\\\consists\"",
  "\"\\\\context\"", "\"\\\\default\"", "\"\\\\defaultchild\"",
  "\"\\\\denies\"", "\"\\\\description\"", "\"\\\\drummode\"",
  "\"\\\\drums\"", "\"\\\\etc\"", "\"\\\\figuremode\"", "\"\\\\figures\"",
  "\"\\\\header\"", "\"\\\\version-error\"", "\"\\\\layout\"",
  "\"\\\\lyricmode\"", "\"\\\\lyrics\"", "\"\\\\lyricsto\"",
  "\"\\\\markup\"", "\"\\\\markuplist\"", "\"\\\\midi\"", "\"\\\\name\"",
  "\"\\\\notemode\"", "\"\\\\override\"", "\"\\\\paper\"",
  "\"\\\\remove\"", "\"\\\\rest\"", "\"\\\\revert\"", "\"\\\\score\"",
  "\"\\\\score-lines\"", "\"\\\\sequential\"", "\"\\\\set\"",
  "\"\\\\simultaneous\"", "\"\\\\tempo\"", "\"\\\\type\"", "\"\\\\unset\"",
  "\"\\\\with\"", "\"\\\\new\"", "\"/+\"", "\"^\"", "\":\"", "\"-\"",
  "\"/\"", "\"<\"", "\">\"", "\"<<\"", "\">>\"", "\"\\\\\\\\\"",
  "\"\\\\!\"", "\"\\\\+\"", "FIGURE_CLOSE", "FIGURE_OPEN", "\"_\"",
  "MULTI_MEASURE_REST", "\"markup?\"", "\"scheme?\"", "\"(backed-up?)\"",
  "\"(reparsed?)\"", "\"markup-list?\"", "\"optional?\"",
  "EXPECT_NO_MORE_ARGS", "\"#{\"", "BOOK_IDENTIFIER", "CHORD_MODIFIER",
  "CHORD_REPETITION", "DRUM_PITCH", "DURATION_ARG", "FRACTION",
  "LOOKUP_IDENTIFIER", "LYRIC_ELEMENT", "MARKUP_FUNCTION",
  "MARKUP_LIST_FUNCTION", "MARKUP_IDENTIFIER", "MARKUPLIST_IDENTIFIER",
  "MUSIC_FUNCTION", "MUSIC_IDENTIFIER", "NOTENAME_PITCH",
  "PITCH_IDENTIFIER", "RESTNAME", "SCM_ARG", "SCM_FUNCTION",
  "SCM_IDENTIFIER", "SCM_TOKEN", "STRING", "SYMBOL_LIST",
  "TONICNAME_PITCH", "SYMBOL", "'-'", "'+'", "UNARY_MINUS", "'.'", "'{'",
  "'}'", "'='", "'*'", "']'", "'/'", "'['", "'?'", "$accept",
  "start_symbol", "$@1", "lilypond", "toplevel_expression", "lookup",
  "embedded_scm_bare", "embedded_scm_active", "embedded_scm_bare_arg",
  "embedded_scm", "embedded_scm_arg", "scm_function_call",
  "embedded_lilypond_number", "embedded_lilypond", "lilypond_header_body",
  "lilypond_header", "header_block", "$@2", "assignment_id", "assignment",
  "identifier_init", "identifier_init_nonumber",
  "partial_function_scriptable", "partial_function",
  "context_def_spec_block", "context_mod_arg", "$@3",
  "context_def_spec_body", "book_block", "book_body", "$@4",
  "bookpart_block", "bookpart_body", "$@5", "score_block", "score_body",
  "score_item", "score_items", "$@6", "paper_block", "output_def",
  "output_def_head", "output_def_head_with_mode_switch",
  "music_or_context_def", "output_def_body", "$@7", "tempo_event",
  "music_list", "braced_music_list", "music", "pitch_as_music",
  "music_embedded", "music_embedded_backup", "music_assign",
  "repeated_music", "sequential_music", "simultaneous_music",
  "simple_music", "context_modification", "$@8",
  "context_modification_arg", "optional_context_mods",
  "context_modification_mods_list", "context_mod_list", "context_prefix",
  "new_lyrics", "basic_music", "contextable_music",
  "contexted_basic_music", "composite_music", "music_bare",
  "grouped_music_list", "symbol_list_arg", "symbol_list_rev",
  "symbol_list_part", "symbol_list_element", "symbol_list_part_bare",
  "function_arglist_nonbackup", "reparsed_rhythm",
  "function_arglist_nonbackup_reparse", "function_arglist_backup",
  "function_arglist", "function_arglist_skip_nonbackup",
  "function_arglist_partial", "function_arglist_partial_optional",
  "function_arglist_common", "function_arglist_common_reparse",
  "function_arglist_optional", "function_arglist_skip_backup",
  "music_function_call", "optional_id", "lyric_mode_music", "$@9",
  "mode_changed_music", "mode_changing_head",
  "mode_changing_head_with_context", "context_change", "property_path",
  "property_operation", "revert_arg", "revert_arg_backup",
  "revert_arg_part", "context_def_mod", "context_mod", "grob_prop_spec",
  "grob_prop_path", "context_prop_spec", "simple_revert_context",
  "music_property_def", "string", "text", "simple_string", "symbol",
  "scalar", "event_chord", "note_chord_element", "chord_body",
  "chord_body_elements", "chord_body_element", "music_function_chord_body",
  "event_function_event", "post_events", "post_event_nofinger",
  "post_event", "string_number_event", "direction_less_event",
  "direction_reqd_event", "octave_check", "quotes", "erroneous_quotes",
  "sup_quotes", "sub_quotes", "steno_pitch", "steno_tonic_pitch", "pitch",
  "pitch_or_tonic_pitch", "gen_text_def", "fingering",
  "script_abbreviation", "script_dir", "maybe_notemode_duration",
  "optional_notemode_duration", "steno_duration", "multiplied_duration",
  "dots", "multipliers", "tremolo_type", "bass_number",
  "figured_bass_alteration", "bass_figure", "figured_bass_modification",
  "br_bass_figure", "figure_list", "optional_rest", "pitch_or_music",
  "simple_element", "lyric_element", "lyric_element_music", "new_chord",
  "chord_items", "chord_separator", "chord_item", "step_numbers",
  "step_number", "tempo_range", "number_expression", "number_term",
  "number_factor", "bare_number_common", "bare_number", "unsigned_number",
  "exclamations", "questions", "full_markup_list", "$@10", "markup_mode",
  "markup_mode_word", "full_markup", "partial_markup", "markup_top",
  "markup_scm", "$@11", "markup_list", "markup_uncomposed_list", "$@12",
  "markup_composed_list", "markup_braced_list", "markup_braced_list_body",
  "markup_command_list", "markup_command_basic_arguments",
  "markup_command_list_arguments", "markup_partial_function",
  "markup_arglist_partial", "markup_head_1_item", "markup_head_1_list",
  "markup_word", "simple_markup", "simple_markup_noword", "$@13", "markup", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_int16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,    58,   263,
     264,   265,   266,   267,    94,    95,   268,   269,   270,    33,
      39,    44,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,    45,    43,   366,
      46,   123,   125,    61,    42,    93,    47,    91,    63
};
# endif

#define YYPACT_NINF (-638)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-586)

#define yytable_value_is_error(Yyn) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     -27,  -638,   112,  1658,  1237,  -638,  -638,   976,    19,    26,
    -638,  -638,  1003,  -638,  -638,  -638,  -638,  -638,  -638,  -638,
    -638,  1023,  -638,  -638,  -638,  -638,  -638,    36,    46,    46,
    1003,  -638,  -638,    31,   207,  -638,   207,  -638,  -638,  -638,
    -638,  -638,  -638,  -638,  -638,  -638,  -638,   138,    86,  -638,
    -638,  -638,  -638,  -638,  -638,    84,  1570,  -638,  -638,  -638,
    -638,  3878,   183,  -638,  -638,  -638,  -638,  -638,  -638,   316,
    -638,  -638,  1331,   129,  -638,  -638,   219,   232,   238,  -638,
    -638,   230,   277,   277,  -638,  -638,  -638,  -638,  1003,   712,
    1237,   237,   237,   237,   493,   237,   698,  -638,  -638,   105,
     105,   105,  -638,  -638,   292,   242,   242,   105,   523,  -638,
    -638,   290,   242,   295,   329,  -638,  -638,   310,  -638,  -638,
    -638,  -638,  -638,  -638,   274,  -638,  -638,  -638,  -638,  -638,
    -638,  -638,  -638,  3647,   236,   330,  -638,  -638,  -638,  -638,
    -638,  -638,  -638,  -638,   105,  -638,  -638,   335,  -638,  -638,
    -638,   105,  -638,  1813,  -638,  -638,  -638,   346,  -638,   105,
    -638,  -638,  -638,  -638,  1397,  -638,   352,  -638,  -638,  -638,
    -638,   416,   266,   281,  -638,  -638,  -638,   243,   246,   256,
     265,   297,   283,   965,  -638,  -638,  -638,   243,  1949,   237,
     667,   315,  -638,  -638,   349,  -638,  -638,   356,  -638,  1355,
     327,  -638,   237,   237,  3203,  -638,  -638,  -638,  -638,  -638,
    -638,  3839,   113,   129,  -638,  -638,   183,  -638,  -638,  -638,
    -638,   443,  -638,   316,   387,  -638,  -638,   807,   835,  -638,
    -638,  -638,  -638,  -638,   167,  -638,  -638,  -638,  -638,  -638,
    -638,  1331,  -638,  -638,  3203,  -638,  -638,   336,  -638,   757,
     373,  -638,  -638,  -638,  -638,  -638,   336,   339,  -638,  -638,
    -638,  -638,  -638,  -638,    99,  -638,  -638,  -638,   237,   353,
    -638,   237,    99,   357,  -638,  -638,  -638,  -638,   105,   369,
    -638,  -638,  -638,  -638,   348,  -638,  3963,   895,  -638,  -638,
    -638,  -638,  -638,   757,   427,  -638,  -638,  -638,  -638,   481,
     494,  -638,  -638,   757,   434,  -638,  -638,   232,  -638,  -638,
    -638,   207,   237,   237,  -638,  -638,   277,  -638,  -638,  -638,
    -638,  4002,  -638,  -638,   383,  -638,  1083,  1115,   512,  -638,
    -638,  -638,  -638,  -638,  -638,  -638,  -638,  -638,  -638,  -638,
    -638,  -638,  -638,  -638,  -638,  1397,  -638,   412,   865,   919,
    -638,   919,   857,   504,  3623,  -638,  -638,  -638,  1065,  -638,
    1748,  -638,  1834,   976,  -638,  -638,  -638,   316,   976,   461,
     448,  -638,   965,    69,  3743,  -638,  -638,  -638,  -638,    99,
     470,   202,  -638,  3089,   473,   769,  1735,  3940,  -638,  -638,
      99,   438,   447,    95,   128,   133,   528,  -638,  -638,  -638,
    -638,   144,  -638,  -638,   223,  -638,   -25,  -638,  -638,  -638,
    -638,  -638,  -638,   443,   297,  -638,  -638,  -638,   451,   460,
     835,   835,   835,  -638,  -638,   835,  -638,  -638,  4090,   490,
    -638,  -638,  -638,  -638,  -638,  -638,  -638,  -638,  -638,   757,
     497,  -638,  2519,   778,   976,  4073,   237,   237,  -638,  3313,
    -638,  -638,   501,  -638,  3423,   465,   416,  -638,  -638,  -638,
    -638,  -638,  -638,  -638,  -638,  -638,  -638,  -638,  -638,  -638,
    -638,  -638,  -638,  -638,   874,  -638,  -638,   925,  -638,  -638,
     919,   919,  2519,   778,  -638,  -638,  2519,   778,   474,   479,
    1474,   919,  -638,   919,   478,  -638,  -638,   478,  -638,  -638,
     -10,  -638,    48,  -638,   919,   883,   883,  -638,  -638,   857,
     609,  -638,  -638,  -638,  -638,   138,  -638,  -638,  -638,  -638,
    -638,  -638,  -638,  -638,  -638,  -638,  -638,   138,  -638,  -638,
    -638,  -638,  -638,  -638,  -638,  -638,   297,  -638,  -638,  -638,
    -638,   138,  -638,  -638,  -638,   811,  1035,  -638,  -638,  -638,
    -638,  -638,  -638,  -638,  -638,   670,  -638,  -638,  -638,  -638,
    -638,  -638,  -638,  -638,  -638,  -638,  -638,  -638,  -638,  -638,
    -638,  -638,  -638,  -638,  -638,  -638,   530,  2633,   583,  -638,
    -638,   148,  -638,  -638,  -638,  -638,  -638,  -638,  -638,  -638,
    -638,  -638,  -638,  -638,  -638,   916,  3203,  3203,  -638,   598,
      87,  -638,   237,   237,   919,    87,    87,    87,    87,  -638,
     297,  -638,  -638,  -638,   634,   965,  1099,  -638,  -638,  1331,
    -638,  -638,  -638,  -638,  2747,   826,  -638,   757,   539,  2177,
    -638,  -638,  -638,  -638,  -638,  -638,  -638,  -638,  -638,   237,
    -638,   237,  -638,  1003,  -638,   265,  -638,  -638,  3960,  -638,
    -638,   455,  -638,   521,  -638,  -638,    54,  -638,  -638,  -638,
     528,  -638,  -638,   151,  -638,  -638,   260,  -638,  -638,    10,
    -638,  -638,   416,  -638,   518,  4109,   919,   512,   925,  -638,
    -638,  -638,  -638,  -638,  -638,  -638,  -638,  -638,  -638,  -638,
    2177,  -638,  2177,  3533,  3533,  -638,  -638,    66,   242,  -638,
     105,  -638,  -638,   883,   607,  -638,   634,  -638,  -638,    46,
    -638,  -638,  -638,  -638,   564,  2291,   618,  -638,  -638,  -638,
    -638,  -638,  -638,  -638,  -638,   769,  -638,  -638,  -638,  -638,
    -638,   783,  -638,  -638,  -638,  -638,  -638,  -638,  -638,   336,
     237,   237,  -638,  -638,  -638,  -638,  -638,  -638,  -638,  -638,
    -638,  -638,  -638,  -638,  -638,    78,    81,  -638,  -638,  -638,
     550,  1099,  -638,  -638,   568,  2063,  -638,  2861,   778,  -638,
     537,  -638,  -638,  -638,  -638,  -638,  -638,  3533,   757,   578,
    -638,   237,   237,    93,   127,   571,   405,  -638,  -638,   416,
    -638,  -638,  -638,   -10,  -638,  -638,   528,    55,  -638,  -638,
    -638,   548,  -638,  -638,   242,  1099,  -638,   811,  -638,  -638,
    -638,  -638,  -638,  -638,  -638,   812,  -638,  -638,  -638,  -638,
    -638,  -638,  -638,  -638,  -638,  -638,   412,    99,    99,  -638,
    -638,   826,  2405,  3533,  -638,  1209,   828,  -638,  -638,   757,
     587,   757,   589,   332,   581,   237,   237,  -638,  -638,  -638,
    -638,  -638,   674,  -638,   632,  -638,  -638,  -638,  -638,   919,
    -638,   237,   237,  -638,   606,  1209,  1209,   828,  1209,   828,
     883,   332,  -638,  -638,   919,  -638,  -638,  -638,   576,   584,
     828,  1209,  1209,  -638,   919,  1209,  1209,  2975
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       5,     3,     0,     0,     0,     1,     8,     0,     0,     0,
     337,   341,     0,   335,   339,   336,   340,     9,   158,   338,
     342,     0,   552,   550,   157,   334,   156,     0,     0,     0,
       0,   172,    13,    21,     0,   227,     0,    25,    18,    66,
      67,   172,     6,    27,    19,    26,    10,     0,     0,     7,
      11,    12,    14,    20,   159,     0,     0,   191,   213,   230,
     229,     0,   223,   224,    15,   214,   228,   212,   226,     0,
     203,    17,     0,   555,    16,    57,   477,   472,   537,   428,
     430,     0,   464,   463,   420,   421,   472,   538,     0,     0,
       0,     0,     0,     0,     0,     0,   197,   406,   498,   466,
     466,   466,    85,   509,     0,   437,   437,   466,     0,    24,
      23,   508,   437,   507,   465,    43,    41,   185,    42,    53,
       4,    77,    52,   101,     0,    82,    79,    80,    78,    81,
     401,   180,   178,     0,   182,   176,   186,    90,   187,   196,
     195,    86,   194,   402,   466,   432,   426,   181,   429,   418,
     447,   466,   546,   108,   474,   416,   431,   179,   416,   466,
     177,   416,    49,    89,     0,   555,   506,    88,   384,   385,
     386,     0,   118,   132,   387,   388,   389,   327,   384,   385,
     386,   329,     0,     0,   150,   190,   192,   327,     0,     0,
       0,     0,   299,   287,     0,   326,   243,     0,    47,     0,
       0,    65,     0,     0,    64,   162,   168,   165,   155,   164,
     163,     0,     0,     0,   218,   217,   221,   222,   219,   179,
     203,   225,   332,     0,   202,   594,   567,     0,     0,   590,
     591,   571,   560,   554,     0,   557,   563,   562,   564,   565,
     588,     0,   553,   559,    64,   478,    50,   469,   539,     0,
       0,   415,    93,   455,   424,   425,   470,     0,   113,    58,
     240,   239,   241,   238,   368,   234,   242,   237,   369,     0,
     372,     0,   371,     0,   472,   380,   381,   383,   171,     0,
     382,   376,   201,   200,     0,   199,     0,     0,   468,   416,
     467,   416,   504,     0,     0,    92,   441,   443,   445,   439,
     438,   448,   505,     0,     0,    94,   446,   455,    48,   427,
      91,     0,     0,     0,   508,   507,   465,   185,   172,   176,
     181,     0,   416,   506,     0,   416,   511,     0,   548,   456,
     462,   459,   460,   452,   453,   458,   457,   461,   454,   107,
     419,   423,   422,   433,   434,     0,   451,   471,   184,   398,
     416,   503,     0,     0,     0,   543,   544,   545,     0,   119,
       0,   133,     0,     0,   203,   331,   215,     0,     0,     0,
       0,   551,     0,     0,   145,   203,   174,   193,   173,    22,
       0,   321,   266,    64,     0,     0,     0,     0,   175,    59,
     344,     0,     0,   541,   377,   378,   465,    87,    68,    72,
      83,     0,   416,    84,    73,   531,   532,   540,   536,   379,
     161,   167,   160,   220,   329,   203,   333,   204,     0,     0,
       0,     0,     0,   578,   596,     0,   579,   574,     0,     0,
     597,   566,   569,   589,   592,   558,   593,    71,   473,     0,
       0,   292,    64,     0,     0,   111,     0,     0,   370,    64,
     351,   374,     0,   350,    64,     0,     0,   205,   404,   416,
     413,   414,   412,   407,   410,   411,   450,   449,   546,   479,
     405,   487,   480,   481,     0,   483,   488,   496,   499,   482,
     400,   399,    64,     0,   442,   444,    64,     0,     0,     0,
       0,   184,   183,   403,     0,   516,   515,     0,   513,   547,
     435,   106,     0,   417,   510,     0,     0,   581,   556,     0,
     188,   130,   126,   117,   127,     0,   121,   122,   120,   154,
     123,   125,   124,   143,   139,   131,   140,     0,   135,   134,
     136,   138,   137,   328,   208,   330,   329,   146,   144,   147,
     151,     0,   149,   148,   209,     0,     0,   317,   318,    30,
      28,   311,    29,   314,   315,   465,    40,    44,   300,    45,
      34,    36,    37,    38,    35,    39,    46,    33,   302,   313,
     312,   301,    32,   316,    31,   323,     0,    64,     0,   472,
     254,   231,   256,   252,   251,   250,   255,   253,   304,   310,
     309,   308,   306,   305,   307,     0,    64,    64,   542,   541,
       0,   535,     0,     0,    76,     0,     0,     0,     0,   210,
     329,   150,   150,   587,     0,     0,     0,   570,   573,     0,
     599,   572,   561,   296,    64,     0,    96,     0,     0,    64,
     294,   343,   357,   360,   355,   358,   359,   362,   363,     0,
     356,     0,   361,     0,   109,    41,   110,   116,     0,   115,
     364,     0,   114,     0,   236,   235,     0,   464,   463,   392,
     465,   390,   104,     0,   395,   373,   108,   391,   393,     0,
     105,   375,     0,   169,   527,   111,   409,   548,   497,   486,
     495,   493,   492,   484,   485,   489,   494,   490,   491,    95,
      64,    97,    64,    64,    64,   518,   517,   512,   437,   549,
     466,   475,   476,     0,   587,   583,   586,   584,   582,     0,
     129,   142,   216,   153,     0,   324,   325,   286,   285,   284,
     282,   283,   319,   320,   303,     0,   264,   265,   258,   261,
     262,   465,   248,   244,   260,   259,   249,   263,   288,   474,
       0,     0,    61,    63,    62,    60,    70,    69,    75,    74,
     530,   529,   533,   534,   211,     0,     0,   577,   576,   575,
       0,     0,   580,   598,     0,   324,   298,    64,     0,    99,
       0,   348,   346,   112,   365,   366,   367,    64,     0,     0,
     394,     0,     0,     0,     0,     0,     0,   349,   170,     0,
     198,   207,   206,   435,    98,   100,     0,   524,   521,   519,
     514,   520,   522,   436,   437,   585,   189,     0,   272,   273,
     278,   274,   279,   280,   281,   465,   267,   268,   270,   269,
     271,   322,   290,   245,   246,   247,   416,   233,   232,   595,
     568,     0,    64,    64,   345,   291,     0,   397,   396,     0,
       0,     0,     0,     0,     0,     0,     0,   354,   528,   416,
     526,   525,     0,   440,   500,   325,   275,   276,   277,   257,
     347,     0,     0,   465,     0,   293,   291,     0,   291,     0,
       0,     0,   353,   352,   408,   523,   501,   416,     0,     0,
       0,   293,   293,   586,   502,   102,   103,    64
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -638,  -638,  -638,  -638,  -638,     3,   210,   -51,  -638,    68,
     147,    12,   601,   630,  -638,  -317,   152,  -638,  -638,   -32,
    -186,    85,  -127,   309,    32,    50,  -638,  -638,   190,  -638,
    -638,    62,  -638,  -638,    73,  -139,  -638,  -638,  -638,   361,
      70,  -638,  -638,  -638,  -638,  -638,  -638,     9,   -19,  -280,
     672,    80,  -638,   710,  -638,  -638,  -638,  -638,    14,  -638,
    -638,  -183,  -638,  -638,  -638,   522,   678,  -638,   680,    25,
    -638,   -35,  -335,   -79,   -85,  -638,    41,    92,  -332,  -638,
    -484,    17,  -637,   -62,  -376,   239,  -638,   -42,  -464,   -91,
     541,  -360,  -638,  -638,  -638,  -638,  -638,  -182,  -638,  -382,
    -638,  -638,  -638,    67,  -638,  -309,   -93,  -638,  -638,  -349,
    -638,    30,     2,  -387,   692,  -638,  -638,  -638,  -638,  -638,
    -638,  -123,   -67,    56,  -638,   -84,  -638,   -38,   -95,  -638,
    -638,  -638,  -638,   333,   389,  -638,  -638,   423,  -638,    21,
    -131,   433,   -55,   204,   -59,    20,  -638,  -638,  -638,   299,
    -638,  -638,  -638,  -638,    37,  -638,  -638,  -203,  -638,  -638,
      74,  -638,  -638,   -86,   106,  -638,   -97,  -325,    18,  -369,
    -158,   313,   111,    89,  -638,   673,    27,    -3,    43,  -638,
    -175,  -638,  -150,  -210,  -638,  -638,  -638,  -638,  -638,  -178,
    -377,   626,  -403,  -201,   -68,    23,  -212,   -16,  -638,   366
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     2,     4,     3,    42,   115,   116,    44,   557,   232,
     558,   118,   119,   120,   595,   201,   560,    47,    48,    49,
     398,   399,   123,   124,   561,   647,   648,   445,   562,   360,
     515,   563,   362,   527,   564,   373,   540,   374,   541,   518,
     565,    54,    55,   411,    56,   211,   130,   188,    57,   131,
     132,   378,   134,   566,    58,    59,    60,   136,   567,   284,
     285,   223,   224,   675,    61,   221,    62,   216,    63,   138,
      65,    66,   582,   390,   265,   266,   267,   193,   583,   194,
     381,   195,   578,   630,   441,   196,   197,   383,   384,    67,
     364,   366,   367,    68,    69,    70,   139,   391,   650,   451,
     452,   453,   651,   652,   268,   269,   273,   271,   140,   141,
     278,   171,   177,   665,   142,   143,   144,   286,   463,   464,
     145,   348,   146,   503,   148,   149,   342,   700,   298,   854,
     299,   300,   150,   151,   152,   468,   343,   309,   344,   321,
     288,   289,   154,   290,   247,   347,   156,   476,   687,   477,
     688,   478,   287,   877,   219,   158,   159,   160,   161,   697,
     498,   800,   801,   802,   673,   404,   405,   406,   407,   408,
     674,   328,   500,   572,   183,   164,   165,   409,   574,   233,
     234,   429,   235,   236,   419,   237,   238,   428,   239,   426,
     427,   501,   507,   240,   354,   434,   620,   436,   418,   762
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      74,   166,   281,   488,   241,   209,    43,   270,   370,   185,
     186,   301,   264,   358,   272,    45,   272,   306,   137,   252,
     326,   392,   162,   182,   210,   153,   339,   256,    64,   435,
      73,   432,   187,   371,   222,   349,   125,   414,   351,   279,
     433,   157,   295,   613,   614,   615,   305,   167,   616,   424,
     199,   181,   589,   198,   609,   590,   243,   701,   437,    43,
     147,   715,   340,   623,     1,    51,   127,   671,    45,   341,
     537,   601,   117,    53,   129,   797,    52,   128,   510,   537,
     668,   716,   537,   213,   133,   668,   448,   166,   822,   122,
     257,   280,    71,   163,   543,   242,   599,    78,   251,   607,
     664,   608,   705,   707,   137,   664,   708,   202,   162,    87,
     379,   153,     5,   698,   274,   372,  -240,   598,   699,   786,
     446,   492,   125,    86,   581,   198,   850,   157,   704,   706,
     323,   822,   162,   167,   494,   495,   496,   402,   497,   778,
     172,   765,   435,   779,   432,   702,   147,   173,   243,  -239,
     346,   189,   127,   433,  -241,    46,   121,   184,   117,   798,
     129,   716,   432,   128,   283,   602,   480,    41,   481,   740,
     133,   433,   781,   851,   424,   122,   712,   402,   839,   163,
     200,   534,   840,   586,   593,   323,   450,   242,   416,   320,
     220,   538,   544,    50,   126,   462,   323,   370,   710,   491,
     829,   317,   493,   830,   600,   205,   203,   442,   155,   204,
     711,   717,   841,   318,   718,  -240,   842,   170,   137,   447,
     489,   338,   176,   455,   713,   153,   229,   504,   245,   230,
     340,   180,   610,   264,   272,   242,   125,   341,   417,   357,
     176,   403,   121,   410,   320,   401,   260,   167,  -239,   766,
     754,   482,   244,  -241,   246,   320,   317,   770,   137,   771,
     248,   486,   296,   297,   603,   153,   127,   317,   741,   430,
     431,   782,   397,   656,   129,   601,   125,   128,   618,   604,
     126,   403,   752,   753,   479,   401,   253,   167,  -324,   546,
    -377,   780,   190,   163,   155,  -378,   191,   192,   176,   176,
     705,   263,   263,   263,   277,   263,   127,   671,    22,   514,
     -87,   526,   397,   310,   129,   249,   568,   128,   346,   250,
     192,   323,   324,   715,   668,   668,   805,   490,   251,   243,
     -83,   424,   535,   163,   787,   -54,   676,   322,   307,    78,
     605,   606,   465,   855,   664,   664,   -84,   765,   109,   110,
     261,    87,  -379,   262,   461,   323,   121,   522,   359,   532,
     619,   654,   655,    43,   783,    43,   363,   855,   242,  -387,
     784,   323,    45,   361,    45,   568,    28,   293,    29,  -388,
     573,   294,   192,   323,   323,   520,   556,   530,  -389,   338,
     834,    31,   322,   533,   126,   559,   121,   624,   536,   263,
     385,   571,   365,   322,   587,   594,   368,   763,   668,   432,
     746,   747,   263,   263,   260,   568,   505,   870,   433,   568,
     748,   749,   516,   585,   592,   355,   845,   780,   664,   382,
     519,    22,   519,   517,   126,   528,   386,    41,   356,   573,
     370,   760,   539,   387,   542,   556,   860,   653,   389,   521,
     415,   531,   556,    96,   559,   766,   438,   556,   443,   649,
     571,   559,   444,   153,   668,   759,   559,   707,   708,   457,
     666,   479,   755,   756,   631,   666,   449,   577,   263,   573,
     454,   263,   103,   573,   664,   556,   667,   323,   382,   556,
     663,   667,   456,   883,   559,   663,   314,   475,   559,   315,
     571,   484,   274,   153,   571,   254,   255,   153,   750,   751,
     733,    86,   483,   646,    33,   485,   109,   110,   261,   487,
     739,   262,   263,   263,   357,   846,    36,   109,   110,   402,
     402,   499,   382,   291,   292,   629,   502,   599,    78,   339,
     302,    22,   382,   508,   744,   420,   320,   372,   761,   763,
      87,   431,   878,    33,   450,   545,   450,   568,   317,   575,
     433,   596,   733,   745,   721,    36,   109,   110,   774,   804,
     597,   775,   611,   170,   737,   690,   622,   325,   170,   692,
     556,   612,   625,   720,   327,   767,   760,   669,   672,   559,
     584,   591,   350,   112,   252,   736,   661,   693,    43,   837,
     838,   661,   694,   803,   109,   110,   275,    45,   303,   276,
     137,   137,   304,   192,   709,   725,   738,   153,   153,   466,
     598,   573,   213,   733,   768,   733,   737,   556,   125,   125,
     760,   848,   556,   403,   403,   789,   559,   401,   401,   167,
     167,   559,   571,   433,   777,   772,  -585,   736,   817,   807,
     153,   821,   430,   831,   170,   645,   263,   263,   127,   127,
     833,   827,   828,   836,   397,   397,   129,   129,   852,   128,
     128,   843,   867,   773,   869,   467,    72,   653,   382,   722,
     723,   871,   758,   797,   475,   163,   163,   737,   876,   737,
     806,   880,   724,   556,   322,   556,   556,   556,   817,   885,
     568,   847,   559,   859,   559,   559,   559,   886,   736,   853,
     736,   153,   820,   153,   135,   308,   569,   844,   556,   776,
     259,   295,   305,   529,   732,   791,   874,   559,   375,   212,
     667,   667,    33,   214,   663,   663,   835,   761,   413,   215,
     357,   217,   792,   646,    36,   109,   110,   757,   121,   121,
     719,   626,   190,   218,   884,   849,   380,   192,   662,   826,
     872,   873,   820,   670,   573,   733,   875,    72,   556,   879,
     556,   799,   570,   678,   758,   569,   732,   559,   788,   559,
     556,   677,   264,   272,   382,   571,   126,   126,   793,   559,
     353,   689,   823,   824,   621,   691,    33,   866,     0,   868,
     135,     0,     0,   282,     0,   825,    72,     0,    36,   109,
     110,     0,   263,   263,   667,   569,     0,   577,   663,   569,
     733,   856,   857,   109,   110,   174,   345,   695,   175,   737,
     696,   570,     0,   258,   858,   556,   556,   732,     0,   732,
     661,   661,   439,   319,   559,   559,   440,   192,     0,   263,
     736,   263,     0,   176,   190,     0,   666,   357,   576,   192,
     832,    72,   816,   627,   382,   -55,   382,   628,   192,     0,
     667,   570,    72,    76,   663,   570,    79,    80,   311,    82,
      83,    84,    85,   469,   737,   645,   666,   666,     0,   666,
     556,   420,   421,     0,     0,   422,   190,   423,   319,   559,
     714,   192,   666,   666,   469,   736,   666,   666,     0,   319,
     734,   439,   816,   627,   400,   764,   192,   864,   192,   425,
     421,   412,    22,   422,   661,   423,     0,    76,   865,     0,
      79,    80,   311,    82,    83,    84,    85,     0,   769,     0,
       0,   505,   506,    22,   679,   422,     0,   423,     0,     0,
     263,   263,     0,     0,   400,     0,   471,   569,     0,   881,
      72,   882,   734,     0,    22,     0,   735,   703,   506,     0,
       0,   422,   887,   423,     0,   470,     0,   471,     0,   732,
     661,     0,   316,     0,     0,   109,   110,   472,     0,     0,
     473,   263,   263,     0,    72,     0,   263,    72,     0,   794,
       0,   795,   680,   681,   682,     0,   109,   110,   472,     0,
       0,   473,     0,   570,    33,     0,     0,   382,   735,     0,
       0,     0,   474,   734,   226,   734,    36,    37,   742,    39,
       0,    72,    40,    72,   732,    72,   316,     0,   743,     0,
       0,     0,   683,   684,   274,    78,   382,    72,   818,     0,
     685,   686,     0,    86,     0,   263,   263,    87,     0,    72,
      72,     0,     0,    33,     0,   369,   228,     0,   319,     7,
     382,   263,   263,     0,     0,    36,   109,   110,   382,   735,
     382,   735,     0,     0,   319,     0,   231,   109,   110,   168,
       0,     0,   169,    88,    10,    11,     0,    12,   818,     0,
     569,     0,    13,    14,   819,    15,    16,     0,     0,     0,
      19,    20,    21,    22,   109,   110,   174,    25,   312,   175,
       0,     0,    92,     0,     0,    28,   313,    29,    94,     0,
      95,   579,    30,     0,   109,   110,   178,     0,    97,   179,
      31,   105,   106,     0,   626,     0,    98,    72,    99,   581,
     112,  -468,  -468,  -468,   819,  -468,   570,   225,     0,   100,
     101,     0,     0,    72,   103,   734,     0,     0,     0,    34,
      35,   105,   106,   107,   769,   689,     0,   691,   314,     0,
     112,   315,     0,   494,   495,   496,    41,   497,     0,     0,
     794,   795,     0,     0,   662,   670,     0,    33,     0,   227,
     319,     0,     0,     0,     0,     0,     0,     0,     0,    36,
     109,   110,   229,     0,     0,   230,     0,     0,     0,     0,
     734,   735,   656,   657,   658,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   -51,    75,     0,
       0,     7,     0,     0,     0,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,     0,     0,     0,    87,
       0,     0,   861,     8,     9,    88,    10,    11,   212,    89,
     862,     0,     0,     0,    13,    14,   735,    15,    16,   -64,
      90,    18,    19,    20,    21,    22,    23,    24,     0,    25,
      91,    26,     0,     0,    92,    27,     0,    28,    93,    29,
      94,     0,    95,    96,    30,     0,   400,   400,     0,     0,
      97,     0,    31,   783,     0,     0,     0,     0,    98,   784,
      99,     0,     0,     0,     0,     0,   863,     0,     0,     0,
       0,   100,   101,     0,   102,    33,   103,     0,     0,   785,
       0,   104,    35,   105,   106,   107,     0,   108,   109,   110,
     111,     0,   112,   113,   114,     0,   376,     0,    41,     7,
       0,     0,     0,    76,   274,     0,    79,    80,   311,    82,
      83,    84,    85,    86,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    88,    10,    11,     0,    12,     0,   225,
     226,     0,    13,    14,     0,    15,    16,     0,     0,     0,
      19,    20,    21,    22,     0,     0,     0,    25,   312,     0,
       0,     0,    92,     0,     0,    28,   313,    29,    94,     0,
      95,     0,    30,     0,     0,     0,     0,     0,    97,    33,
      31,   227,   228,     0,     0,     0,    98,     0,    99,     0,
       0,    36,   109,   110,   229,     0,     0,   230,     0,   100,
     101,     0,   231,    33,   103,   225,   226,     0,     0,    34,
      35,   105,   106,   107,     0,    36,   109,   110,   314,     0,
     112,   315,   316,     0,   -56,   376,    41,   388,     7,     0,
       0,     0,    76,   274,     0,    79,    80,   311,    82,    83,
      84,    85,    86,     0,     0,    33,     0,   352,   228,     0,
       0,     0,    88,    10,    11,     0,    12,    36,   109,   110,
     229,    13,    14,   230,    15,    16,     0,     0,   231,    19,
      20,    21,    22,     0,     0,     0,    25,   312,     0,     0,
       0,    92,     0,     0,    28,   313,    29,    94,     0,    95,
       0,    30,     0,     0,     0,     0,     0,    97,     0,    31,
       0,     0,     0,     0,     0,    98,     0,    99,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   100,   101,
       0,   206,    33,   103,  -166,     0,     0,     0,    34,    35,
     105,   106,   107,     0,    36,   109,   110,   314,     0,   112,
     315,   316,     0,     0,     0,    41,     0,     0,  -166,  -166,
    -166,     0,  -166,     0,     0,     0,     0,  -166,  -166,     0,
    -166,  -166,     0,     0,     0,  -166,  -166,  -166,    22,     0,
       0,     0,  -166,  -166,     0,     0,     0,  -166,     0,     0,
    -166,  -166,  -166,  -166,     0,  -166,     0,  -166,     0,     0,
       0,     0,     0,  -166,     0,  -166,     0,     0,     0,     0,
       0,  -166,     0,  -166,     0,     0,     0,     0,    -2,     6,
       0,     0,     7,     0,  -166,  -166,     0,     0,    33,     0,
       0,     0,     0,     0,  -166,  -166,     0,     0,  -166,     0,
      36,    37,   207,    39,     8,     9,    40,    10,    11,     0,
      12,  -166,   208,     0,     0,    13,    14,     0,    15,    16,
     -64,    17,    18,    19,    20,    21,    22,    23,    24,     0,
      25,     0,    26,     0,     0,     0,    27,     0,    28,     0,
      29,     0,     0,     0,     0,    30,     0,     0,     0,     0,
       0,     0,     0,    31,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   274,    78,     0,     0,     0,   511,
      32,     0,     7,    86,     0,     0,    33,    87,     0,     0,
       0,     0,    34,    35,     0,     0,     0,     0,    36,    37,
      38,    39,     0,     0,    40,     9,     0,    10,    11,    41,
      12,     0,     0,    22,     0,    13,    14,     0,    15,    16,
    -128,     0,    18,    19,    20,    21,    22,    23,    24,     0,
      25,     0,    26,     0,     0,     0,    27,     0,    28,     0,
      29,     0,     0,     0,     0,    30,     0,     0,     0,     0,
       0,    76,     0,    31,    79,    80,    81,   329,   330,     0,
       0,   579,   331,     0,   103,   523,     0,     0,     7,     0,
       0,   105,   106,     0,   580,     0,    33,     0,   314,   581,
     112,   315,    34,    35,     0,     0,     0,     0,    36,    37,
     512,    22,     0,    10,    11,     0,    12,     0,     0,    41,
     513,    13,    14,     0,    15,    16,  -141,     0,    18,    19,
      20,    21,    22,    23,    24,     0,    25,   332,    26,     0,
       0,     0,    27,     0,    28,     0,    29,     0,     0,     0,
       0,    30,     0,     0,     0,     0,     0,     0,     0,    31,
       0,    33,     0,     0,     0,     0,     0,   104,     0,     0,
       0,     0,     0,   108,   109,   110,   333,     0,     0,   334,
     335,   336,    33,   337,     0,     0,     0,     0,    34,    35,
       0,     0,     0,     0,    36,    37,   524,     0,     0,     0,
     376,     0,     0,     7,     0,    41,   525,    76,   274,     0,
      79,    80,   311,    82,    83,    84,    85,    86,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    88,    10,    11,
       0,    12,     0,     0,     0,     0,    13,    14,     0,    15,
      16,     0,     0,     0,    19,    20,    21,    22,     0,     0,
       0,    25,   312,     0,     0,     0,    92,     0,     0,    28,
     313,    29,    94,     0,    95,     0,    30,     0,     0,     0,
       0,     0,    97,     0,    31,   377,     0,     0,     0,     0,
      98,     0,    99,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   100,   101,     0,     0,    33,   103,     0,
       0,     0,     0,    34,    35,   105,   106,   107,     0,    36,
     109,   110,   314,     0,   112,   315,   316,     7,     0,     0,
      41,    76,   808,   809,    79,    80,   311,    82,    83,    84,
      85,   810,     0,     0,     0,   811,     0,     0,     0,     8,
       9,    88,    10,    11,     0,    89,     0,     0,     0,     0,
      13,    14,  -297,    15,    16,   -64,     0,    18,    19,    20,
      21,    22,    23,    24,     0,    25,   312,    26,     0,     0,
      92,    27,     0,    28,   313,    29,    94,     0,    95,    96,
      30,     0,     0,     0,     0,     0,    97,     0,    31,     0,
       0,     0,     0,     0,    98,     0,    99,     0,     0,     0,
     546,     0,     0,     0,     0,     0,     0,   100,   101,     0,
     549,    33,     0,     0,     0,     0,     0,    34,    35,   105,
     106,   107,   550,    36,   812,   552,   813,     0,   112,   814,
     815,     7,     0,     0,    41,    76,   726,    78,    79,    80,
      81,    82,    83,    84,    85,   727,     0,     0,     0,    87,
       0,     0,     0,     8,     9,    88,    10,    11,     0,    89,
    -289,     0,     0,     0,    13,    14,  -293,    15,    16,     0,
       0,    18,    19,    20,    21,    22,    23,    24,     0,    25,
      91,    26,     0,     0,    92,    27,     0,    28,    93,    29,
      94,     0,    95,    96,    30,     0,     0,     0,     0,     0,
      97,     0,    31,     0,     0,     0,     0,     0,    98,     0,
      99,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   100,   101,     0,   549,    33,     0,     0,     0,     0,
       0,   104,    35,   105,   106,   107,   550,   108,   728,   552,
     729,     0,   112,   730,   731,     7,     0,     0,    41,    76,
     808,   809,    79,    80,   311,    82,    83,    84,    85,   810,
       0,     0,     0,   811,     0,     0,     0,     8,     9,    88,
      10,    11,     0,    89,     0,     0,     0,     0,    13,    14,
       0,    15,    16,   -64,     0,    18,    19,    20,    21,    22,
      23,    24,     0,    25,   312,    26,     0,     0,    92,    27,
       0,    28,   313,    29,    94,     0,    95,    96,    30,     0,
       0,     0,     0,     0,    97,     0,    31,     0,     0,     0,
       0,     0,    98,     0,    99,     0,     0,     0,   546,     0,
       0,     0,     0,     0,     0,   100,   101,     0,   549,    33,
       0,     0,     0,     0,     0,    34,    35,   105,   106,   107,
     550,    36,   812,   552,   813,     0,   112,   814,   815,     7,
       0,     0,    41,    76,   726,    78,    79,    80,   311,    82,
      83,    84,    85,   727,     0,     0,     0,    87,     0,     0,
       0,     8,     9,    88,    10,    11,     0,    89,  -289,     0,
       0,     0,    13,    14,  -293,    15,    16,     0,     0,    18,
      19,    20,    21,    22,    23,    24,     0,    25,   312,    26,
       0,     0,    92,    27,     0,    28,   313,    29,    94,     0,
      95,    96,    30,     0,     0,     0,     0,     0,    97,     0,
      31,     0,     0,     0,     0,     0,    98,     0,    99,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   100,
     101,     0,   549,    33,     0,     0,     0,     0,     0,    34,
      35,   105,   106,   107,   550,    36,   728,   552,   729,     0,
     112,   730,   731,     7,     0,     0,    41,    76,   547,    78,
      79,    80,    81,    82,    83,    84,    85,   548,     0,     0,
       0,    87,     0,     0,     0,     8,     9,    88,    10,    11,
       0,    89,     0,     0,     0,     0,    13,    14,  -291,    15,
      16,     0,     0,    18,    19,    20,    21,    22,    23,    24,
       0,    25,    91,    26,     0,     0,    92,    27,     0,    28,
      93,    29,    94,     0,    95,    96,    30,     0,     0,     0,
       0,     0,    97,     0,    31,     0,     0,     0,     0,     0,
      98,     0,    99,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   100,   101,     0,   549,    33,     0,     0,
       0,     0,     0,   104,    35,   105,   106,   107,   550,   108,
     551,   552,   553,     0,   112,   554,   555,     7,     0,     0,
      41,    76,   726,    78,    79,    80,   311,    82,    83,    84,
      85,   727,     0,     0,     0,    87,     0,     0,     0,     8,
       9,    88,    10,    11,     0,    89,  -289,     0,     0,     0,
      13,    14,     0,    15,    16,     0,     0,    18,    19,    20,
      21,    22,    23,    24,     0,    25,   312,    26,     0,     0,
      92,    27,     0,    28,   313,    29,    94,     0,    95,    96,
      30,     0,     0,     0,     0,     0,    97,     0,    31,     0,
       0,     0,     0,     0,    98,     0,    99,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   100,   101,     0,
     549,    33,     0,     0,     0,     0,     0,    34,    35,   105,
     106,   107,   550,    36,   728,   552,   729,     0,   112,   730,
     731,     7,     0,     0,    41,    76,   547,    78,    79,    80,
     311,    82,    83,    84,    85,   548,     0,     0,     0,    87,
       0,     0,     0,     8,     9,    88,    10,    11,     0,    89,
       0,     0,     0,     0,    13,    14,  -295,    15,    16,     0,
       0,    18,    19,    20,    21,    22,    23,    24,     0,    25,
     312,    26,     0,     0,    92,    27,     0,    28,   313,    29,
      94,     0,    95,    96,    30,     0,     0,     0,     0,     0,
      97,     0,    31,     0,     0,     0,     0,     0,    98,     0,
      99,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   100,   101,     0,   549,    33,     0,     0,     0,     0,
       0,    34,    35,   105,   106,   107,   550,    36,   551,   552,
     553,     0,   112,   554,   555,     7,     0,     0,    41,    76,
     547,    78,    79,    80,   311,    82,    83,    84,    85,   548,
       0,     0,     0,    87,     0,     0,     0,     8,     9,    88,
      10,    11,     0,    89,     0,     0,     0,     0,    13,    14,
    -291,    15,    16,     0,     0,    18,    19,    20,    21,    22,
      23,    24,     0,    25,   312,    26,     0,     0,    92,    27,
       0,    28,   313,    29,    94,     0,    95,    96,    30,     0,
       0,     0,     0,     0,    97,     0,    31,     0,     0,     0,
       0,     0,    98,     0,    99,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   100,   101,     0,   549,    33,
       0,     0,     0,     0,     0,    34,    35,   105,   106,   107,
     550,    36,   551,   552,   553,     0,   112,   554,   555,     7,
       0,     0,    41,    76,   726,    78,    79,    80,   311,    82,
      83,    84,    85,   727,     0,     0,     0,    87,     0,     0,
       0,     8,     9,    88,    10,    11,     0,    89,     0,     0,
       0,     0,    13,    14,  -293,    15,    16,     0,     0,    18,
      19,    20,    21,    22,    23,    24,     0,    25,   312,    26,
       0,     0,    92,    27,     0,    28,   313,    29,    94,     0,
      95,    96,    30,     0,     0,     0,     0,     0,    97,     0,
      31,     0,     0,     0,     0,     0,    98,     0,    99,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   100,
     101,     0,   549,    33,     0,     0,     0,     0,     0,    34,
      35,   105,   106,   107,   550,    36,   728,   552,   729,     0,
     112,   730,   731,     7,     0,     0,    41,    76,   547,    78,
      79,    80,   311,    82,    83,    84,    85,   548,     0,     0,
       0,    87,     0,     0,     0,     8,     9,    88,    10,    11,
       0,    89,     0,     0,     0,     0,    13,    14,     0,    15,
      16,     0,     0,    18,    19,    20,    21,    22,    23,    24,
       0,    25,   312,    26,     0,     0,    92,    27,     0,    28,
     313,    29,    94,     0,    95,    96,    30,     0,     0,     0,
       0,     0,    97,     0,    31,     0,     0,     0,     0,     0,
      98,     0,    99,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   100,   101,     0,   549,    33,     0,     0,
       0,     0,     0,    34,    35,   105,   106,   107,   550,    36,
     551,   552,   553,     0,   112,   554,   555,     7,     0,     0,
      41,    76,   393,    78,    79,    80,    81,    82,    83,    84,
      85,     0,     0,     0,     0,    87,     0,     0,     0,     8,
       9,    88,    10,    11,     0,    89,     0,     0,     0,     0,
      13,    14,     0,    15,    16,     0,     0,    18,    19,    20,
      21,    22,    23,    24,     0,    25,    91,    26,     0,     0,
      92,    27,     0,    28,    93,    29,    94,     0,    95,    96,
      30,     0,     0,     0,     0,     0,    97,     0,    31,     0,
       0,     0,     0,     0,    98,     0,    99,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   100,   101,     0,
     102,    33,     0,     0,     0,     0,     0,   104,    35,   105,
     106,   107,     0,   108,   109,   110,   394,     7,   112,   395,
     396,     0,   393,    78,    41,     0,   656,   657,   658,     0,
       0,     0,     0,     0,     0,    87,     0,     0,     0,     8,
       9,    88,    10,    11,     0,    89,     0,     0,     0,     0,
      13,    14,  -102,    15,    16,     0,     0,    18,    19,    20,
      21,    22,    23,    24,     0,    25,    91,    26,     0,     0,
      92,    27,     0,    28,    93,    29,    94,     0,    95,    96,
      30,     0,     0,     0,     0,     0,    97,     0,    31,     0,
       0,     0,     0,     0,    98,     0,    99,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   100,   101,     0,
     549,    33,     0,     0,     0,     0,     0,   104,    35,   105,
     106,   107,   550,   108,   659,   552,   394,     7,   112,   395,
     660,     0,   393,    78,    41,     0,   656,   657,   658,     0,
       0,     0,     0,     0,     0,    87,     0,     0,     0,     8,
       9,    88,    10,    11,     0,    89,     0,     0,     0,     0,
      13,    14,  -103,    15,    16,     0,     0,    18,    19,    20,
      21,    22,    23,    24,     0,    25,    91,    26,     0,     0,
      92,    27,     0,    28,    93,    29,    94,     0,    95,    96,
      30,     0,     0,     0,     0,     0,    97,     0,    31,     0,
       0,     0,     0,     0,    98,     0,    99,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   100,   101,     0,
     549,    33,     0,     0,     0,     0,     0,   104,    35,   105,
     106,   107,   550,   108,   659,   552,   394,     7,   112,   395,
     660,     0,   393,    78,    41,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    87,     0,     0,     0,     8,
       9,    88,    10,    11,     0,    89,     0,     0,     0,     0,
      13,    14,     0,    15,    16,     0,     0,    18,    19,    20,
      21,    22,    23,    24,     0,    25,   312,    26,     0,     0,
      92,    27,     0,    28,   313,    29,    94,     0,    95,    96,
      30,     0,     0,     0,     0,     0,    97,     0,    31,     0,
       0,     0,     0,     0,    98,     0,    99,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   100,   101,     0,
     549,    33,     0,     0,     0,     0,     0,    34,    35,   105,
     106,   107,   550,    36,   659,   552,   394,     0,   112,   395,
     796,     7,     0,     0,    41,    76,   274,     0,    79,    80,
     311,    82,    83,    84,    85,    86,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    88,    10,    11,     0,    12,
       0,   225,   226,     0,    13,    14,     0,    15,    16,     0,
       0,     0,    19,    20,    21,    22,     0,     0,     0,    25,
     312,     0,     0,     0,    92,     0,     0,    28,   313,    29,
      94,     0,    95,     0,    30,     0,     0,     0,     0,     0,
      97,    33,    31,   509,   228,     0,     0,     0,    98,     0,
      99,     0,     0,    36,   109,   110,   229,     0,     0,   230,
       0,   100,   101,     0,   231,    33,   103,     7,     0,     0,
       0,    34,    35,   105,   106,   107,     0,    36,   109,   110,
     314,     0,   112,   315,   316,     0,     0,     0,    41,     0,
       0,    88,    10,    11,     0,    12,     0,     0,     0,     0,
      13,    14,     0,    15,    16,  -152,     0,    18,    19,    20,
      21,    22,     0,    24,     0,    25,   312,    26,     0,     0,
      92,     0,     0,    28,   313,    29,    94,     0,    95,     0,
      30,     0,     0,     0,     0,     0,    97,     0,    31,     0,
       0,     0,     0,     0,    98,     0,    99,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   100,   101,     0,
       0,    33,   103,     7,     0,     0,     0,    34,    35,   105,
     106,   107,     0,    36,   109,   110,   314,     0,   112,   315,
       0,     0,     0,     0,    41,     0,     0,    88,    10,    11,
       0,    89,     0,     0,     0,     0,    13,    14,     0,    15,
      16,     0,     7,     0,    19,    20,    21,     0,     0,     0,
       0,    25,   312,     0,     0,     0,    92,     0,     0,    28,
     313,    29,    94,     0,    95,     0,    30,    10,    11,     0,
      12,     0,    97,     0,    31,    13,    14,     0,    15,    16,
      98,     0,    99,    19,    20,    21,     0,     0,     0,     0,
      25,     0,     0,   100,   101,     0,     0,     0,    28,     0,
      29,    94,     0,    34,    35,    30,     0,   107,     0,   274,
      78,    97,     0,    31,     0,     0,     0,     0,    86,    98,
      41,    99,    87,     0,     7,     0,     0,     0,     0,     0,
       0,    76,   100,   101,    79,    80,   311,    82,    83,    84,
      85,     0,    34,    35,   105,   106,   107,     0,    22,    10,
      11,     0,    12,   112,     0,     0,     0,    13,    14,    41,
      15,    16,     0,     0,     0,    19,    20,    21,     0,     0,
      76,     0,    25,    79,    80,   311,   329,   330,     0,     0,
      28,   331,    29,     0,     0,     0,     0,    30,     0,     0,
       0,     0,     0,     0,     0,    31,   579,   458,     0,   103,
       0,     0,     0,     0,     0,     0,   105,   106,     0,   588,
      22,     0,     0,   314,   581,   112,   315,     0,   459,     0,
       0,    33,     0,     0,    34,    35,     0,    34,   460,   105,
     106,     0,     0,    36,   109,   110,   332,     0,   112,     0,
     316,    41,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   632,   633,     0,
      33,     0,     0,     0,   634,     0,    34,   635,   636,   637,
       0,     0,    36,   109,   110,   333,     0,     0,   334,   335,
     336,     0,   337,     0,   638,     0,   639,     0,   640,     0,
     641,     0,     0,   632,   633,     0,     0,   642,   643,    96,
     634,     0,     0,   635,   636,   637,     0,     0,   225,   226,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     638,     0,   639,     0,   640,     0,   641,     0,     0,     0,
       0,    33,     0,   642,   643,     0,     0,     0,     0,     0,
       0,     0,     0,    36,   109,   110,   174,     0,    33,   175,
     227,   228,     0,     0,     0,   644,     0,     0,     0,     0,
      36,   109,   110,   229,     0,     0,   230,    33,     0,     0,
       0,   231,   617,     0,     0,     0,     0,     0,     0,    36,
     109,   110,   174,     0,     0,   175,     0,     0,     0,     0,
       0,   790
};

static const yytype_int16 yycheck[] =
{
       3,     4,    95,   312,    72,    56,     3,    92,   183,    28,
      29,   106,    91,   171,    93,     3,    95,   112,     4,    81,
     151,   203,     4,    21,    56,     4,   153,    86,     3,   241,
       3,   241,    30,   183,    69,   158,     4,   220,   161,    94,
     241,     4,   104,   420,   421,   422,   108,     4,   425,   227,
      41,    21,   387,    36,   414,   387,    72,     9,   244,    56,
       4,   545,   153,   439,    91,     3,     4,   454,    56,   153,
       1,   396,     4,     3,     4,     9,     3,     4,   358,     1,
     449,   545,     1,    56,     4,   454,   268,    90,   725,     4,
      88,    94,     3,     4,   374,    72,     9,    10,    81,   124,
     449,   126,   505,   506,    90,   454,   509,    21,    90,    22,
     189,    90,     0,   123,     9,   183,    21,    22,   128,   109,
      21,   324,    90,    18,   114,   108,    71,    90,   505,   506,
     133,   768,   114,    90,    68,    69,    70,   204,    72,    85,
     121,   625,   354,    89,   354,    97,    90,   121,   164,    21,
     153,   120,    90,   354,    21,     3,     4,   121,    90,    93,
      90,   625,   372,    90,    96,    21,   289,   121,   291,    21,
      90,   372,    21,   118,   352,    90,   536,   244,    85,    90,
      42,   364,    89,   386,   387,   188,   271,   164,   223,   133,
       7,   122,   375,     3,     4,   286,   199,   372,   515,   322,
     122,   133,   325,   122,   117,   121,   120,   249,     4,   123,
     527,   546,    85,   133,   546,   120,    89,     7,   204,   120,
     313,   153,    12,   278,   541,   204,   113,   350,     9,   116,
     321,    21,   415,   312,   313,   212,   204,   321,   224,   171,
      30,   204,    90,   211,   188,   204,     9,   204,   120,   625,
     610,   293,   123,   120,    22,   199,   188,   639,   244,   641,
      22,   303,    20,    21,   120,   244,   204,   199,   120,   102,
     103,   120,   204,    13,   204,   600,   244,   204,   428,   402,
      90,   244,   607,   608,   287,   244,     9,   244,    86,    87,
       0,   660,    85,   204,    90,     0,    89,    90,    88,    89,
     703,    91,    92,    93,    94,    95,   244,   694,    48,   360,
       0,   362,   244,    39,   244,    85,   383,   244,   321,    89,
      90,   324,    86,   807,   693,   694,   703,   318,   311,   345,
       0,   509,   367,   244,   669,     0,   459,   133,     9,    10,
     117,   118,   286,   807,   693,   694,     0,   831,   111,   112,
     113,    22,     0,   116,   286,   358,   204,   360,    92,   362,
     428,   446,   447,   360,   104,   362,   123,   831,   345,   123,
     110,   374,   360,    92,   362,   442,    60,    85,    62,   123,
     383,    89,    90,   386,   387,   360,   383,   362,   123,   321,
     777,    75,   188,   363,   204,   383,   244,   439,   368,   189,
      85,   383,   105,   199,   386,   387,   123,   619,   777,   619,
     596,   597,   202,   203,     9,   482,    84,    85,   619,   486,
     602,   603,   360,   386,   387,     9,    21,   796,   777,   190,
     360,    48,   362,   360,   244,   362,    87,   121,    22,   442,
     615,   616,   374,    87,   374,   442,   833,   445,   121,   360,
       7,   362,   449,    66,   442,   831,   120,   454,    85,   445,
     442,   449,   123,   442,   833,   615,   454,   870,   871,   121,
     449,   474,   611,   612,   444,   454,   123,   385,   268,   482,
     123,   271,    99,   486,   833,   482,   449,   490,   249,   486,
     449,   454,   123,   870,   482,   454,   113,   287,   486,   116,
     482,    20,     9,   482,   486,    82,    83,   486,   605,   606,
     577,    18,    85,   445,    98,    21,   111,   112,   113,    85,
     579,   116,   312,   313,   456,   120,   110,   111,   112,   596,
     597,    19,   293,   100,   101,   443,   124,     9,    10,   666,
     107,    48,   303,    39,   595,    84,   490,   615,   616,   761,
      22,   103,   861,    98,   639,    85,   641,   624,   490,    86,
     761,   123,   629,   595,   546,   110,   111,   112,   113,   700,
     123,   116,   121,   363,   577,   483,    86,   144,   368,   487,
     577,   121,    85,   546,   151,   627,   761,    86,   123,   577,
     386,   387,   159,   115,   656,   577,   449,   123,   595,   781,
     782,   454,   123,   698,   111,   112,   113,   595,    85,   116,
     596,   597,    89,    90,     5,    85,    33,   596,   597,   286,
      22,   624,   595,   690,    85,   692,   629,   624,   596,   597,
     805,   789,   629,   596,   597,   117,   624,   596,   597,   596,
     597,   629,   624,   844,   123,   643,    39,   629,   715,    85,
     629,    33,   102,    85,   444,   445,   446,   447,   596,   597,
     123,   740,   741,    85,   596,   597,   596,   597,   120,   596,
     597,   100,    85,   648,    85,   286,     3,   675,   439,     9,
      10,   100,   614,     9,   474,   596,   597,   690,    56,   692,
     709,    85,    22,   690,   490,   692,   693,   694,   765,   123,
     767,   786,   690,   826,   692,   693,   694,   123,   690,   804,
     692,   690,   715,   692,     4,   114,   383,   785,   715,   651,
      90,   783,   784,   362,   577,   675,   849,   715,   187,    56,
     693,   694,    98,    61,   693,   694,   778,   805,   216,    61,
     672,    61,   675,   675,   110,   111,   112,   113,   596,   597,
     546,   442,    85,    61,   877,   793,    89,    90,   449,   739,
     845,   846,   765,   454,   767,   832,   852,    94,   765,   862,
     767,   697,   383,   474,   706,   442,   629,   765,   672,   767,
     777,   468,   861,   862,   545,   767,   596,   597,   677,   777,
     164,   482,     9,    10,   428,   486,    98,   839,    -1,   841,
      90,    -1,    -1,   105,    -1,    22,   133,    -1,   110,   111,
     112,    -1,   602,   603,   777,   482,    -1,   725,   777,   486,
     887,     9,    10,   111,   112,   113,   153,   494,   116,   832,
     497,   442,    -1,   121,    22,   832,   833,   690,    -1,   692,
     693,   694,    85,   133,   832,   833,    89,    90,    -1,   639,
     832,   641,    -1,   643,    85,    -1,   835,   789,    89,    90,
     768,   188,   715,    85,   625,     0,   627,    89,    90,    -1,
     833,   482,   199,     8,   833,   486,    11,    12,    13,    14,
      15,    16,    17,     9,   887,   675,   865,   866,    -1,   868,
     887,    84,    85,    -1,    -1,    88,    85,    90,   188,   887,
      89,    90,   881,   882,     9,   887,   885,   886,    -1,   199,
     577,    85,   765,    85,   204,    89,    90,    89,    90,    84,
      85,   211,    48,    88,   777,    90,    -1,     8,   836,    -1,
      11,    12,    13,    14,    15,    16,    17,    -1,   629,    -1,
      -1,    84,    85,    48,    19,    88,    -1,    90,    -1,    -1,
     740,   741,    -1,    -1,   244,    -1,    82,   624,    -1,   867,
     287,   869,   629,    -1,    48,    -1,   577,    84,    85,    -1,
      -1,    88,   880,    90,    -1,    80,    -1,    82,    -1,   832,
     833,    -1,   117,    -1,    -1,   111,   112,   113,    -1,    -1,
     116,   781,   782,    -1,   321,    -1,   786,   324,    -1,   690,
      -1,   692,    77,    78,    79,    -1,   111,   112,   113,    -1,
      -1,   116,    -1,   624,    98,    -1,    -1,   778,   629,    -1,
      -1,    -1,   127,   690,    59,   692,   110,   111,   112,   113,
      -1,   358,   116,   360,   887,   362,   117,    -1,   122,    -1,
      -1,    -1,   117,   118,     9,    10,   807,   374,   715,    -1,
     125,   126,    -1,    18,    -1,   845,   846,    22,    -1,   386,
     387,    -1,    -1,    98,    -1,   100,   101,    -1,   358,     4,
     831,   861,   862,    -1,    -1,   110,   111,   112,   839,   690,
     841,   692,    -1,    -1,   374,    -1,   121,   111,   112,   113,
      -1,    -1,   116,    28,    29,    30,    -1,    32,   765,    -1,
     767,    -1,    37,    38,   715,    40,    41,    -1,    -1,    -1,
      45,    46,    47,    48,   111,   112,   113,    52,    53,   116,
      -1,    -1,    57,    -1,    -1,    60,    61,    62,    63,    -1,
      65,    96,    67,    -1,   111,   112,   113,    -1,    73,   116,
      75,   106,   107,    -1,   835,    -1,    81,   474,    83,   114,
     115,    68,    69,    70,   765,    72,   767,    58,    -1,    94,
      95,    -1,    -1,   490,    99,   832,    -1,    -1,    -1,   104,
     105,   106,   107,   108,   865,   866,    -1,   868,   113,    -1,
     115,   116,    -1,    68,    69,    70,   121,    72,    -1,    -1,
     881,   882,    -1,    -1,   885,   886,    -1,    98,    -1,   100,
     490,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,
     111,   112,   113,    -1,    -1,   116,    -1,    -1,    -1,    -1,
     887,   832,    13,    14,    15,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     0,     1,    -1,
      -1,     4,    -1,    -1,    -1,     8,     9,    10,    11,    12,
      13,    14,    15,    16,    17,    18,    -1,    -1,    -1,    22,
      -1,    -1,    53,    26,    27,    28,    29,    30,   595,    32,
      61,    -1,    -1,    -1,    37,    38,   887,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    -1,    52,
      53,    54,    -1,    -1,    57,    58,    -1,    60,    61,    62,
      63,    -1,    65,    66,    67,    -1,   596,   597,    -1,    -1,
      73,    -1,    75,   104,    -1,    -1,    -1,    -1,    81,   110,
      83,    -1,    -1,    -1,    -1,    -1,   117,    -1,    -1,    -1,
      -1,    94,    95,    -1,    97,    98,    99,    -1,    -1,   666,
      -1,   104,   105,   106,   107,   108,    -1,   110,   111,   112,
     113,    -1,   115,   116,   117,    -1,     1,    -1,   121,     4,
      -1,    -1,    -1,     8,     9,    -1,    11,    12,    13,    14,
      15,    16,    17,    18,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    28,    29,    30,    -1,    32,    -1,    58,
      59,    -1,    37,    38,    -1,    40,    41,    -1,    -1,    -1,
      45,    46,    47,    48,    -1,    -1,    -1,    52,    53,    -1,
      -1,    -1,    57,    -1,    -1,    60,    61,    62,    63,    -1,
      65,    -1,    67,    -1,    -1,    -1,    -1,    -1,    73,    98,
      75,   100,   101,    -1,    -1,    -1,    81,    -1,    83,    -1,
      -1,   110,   111,   112,   113,    -1,    -1,   116,    -1,    94,
      95,    -1,   121,    98,    99,    58,    59,    -1,    -1,   104,
     105,   106,   107,   108,    -1,   110,   111,   112,   113,    -1,
     115,   116,   117,    -1,     0,     1,   121,   122,     4,    -1,
      -1,    -1,     8,     9,    -1,    11,    12,    13,    14,    15,
      16,    17,    18,    -1,    -1,    98,    -1,   100,   101,    -1,
      -1,    -1,    28,    29,    30,    -1,    32,   110,   111,   112,
     113,    37,    38,   116,    40,    41,    -1,    -1,   121,    45,
      46,    47,    48,    -1,    -1,    -1,    52,    53,    -1,    -1,
      -1,    57,    -1,    -1,    60,    61,    62,    63,    -1,    65,
      -1,    67,    -1,    -1,    -1,    -1,    -1,    73,    -1,    75,
      -1,    -1,    -1,    -1,    -1,    81,    -1,    83,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,
      -1,     1,    98,    99,     4,    -1,    -1,    -1,   104,   105,
     106,   107,   108,    -1,   110,   111,   112,   113,    -1,   115,
     116,   117,    -1,    -1,    -1,   121,    -1,    -1,    28,    29,
      30,    -1,    32,    -1,    -1,    -1,    -1,    37,    38,    -1,
      40,    41,    -1,    -1,    -1,    45,    46,    47,    48,    -1,
      -1,    -1,    52,    53,    -1,    -1,    -1,    57,    -1,    -1,
      60,    61,    62,    63,    -1,    65,    -1,    67,    -1,    -1,
      -1,    -1,    -1,    73,    -1,    75,    -1,    -1,    -1,    -1,
      -1,    81,    -1,    83,    -1,    -1,    -1,    -1,     0,     1,
      -1,    -1,     4,    -1,    94,    95,    -1,    -1,    98,    -1,
      -1,    -1,    -1,    -1,   104,   105,    -1,    -1,   108,    -1,
     110,   111,   112,   113,    26,    27,   116,    29,    30,    -1,
      32,   121,   122,    -1,    -1,    37,    38,    -1,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    -1,
      52,    -1,    54,    -1,    -1,    -1,    58,    -1,    60,    -1,
      62,    -1,    -1,    -1,    -1,    67,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    75,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     9,    10,    -1,    -1,    -1,     1,
      92,    -1,     4,    18,    -1,    -1,    98,    22,    -1,    -1,
      -1,    -1,   104,   105,    -1,    -1,    -1,    -1,   110,   111,
     112,   113,    -1,    -1,   116,    27,    -1,    29,    30,   121,
      32,    -1,    -1,    48,    -1,    37,    38,    -1,    40,    41,
      42,    -1,    44,    45,    46,    47,    48,    49,    50,    -1,
      52,    -1,    54,    -1,    -1,    -1,    58,    -1,    60,    -1,
      62,    -1,    -1,    -1,    -1,    67,    -1,    -1,    -1,    -1,
      -1,     8,    -1,    75,    11,    12,    13,    14,    15,    -1,
      -1,    96,    19,    -1,    99,     1,    -1,    -1,     4,    -1,
      -1,   106,   107,    -1,   109,    -1,    98,    -1,   113,   114,
     115,   116,   104,   105,    -1,    -1,    -1,    -1,   110,   111,
     112,    48,    -1,    29,    30,    -1,    32,    -1,    -1,   121,
     122,    37,    38,    -1,    40,    41,    42,    -1,    44,    45,
      46,    47,    48,    49,    50,    -1,    52,    74,    54,    -1,
      -1,    -1,    58,    -1,    60,    -1,    62,    -1,    -1,    -1,
      -1,    67,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    75,
      -1,    98,    -1,    -1,    -1,    -1,    -1,   104,    -1,    -1,
      -1,    -1,    -1,   110,   111,   112,   113,    -1,    -1,   116,
     117,   118,    98,   120,    -1,    -1,    -1,    -1,   104,   105,
      -1,    -1,    -1,    -1,   110,   111,   112,    -1,    -1,    -1,
       1,    -1,    -1,     4,    -1,   121,   122,     8,     9,    -1,
      11,    12,    13,    14,    15,    16,    17,    18,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    28,    29,    30,
      -1,    32,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,
      41,    -1,    -1,    -1,    45,    46,    47,    48,    -1,    -1,
      -1,    52,    53,    -1,    -1,    -1,    57,    -1,    -1,    60,
      61,    62,    63,    -1,    65,    -1,    67,    -1,    -1,    -1,
      -1,    -1,    73,    -1,    75,    76,    -1,    -1,    -1,    -1,
      81,    -1,    83,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    -1,    -1,    98,    99,    -1,
      -1,    -1,    -1,   104,   105,   106,   107,   108,    -1,   110,
     111,   112,   113,    -1,   115,   116,   117,     4,    -1,    -1,
     121,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      17,    18,    -1,    -1,    -1,    22,    -1,    -1,    -1,    26,
      27,    28,    29,    30,    -1,    32,    -1,    -1,    -1,    -1,
      37,    38,    39,    40,    41,    42,    -1,    44,    45,    46,
      47,    48,    49,    50,    -1,    52,    53,    54,    -1,    -1,
      57,    58,    -1,    60,    61,    62,    63,    -1,    65,    66,
      67,    -1,    -1,    -1,    -1,    -1,    73,    -1,    75,    -1,
      -1,    -1,    -1,    -1,    81,    -1,    83,    -1,    -1,    -1,
      87,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    -1,
      97,    98,    -1,    -1,    -1,    -1,    -1,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,    -1,   115,   116,
     117,     4,    -1,    -1,   121,     8,     9,    10,    11,    12,
      13,    14,    15,    16,    17,    18,    -1,    -1,    -1,    22,
      -1,    -1,    -1,    26,    27,    28,    29,    30,    -1,    32,
      33,    -1,    -1,    -1,    37,    38,    39,    40,    41,    -1,
      -1,    44,    45,    46,    47,    48,    49,    50,    -1,    52,
      53,    54,    -1,    -1,    57,    58,    -1,    60,    61,    62,
      63,    -1,    65,    66,    67,    -1,    -1,    -1,    -1,    -1,
      73,    -1,    75,    -1,    -1,    -1,    -1,    -1,    81,    -1,
      83,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    -1,    97,    98,    -1,    -1,    -1,    -1,
      -1,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,    -1,   115,   116,   117,     4,    -1,    -1,   121,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      -1,    -1,    -1,    22,    -1,    -1,    -1,    26,    27,    28,
      29,    30,    -1,    32,    -1,    -1,    -1,    -1,    37,    38,
      -1,    40,    41,    42,    -1,    44,    45,    46,    47,    48,
      49,    50,    -1,    52,    53,    54,    -1,    -1,    57,    58,
      -1,    60,    61,    62,    63,    -1,    65,    66,    67,    -1,
      -1,    -1,    -1,    -1,    73,    -1,    75,    -1,    -1,    -1,
      -1,    -1,    81,    -1,    83,    -1,    -1,    -1,    87,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    -1,    97,    98,
      -1,    -1,    -1,    -1,    -1,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,    -1,   115,   116,   117,     4,
      -1,    -1,   121,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    -1,    -1,    -1,    22,    -1,    -1,
      -1,    26,    27,    28,    29,    30,    -1,    32,    33,    -1,
      -1,    -1,    37,    38,    39,    40,    41,    -1,    -1,    44,
      45,    46,    47,    48,    49,    50,    -1,    52,    53,    54,
      -1,    -1,    57,    58,    -1,    60,    61,    62,    63,    -1,
      65,    66,    67,    -1,    -1,    -1,    -1,    -1,    73,    -1,
      75,    -1,    -1,    -1,    -1,    -1,    81,    -1,    83,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    -1,    97,    98,    -1,    -1,    -1,    -1,    -1,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,    -1,
     115,   116,   117,     4,    -1,    -1,   121,     8,     9,    10,
      11,    12,    13,    14,    15,    16,    17,    18,    -1,    -1,
      -1,    22,    -1,    -1,    -1,    26,    27,    28,    29,    30,
      -1,    32,    -1,    -1,    -1,    -1,    37,    38,    39,    40,
      41,    -1,    -1,    44,    45,    46,    47,    48,    49,    50,
      -1,    52,    53,    54,    -1,    -1,    57,    58,    -1,    60,
      61,    62,    63,    -1,    65,    66,    67,    -1,    -1,    -1,
      -1,    -1,    73,    -1,    75,    -1,    -1,    -1,    -1,    -1,
      81,    -1,    83,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    -1,    97,    98,    -1,    -1,
      -1,    -1,    -1,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,    -1,   115,   116,   117,     4,    -1,    -1,
     121,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      17,    18,    -1,    -1,    -1,    22,    -1,    -1,    -1,    26,
      27,    28,    29,    30,    -1,    32,    33,    -1,    -1,    -1,
      37,    38,    -1,    40,    41,    -1,    -1,    44,    45,    46,
      47,    48,    49,    50,    -1,    52,    53,    54,    -1,    -1,
      57,    58,    -1,    60,    61,    62,    63,    -1,    65,    66,
      67,    -1,    -1,    -1,    -1,    -1,    73,    -1,    75,    -1,
      -1,    -1,    -1,    -1,    81,    -1,    83,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    -1,
      97,    98,    -1,    -1,    -1,    -1,    -1,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,    -1,   115,   116,
     117,     4,    -1,    -1,   121,     8,     9,    10,    11,    12,
      13,    14,    15,    16,    17,    18,    -1,    -1,    -1,    22,
      -1,    -1,    -1,    26,    27,    28,    29,    30,    -1,    32,
      -1,    -1,    -1,    -1,    37,    38,    39,    40,    41,    -1,
      -1,    44,    45,    46,    47,    48,    49,    50,    -1,    52,
      53,    54,    -1,    -1,    57,    58,    -1,    60,    61,    62,
      63,    -1,    65,    66,    67,    -1,    -1,    -1,    -1,    -1,
      73,    -1,    75,    -1,    -1,    -1,    -1,    -1,    81,    -1,
      83,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    95,    -1,    97,    98,    -1,    -1,    -1,    -1,
      -1,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,    -1,   115,   116,   117,     4,    -1,    -1,   121,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      -1,    -1,    -1,    22,    -1,    -1,    -1,    26,    27,    28,
      29,    30,    -1,    32,    -1,    -1,    -1,    -1,    37,    38,
      39,    40,    41,    -1,    -1,    44,    45,    46,    47,    48,
      49,    50,    -1,    52,    53,    54,    -1,    -1,    57,    58,
      -1,    60,    61,    62,    63,    -1,    65,    66,    67,    -1,
      -1,    -1,    -1,    -1,    73,    -1,    75,    -1,    -1,    -1,
      -1,    -1,    81,    -1,    83,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    94,    95,    -1,    97,    98,
      -1,    -1,    -1,    -1,    -1,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,    -1,   115,   116,   117,     4,
      -1,    -1,   121,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    -1,    -1,    -1,    22,    -1,    -1,
      -1,    26,    27,    28,    29,    30,    -1,    32,    -1,    -1,
      -1,    -1,    37,    38,    39,    40,    41,    -1,    -1,    44,
      45,    46,    47,    48,    49,    50,    -1,    52,    53,    54,
      -1,    -1,    57,    58,    -1,    60,    61,    62,    63,    -1,
      65,    66,    67,    -1,    -1,    -1,    -1,    -1,    73,    -1,
      75,    -1,    -1,    -1,    -1,    -1,    81,    -1,    83,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    -1,    97,    98,    -1,    -1,    -1,    -1,    -1,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,    -1,
     115,   116,   117,     4,    -1,    -1,   121,     8,     9,    10,
      11,    12,    13,    14,    15,    16,    17,    18,    -1,    -1,
      -1,    22,    -1,    -1,    -1,    26,    27,    28,    29,    30,
      -1,    32,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,
      41,    -1,    -1,    44,    45,    46,    47,    48,    49,    50,
      -1,    52,    53,    54,    -1,    -1,    57,    58,    -1,    60,
      61,    62,    63,    -1,    65,    66,    67,    -1,    -1,    -1,
      -1,    -1,    73,    -1,    75,    -1,    -1,    -1,    -1,    -1,
      81,    -1,    83,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    95,    -1,    97,    98,    -1,    -1,
      -1,    -1,    -1,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,    -1,   115,   116,   117,     4,    -1,    -1,
     121,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      17,    -1,    -1,    -1,    -1,    22,    -1,    -1,    -1,    26,
      27,    28,    29,    30,    -1,    32,    -1,    -1,    -1,    -1,
      37,    38,    -1,    40,    41,    -1,    -1,    44,    45,    46,
      47,    48,    49,    50,    -1,    52,    53,    54,    -1,    -1,
      57,    58,    -1,    60,    61,    62,    63,    -1,    65,    66,
      67,    -1,    -1,    -1,    -1,    -1,    73,    -1,    75,    -1,
      -1,    -1,    -1,    -1,    81,    -1,    83,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    -1,
      97,    98,    -1,    -1,    -1,    -1,    -1,   104,   105,   106,
     107,   108,    -1,   110,   111,   112,   113,     4,   115,   116,
     117,    -1,     9,    10,   121,    -1,    13,    14,    15,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    -1,    -1,    -1,    26,
      27,    28,    29,    30,    -1,    32,    -1,    -1,    -1,    -1,
      37,    38,    39,    40,    41,    -1,    -1,    44,    45,    46,
      47,    48,    49,    50,    -1,    52,    53,    54,    -1,    -1,
      57,    58,    -1,    60,    61,    62,    63,    -1,    65,    66,
      67,    -1,    -1,    -1,    -1,    -1,    73,    -1,    75,    -1,
      -1,    -1,    -1,    -1,    81,    -1,    83,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    -1,
      97,    98,    -1,    -1,    -1,    -1,    -1,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,     4,   115,   116,
     117,    -1,     9,    10,   121,    -1,    13,    14,    15,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    -1,    -1,    -1,    26,
      27,    28,    29,    30,    -1,    32,    -1,    -1,    -1,    -1,
      37,    38,    39,    40,    41,    -1,    -1,    44,    45,    46,
      47,    48,    49,    50,    -1,    52,    53,    54,    -1,    -1,
      57,    58,    -1,    60,    61,    62,    63,    -1,    65,    66,
      67,    -1,    -1,    -1,    -1,    -1,    73,    -1,    75,    -1,
      -1,    -1,    -1,    -1,    81,    -1,    83,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    -1,
      97,    98,    -1,    -1,    -1,    -1,    -1,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,     4,   115,   116,
     117,    -1,     9,    10,   121,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    -1,    -1,    -1,    26,
      27,    28,    29,    30,    -1,    32,    -1,    -1,    -1,    -1,
      37,    38,    -1,    40,    41,    -1,    -1,    44,    45,    46,
      47,    48,    49,    50,    -1,    52,    53,    54,    -1,    -1,
      57,    58,    -1,    60,    61,    62,    63,    -1,    65,    66,
      67,    -1,    -1,    -1,    -1,    -1,    73,    -1,    75,    -1,
      -1,    -1,    -1,    -1,    81,    -1,    83,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    -1,
      97,    98,    -1,    -1,    -1,    -1,    -1,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,    -1,   115,   116,
     117,     4,    -1,    -1,   121,     8,     9,    -1,    11,    12,
      13,    14,    15,    16,    17,    18,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    28,    29,    30,    -1,    32,
      -1,    58,    59,    -1,    37,    38,    -1,    40,    41,    -1,
      -1,    -1,    45,    46,    47,    48,    -1,    -1,    -1,    52,
      53,    -1,    -1,    -1,    57,    -1,    -1,    60,    61,    62,
      63,    -1,    65,    -1,    67,    -1,    -1,    -1,    -1,    -1,
      73,    98,    75,   100,   101,    -1,    -1,    -1,    81,    -1,
      83,    -1,    -1,   110,   111,   112,   113,    -1,    -1,   116,
      -1,    94,    95,    -1,   121,    98,    99,     4,    -1,    -1,
      -1,   104,   105,   106,   107,   108,    -1,   110,   111,   112,
     113,    -1,   115,   116,   117,    -1,    -1,    -1,   121,    -1,
      -1,    28,    29,    30,    -1,    32,    -1,    -1,    -1,    -1,
      37,    38,    -1,    40,    41,    42,    -1,    44,    45,    46,
      47,    48,    -1,    50,    -1,    52,    53,    54,    -1,    -1,
      57,    -1,    -1,    60,    61,    62,    63,    -1,    65,    -1,
      67,    -1,    -1,    -1,    -1,    -1,    73,    -1,    75,    -1,
      -1,    -1,    -1,    -1,    81,    -1,    83,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    -1,
      -1,    98,    99,     4,    -1,    -1,    -1,   104,   105,   106,
     107,   108,    -1,   110,   111,   112,   113,    -1,   115,   116,
      -1,    -1,    -1,    -1,   121,    -1,    -1,    28,    29,    30,
      -1,    32,    -1,    -1,    -1,    -1,    37,    38,    -1,    40,
      41,    -1,     4,    -1,    45,    46,    47,    -1,    -1,    -1,
      -1,    52,    53,    -1,    -1,    -1,    57,    -1,    -1,    60,
      61,    62,    63,    -1,    65,    -1,    67,    29,    30,    -1,
      32,    -1,    73,    -1,    75,    37,    38,    -1,    40,    41,
      81,    -1,    83,    45,    46,    47,    -1,    -1,    -1,    -1,
      52,    -1,    -1,    94,    95,    -1,    -1,    -1,    60,    -1,
      62,    63,    -1,   104,   105,    67,    -1,   108,    -1,     9,
      10,    73,    -1,    75,    -1,    -1,    -1,    -1,    18,    81,
     121,    83,    22,    -1,     4,    -1,    -1,    -1,    -1,    -1,
      -1,     8,    94,    95,    11,    12,    13,    14,    15,    16,
      17,    -1,   104,   105,   106,   107,   108,    -1,    48,    29,
      30,    -1,    32,   115,    -1,    -1,    -1,    37,    38,   121,
      40,    41,    -1,    -1,    -1,    45,    46,    47,    -1,    -1,
       8,    -1,    52,    11,    12,    13,    14,    15,    -1,    -1,
      60,    19,    62,    -1,    -1,    -1,    -1,    67,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    75,    96,    74,    -1,    99,
      -1,    -1,    -1,    -1,    -1,    -1,   106,   107,    -1,   109,
      48,    -1,    -1,   113,   114,   115,   116,    -1,    95,    -1,
      -1,    98,    -1,    -1,   104,   105,    -1,   104,   105,   106,
     107,    -1,    -1,   110,   111,   112,    74,    -1,   115,    -1,
     117,   121,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    24,    25,    -1,
      98,    -1,    -1,    -1,    31,    -1,   104,    34,    35,    36,
      -1,    -1,   110,   111,   112,   113,    -1,    -1,   116,   117,
     118,    -1,   120,    -1,    51,    -1,    53,    -1,    55,    -1,
      57,    -1,    -1,    24,    25,    -1,    -1,    64,    65,    66,
      31,    -1,    -1,    34,    35,    36,    -1,    -1,    58,    59,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      51,    -1,    53,    -1,    55,    -1,    57,    -1,    -1,    -1,
      -1,    98,    -1,    64,    65,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   110,   111,   112,   113,    -1,    98,   116,
     100,   101,    -1,    -1,    -1,   122,    -1,    -1,    -1,    -1,
     110,   111,   112,   113,    -1,    -1,   116,    98,    -1,    -1,
      -1,   121,   122,    -1,    -1,    -1,    -1,    -1,    -1,   110,
     111,   112,   113,    -1,    -1,   116,    -1,    -1,    -1,    -1,
      -1,   122
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,    91,   130,   132,   131,     0,     1,     4,    26,    27,
      29,    30,    32,    37,    38,    40,    41,    43,    44,    45,
      46,    47,    48,    49,    50,    52,    54,    58,    60,    62,
      67,    75,    92,    98,   104,   105,   110,   111,   112,   113,
     116,   121,   133,   134,   136,   140,   145,   146,   147,   148,
     157,   160,   163,   169,   170,   171,   173,   177,   183,   184,
     185,   193,   195,   197,   198,   199,   200,   218,   222,   223,
     224,   302,   304,   305,   306,     1,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    22,    28,    32,
      43,    53,    57,    61,    63,    65,    66,    73,    81,    83,
      94,    95,    97,    99,   104,   106,   107,   108,   110,   111,
     112,   113,   115,   116,   117,   134,   135,   138,   140,   141,
     142,   145,   150,   151,   152,   153,   157,   160,   163,   169,
     175,   178,   179,   180,   181,   182,   186,   187,   198,   225,
     237,   238,   243,   244,   245,   249,   251,   252,   253,   254,
     261,   262,   263,   268,   271,   272,   275,   283,   284,   285,
     286,   287,   297,   302,   304,   305,   306,   307,   113,   116,
     135,   240,   121,   121,   113,   116,   135,   241,   113,   116,
     135,   240,   241,   303,   121,   177,   177,   241,   176,   120,
      85,    89,    90,   206,   208,   210,   214,   215,   210,   176,
      42,   144,    21,   120,   123,   121,     1,   112,   122,   136,
     148,   174,   304,   305,   179,   195,   196,   197,   243,   283,
       7,   194,   200,   190,   191,    58,    59,   100,   101,   113,
     116,   121,   138,   308,   309,   311,   312,   314,   315,   317,
     322,   323,   324,   326,   123,     9,    22,   273,    22,    85,
      89,   210,   212,     9,   266,   266,   273,   241,   121,   142,
       9,   113,   116,   135,   202,   203,   204,   205,   233,   234,
     203,   236,   202,   235,     9,   113,   116,   135,   239,   271,
     306,   235,   105,   138,   188,   189,   246,   281,   269,   270,
     272,   270,   270,    85,    89,   212,    20,    21,   257,   259,
     260,   257,   270,    85,    89,   212,   257,     9,   141,   266,
      39,    13,    53,    61,   113,   116,   117,   138,   180,   182,
     252,   268,   272,   306,    86,   270,   269,   270,   300,    14,
      15,    19,    74,   113,   116,   117,   118,   120,   138,   151,
     218,   254,   255,   265,   267,   304,   306,   274,   250,   250,
     270,   250,   100,   320,   323,     9,    22,   138,   299,    92,
     158,    92,   161,   123,   219,   105,   220,   221,   123,   100,
     309,   311,   323,   164,   166,   219,     1,    76,   180,   202,
      89,   209,   214,   216,   217,    85,    87,    87,   122,   121,
     202,   226,   226,     9,   113,   116,   117,   138,   149,   150,
     182,   205,   251,   283,   294,   295,   296,   297,   298,   306,
     153,   172,   182,   194,   190,     7,   200,   187,   327,   313,
      84,    85,    88,    90,   318,    84,   318,   319,   316,   310,
     102,   103,   312,   322,   324,   325,   326,   149,   120,    85,
      89,   213,   216,    85,   123,   156,    21,   120,   226,   123,
     203,   228,   229,   230,   123,   271,   123,   121,    74,    95,
     105,   138,   218,   247,   248,   252,   262,   263,   264,     9,
      80,    82,   113,   116,   127,   135,   276,   278,   280,   306,
     250,   250,   216,    85,    20,    21,   216,    85,   234,   235,
     176,   250,   286,   250,    68,    69,    70,    72,   289,    19,
     301,   320,   124,   252,   250,    84,    85,   321,    39,   100,
     178,     1,   112,   122,   136,   159,   160,   163,   168,   169,
     198,   302,   306,     1,   112,   122,   136,   162,   163,   168,
     198,   302,   306,   240,   190,   200,   240,     1,   122,   138,
     165,   167,   169,   178,   190,    85,    87,     9,    18,    97,
     109,   111,   112,   113,   116,   117,   134,   137,   139,   140,
     145,   153,   157,   160,   163,   169,   182,   187,   251,   262,
     263,   297,   302,   306,   307,    86,    89,   206,   211,    96,
     109,   114,   201,   207,   272,   283,   286,   297,   109,   201,
     207,   272,   283,   286,   297,   143,   123,   123,    22,     9,
     117,   296,    21,   120,   250,   117,   118,   124,   126,   220,
     190,   121,   121,   319,   319,   319,   319,   122,   311,   323,
     325,   328,    86,   213,   216,    85,   152,    85,    89,   206,
     212,   240,    24,    25,    31,    34,    35,    36,    51,    53,
      55,    57,    64,    65,   122,   135,   138,   154,   155,   187,
     227,   231,   232,   241,   203,   203,    13,    14,    15,   111,
     117,   139,   152,   205,   238,   242,   268,   283,   298,    86,
     152,   242,   123,   293,   299,   192,   250,   300,   278,    19,
      77,    78,    79,   117,   118,   125,   126,   277,   279,   152,
     206,   152,   206,   123,   123,   262,   262,   288,   123,   128,
     256,     9,    97,    84,   319,   321,   319,   321,   321,     5,
     144,   144,   220,   144,    89,   209,   217,   201,   207,   272,
     283,   297,     9,    10,    22,    85,     9,    18,   111,   113,
     116,   117,   139,   251,   262,   263,   297,   306,    33,   273,
      21,   120,   112,   122,   136,   148,   149,   149,   226,   226,
     295,   295,   296,   296,   220,   164,   164,   113,   138,   311,
     309,   323,   328,   325,    89,   209,   213,   216,    85,   152,
     228,   228,   241,   198,   113,   116,   138,   123,    85,    89,
     298,    21,   120,   104,   110,   304,   109,   201,   293,   117,
     122,   154,   232,   301,   152,   152,   117,     9,    93,   289,
     290,   291,   292,   257,   269,   319,   177,    85,     9,    10,
      18,    22,   111,   113,   116,   117,   139,   251,   262,   263,
     306,    33,   211,     9,    10,    22,   274,   202,   202,   122,
     122,    85,   206,   123,   242,   216,    85,   226,   226,    85,
      89,    85,    89,   100,   323,    21,   120,   203,   299,   256,
      71,   118,   120,   257,   258,   217,     9,    10,    22,   250,
     242,    53,    61,   117,    89,   206,   216,    85,   216,    85,
      85,   100,   203,   203,   250,   292,    56,   282,   234,   235,
      85,   206,   206,   319,   250,   123,   123,   206
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_int16 yyr1[] =
{
       0,   129,   130,   131,   130,   132,   132,   132,   132,   132,
     133,   133,   133,   133,   133,   133,   133,   133,   133,   133,
     133,   134,   134,   135,   135,   136,   136,   136,   137,   137,
     137,   137,   137,   137,   137,   137,   137,   137,   137,   137,
     137,   138,   138,   138,   139,   139,   139,   140,   141,   141,
     141,   142,   142,   142,   142,   142,   142,   142,   142,   143,
     143,   143,   143,   144,   146,   145,   147,   147,   148,   148,
     148,   148,   149,   149,   149,   149,   149,   150,   150,   150,
     150,   150,   150,   150,   150,   150,   150,   150,   150,   150,
     150,   150,   151,   151,   151,   151,   151,   151,   151,   151,
     151,   152,   152,   152,   152,   152,   152,   152,   152,   153,
     154,   155,   154,   156,   156,   156,   156,   157,   158,   158,
     158,   158,   158,   158,   158,   158,   158,   158,   159,   158,
     158,   160,   161,   161,   161,   161,   161,   161,   161,   161,
     161,   162,   161,   161,   163,   164,   164,   165,   165,   165,
     166,   166,   167,   166,   168,   169,   170,   170,   170,   171,
     172,   172,   173,   173,   173,   173,   174,   173,   173,   175,
     175,   175,   176,   176,   176,   177,   178,   178,   178,   179,
     180,   180,   180,   180,   180,   181,   182,   182,   183,   183,
     184,   184,   185,   185,   186,   186,   186,   188,   187,   187,
     189,   189,   190,   191,   191,   192,   192,   192,   193,   193,
     194,   194,   195,   195,   195,   195,   195,   196,   196,   196,
     197,   197,   197,   198,   198,   198,   199,   199,   199,   200,
     200,   201,   201,   201,   202,   202,   202,   203,   203,   204,
     204,   205,   205,   206,   206,   206,   206,   206,   206,   206,
     206,   206,   206,   206,   206,   206,   206,   207,   208,   208,
     208,   208,   208,   208,   208,   208,   209,   209,   209,   209,
     209,   209,   209,   209,   209,   209,   209,   209,   209,   209,
     209,   209,   209,   209,   209,   209,   209,   210,   210,   211,
     211,   212,   212,   212,   212,   213,   213,   213,   213,   214,
     214,   214,   214,   214,   214,   214,   214,   214,   214,   214,
     214,   215,   215,   215,   215,   215,   215,   215,   215,   215,
     215,   216,   216,   216,   217,   217,   218,   219,   219,   221,
     220,   220,   222,   222,   223,   223,   223,   223,   223,   224,
     224,   224,   224,   225,   226,   227,   227,   227,   227,   228,
     229,   230,   230,   230,   230,   231,   231,   231,   231,   231,
     231,   231,   231,   231,   232,   232,   232,   232,   233,   234,
     234,   235,   236,   237,   237,   237,   237,   238,   238,   238,
     239,   239,   239,   239,   240,   240,   240,   241,   241,   241,
     242,   242,   242,   242,   242,   242,   242,   242,   243,   243,
     243,   243,   243,   244,   245,   245,   246,   246,   247,   247,
     247,   247,   248,   248,   248,   249,   250,   250,   251,   251,
     251,   251,   251,   251,   251,   251,   252,   252,   253,   254,
     254,   254,   254,   255,   255,   256,   256,   257,   257,   257,
     258,   259,   259,   260,   260,   261,   262,   263,   263,   264,
     264,   265,   265,   265,   265,   266,   267,   267,   267,   267,
     267,   267,   267,   268,   268,   268,   269,   269,   270,   271,
     271,   272,   273,   273,   274,   274,   274,   275,   275,   276,
     276,   276,   276,   276,   277,   277,   277,   278,   278,   278,
     278,   278,   279,   279,   279,   279,   280,   280,   281,   281,
     282,   282,   283,   283,   284,   284,   285,   285,   285,   285,
     286,   287,   287,   288,   288,   289,   289,   289,   289,   290,
     290,   290,   291,   291,   292,   292,   292,   293,   293,   294,
     294,   294,   295,   295,   295,   296,   296,   297,   297,   297,
     298,   298,   298,   299,   299,   299,   300,   300,   301,   301,
     303,   302,   304,   305,   306,   306,   307,   308,   308,   308,
     310,   309,   311,   311,   312,   312,   312,   313,   312,   314,
     315,   316,   316,   316,   317,   318,   318,   318,   318,   319,
     319,   320,   320,   321,   321,   321,   321,   322,   323,   323,
     324,   324,   325,   325,   327,   326,   326,   326,   328,   328
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     1,     0,     3,     0,     2,     2,     2,     2,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     2,     2,     1,
       2,     0,     1,     1,     1,     2,     3,     1,     2,     0,
       2,     2,     2,     4,     0,     2,     1,     1,     3,     5,
       5,     3,     1,     1,     3,     3,     2,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     2,     2,     2,     4,     4,     4,     5,     5,
       5,     1,     3,     3,     4,     4,     3,     2,     1,     4,
       1,     0,     2,     0,     2,     2,     2,     4,     0,     1,
       2,     2,     2,     2,     2,     2,     2,     2,     0,     3,
       2,     4,     0,     1,     2,     2,     2,     2,     2,     2,
       2,     0,     3,     2,     4,     1,     2,     1,     1,     1,
       0,     2,     0,     3,     1,     2,     1,     1,     1,     1,
       1,     1,     2,     2,     2,     2,     0,     3,     2,     4,
       5,     2,     0,     2,     2,     3,     1,     1,     1,     1,
       1,     1,     1,     3,     2,     1,     1,     1,     4,     6,
       2,     1,     2,     3,     1,     1,     1,     0,     5,     2,
       1,     1,     1,     0,     2,     0,     2,     2,     4,     4,
       3,     4,     1,     1,     1,     3,     5,     1,     1,     1,
       3,     2,     2,     1,     1,     2,     1,     1,     1,     1,
       1,     1,     3,     3,     1,     3,     3,     1,     1,     1,
       1,     1,     1,     1,     4,     5,     5,     5,     4,     4,
       3,     3,     3,     3,     3,     3,     3,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     1,     4,     4,     4,
       4,     4,     4,     4,     4,     5,     5,     5,     4,     4,
       4,     4,     3,     3,     3,     3,     3,     1,     4,     1,
       3,     2,     2,     3,     3,     2,     2,     3,     3,     1,
       3,     3,     3,     4,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     4,
       4,     1,     4,     2,     1,     3,     2,     0,     2,     0,
       2,     1,     2,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     4,     1,     3,     2,     4,     2,     3,
       1,     1,     5,     5,     4,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     2,     2,     2,     1,     1,
       2,     1,     1,     4,     3,     4,     2,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     2,     1,     3,     3,     2,     3,
       3,     1,     1,     3,     3,     3,     0,     2,     5,     2,
       1,     1,     1,     1,     1,     2,     0,     2,     1,     2,
       1,     1,     2,     2,     2,     2,     1,     2,     1,     1,
       1,     1,     1,     1,     1,     0,     2,     0,     1,     1,
       1,     1,     2,     1,     2,     2,     2,     1,     2,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     0,     1,     1,     2,
       2,     2,     0,     2,     0,     3,     3,     1,     2,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     2,
       2,     2,     1,     1,     1,     1,     1,     2,     0,     2,
       0,     1,     8,     2,     2,     2,     1,     1,     1,     1,
       3,     2,     4,     0,     2,     1,     1,     2,     2,     1,
       1,     1,     1,     3,     1,     2,     2,     1,     3,     3,
       3,     1,     1,     3,     3,     2,     1,     1,     1,     2,
       1,     1,     2,     1,     1,     1,     0,     2,     0,     2,
       0,     3,     1,     2,     2,     1,     3,     1,     2,     1,
       0,     3,     1,     1,     1,     1,     2,     0,     5,     2,
       3,     0,     2,     2,     2,     3,     3,     3,     1,     1,
       3,     2,     3,     2,     2,     2,     2,     3,     1,     2,
       1,     1,     1,     1,     0,     5,     2,     2,     2,     1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (&yylloc, parser, retval, YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static int
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  int res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
 }

#  define YY_LOCATION_PRINT(File, Loc)          \
  yy_location_print_ (File, &(Loc))

# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value, Location, parser, retval); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, Lily_parser *parser, SCM *retval)
{
  FILE *yyoutput = yyo;
  YYUSE (yyoutput);
  YYUSE (yylocationp);
  YYUSE (parser);
  YYUSE (retval);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyo, yytoknum[yytype], *yyvaluep);
# endif
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, Lily_parser *parser, SCM *retval)
{
  YYFPRINTF (yyo, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  YY_LOCATION_PRINT (yyo, *yylocationp);
  YYFPRINTF (yyo, ": ");
  yy_symbol_value_print (yyo, yytype, yyvaluep, yylocationp, parser, retval);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp, int yyrule, Lily_parser *parser, SCM *retval)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &yyvsp[(yyi + 1) - (yynrhs)]
                       , &(yylsp[(yyi + 1) - (yynrhs)])                       , parser, retval);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule, parser, retval); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen(S) (YY_CAST (YYPTRDIFF_T, strlen (S)))
#  else
/* Return the length of YYSTR.  */
static YYPTRDIFF_T
yystrlen (const char *yystr)
{
  YYPTRDIFF_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYPTRDIFF_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYPTRDIFF_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            else
              goto append;

          append:
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (yyres)
    return yystpcpy (yyres, yystr) - yyres;
  else
    return yystrlen (yystr);
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYPTRDIFF_T *yymsg_alloc, char **yymsg,
                yy_state_t *yyssp, int yytoken)
{
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat: reported tokens (one for the "unexpected",
     one per "expected"). */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Actual size of YYARG. */
  int yycount = 0;
  /* Cumulated lengths of YYARG.  */
  YYPTRDIFF_T yysize = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      YYPTRDIFF_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
      yysize = yysize0;
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYPTRDIFF_T yysize1
                    = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
                    yysize = yysize1;
                  else
                    return 2;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    /* Don't count the "%s"s in the final size, but reserve room for
       the terminator.  */
    YYPTRDIFF_T yysize1 = yysize + (yystrlen (yyformat) - 2 * yycount) + 1;
    if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
      yysize = yysize1;
    else
      return 2;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          ++yyp;
          ++yyformat;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp, Lily_parser *parser, SCM *retval)
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);
  YYUSE (parser);
  YYUSE (retval);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/*----------.
| yyparse.  |
`----------*/

int
yyparse (Lily_parser *parser, SCM *retval)
{
/* The lookahead symbol.  */
int yychar;


/* The semantic value of the lookahead symbol.  */
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
YY_INITIAL_VALUE (static YYSTYPE yyval_default;)
YYSTYPE yylval YY_INITIAL_VALUE (= yyval_default);

/* Location data for the lookahead symbol.  */
static YYLTYPE yyloc_default
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
YYLTYPE yylloc = yyloc_default;

    /* Number of syntax errors so far.  */
    int yynerrs;

    yy_state_fast_t yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.
       'yyls': related to locations.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss;
    yy_state_t *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    /* The location stack.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls;
    YYLTYPE *yylsp;

    /* The locations where the error started and ended.  */
    YYLTYPE yyerror_range[3];

    YYPTRDIFF_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYPTRDIFF_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yylsp = yyls = yylsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  yylsp[0] = yylloc;
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    goto yyexhaustedlab;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yyls1, yysize * YYSIZEOF (*yylsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
        yyls = yyls1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
# undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex (&yylval, &yylloc, parser);
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location. */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  yyerror_range[1] = yyloc;
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 3:
#line 393 "parser.yy"
                        {
		parser->lexer_->push_note_state (Lily::pitchnames);
	}
#line 3115 "./out/parser.cc"
    break;

  case 4:
#line 395 "parser.yy"
                            {
		parser->lexer_->pop_state ();
                *retval = yyvsp[0];
 	}
#line 3124 "./out/parser.cc"
    break;

  case 5:
#line 401 "parser.yy"
                            { yyval = SCM_UNSPECIFIED; }
#line 3130 "./out/parser.cc"
    break;

  case 6:
#line 402 "parser.yy"
                                       {
	}
#line 3137 "./out/parser.cc"
    break;

  case 7:
#line 404 "parser.yy"
                              {
	}
#line 3144 "./out/parser.cc"
    break;

  case 8:
#line 406 "parser.yy"
                         {
		parser->error_level_ = 1;
	}
#line 3152 "./out/parser.cc"
    break;

  case 9:
#line 409 "parser.yy"
                                {
		parser->error_level_ = 1;
	}
#line 3160 "./out/parser.cc"
    break;

  case 10:
#line 416 "parser.yy"
                     {
		parser->lexer_->set_identifier (ly_symbol2scm ("$defaultheader"), yyvsp[0]);
	}
#line 3168 "./out/parser.cc"
    break;

  case 11:
#line 419 "parser.yy"
                     {
		SCM proc = parser->lexer_->lookup_identifier ("toplevel-book-handler");
		scm_call_1 (proc, yyvsp[0]);
	}
#line 3177 "./out/parser.cc"
    break;

  case 12:
#line 423 "parser.yy"
                         {
		SCM proc = parser->lexer_->lookup_identifier ("toplevel-bookpart-handler");
		scm_call_1 (proc, yyvsp[0]);
	}
#line 3186 "./out/parser.cc"
    break;

  case 13:
#line 427 "parser.yy"
                          {
		SCM proc = parser->lexer_->lookup_identifier
			(unsmob<Book>(yyvsp[0])->paper_
			 ? "toplevel-book-handler"
			 : "toplevel-bookpart-handler");
		scm_call_1 (proc, yyvsp[0]);
	}
#line 3198 "./out/parser.cc"
    break;

  case 14:
#line 434 "parser.yy"
                      {
		SCM proc = parser->lexer_->lookup_identifier ("toplevel-score-handler");
		scm_call_1 (proc, yyvsp[0]);
	}
#line 3207 "./out/parser.cc"
    break;

  case 15:
#line 438 "parser.yy"
                          {
		SCM proc = parser->lexer_->lookup_identifier ("toplevel-music-handler");
		scm_call_1 (proc, yyvsp[0]);
	}
#line 3216 "./out/parser.cc"
    break;

  case 16:
#line 442 "parser.yy"
                      {
		SCM proc = parser->lexer_->lookup_identifier ("toplevel-text-handler");
		scm_call_1 (proc, scm_list_1 (yyvsp[0]));
	}
#line 3225 "./out/parser.cc"
    break;

  case 17:
#line 446 "parser.yy"
                           {
		SCM proc = parser->lexer_->lookup_identifier ("toplevel-text-handler");
		scm_call_1 (proc, yyvsp[0]);
	}
#line 3234 "./out/parser.cc"
    break;

  case 18:
#line 450 "parser.yy"
                    {
		// Evaluate and ignore #xxx, as opposed to \xxx
		parser->lexer_->eval_scm_token (yyvsp[0], (yylsp[0]));
	}
#line 3243 "./out/parser.cc"
    break;

  case 19:
#line 455 "parser.yy"
        {
		SCM out = SCM_UNDEFINED;
		if (Text_interface::is_markup (yyvsp[0]))
			out = scm_list_1 (yyvsp[0]);
		else if (Text_interface::is_markup_list (yyvsp[0]))
			out = yyvsp[0];
		if (scm_is_pair (out))
		{
			SCM proc = parser->lexer_->lookup_identifier ("toplevel-text-handler");
			scm_call_1 (proc, out);
		} else if (unsmob<Score> (yyvsp[0]))
		{
			SCM proc = parser->lexer_->lookup_identifier ("toplevel-score-handler");
			scm_call_1 (proc, yyvsp[0]);
		} else if (Output_def * od = unsmob<Output_def> (yyvsp[0])) {
			SCM id = SCM_EOL;

			if (to_boolean (od->c_variable ("is-paper")))
				id = ly_symbol2scm ("$defaultpaper");
			else if (to_boolean (od->c_variable ("is-midi")))
				id = ly_symbol2scm ("$defaultmidi");
			else if (to_boolean (od->c_variable ("is-layout")))
				id = ly_symbol2scm ("$defaultlayout");

			parser->lexer_->set_identifier (id, yyvsp[0]);
		} else if (ly_is_module (yyvsp[0]))
		{
			SCM module = get_header (parser);
			ly_module_copy (module, yyvsp[0]);
			parser->lexer_->set_identifier
				(ly_symbol2scm ("$defaultheader"), module);
		} else if (!scm_is_eq (yyvsp[0], SCM_UNSPECIFIED))
			parser->parser_error ((yylsp[0]), _("bad expression type"));
	}
#line 3282 "./out/parser.cc"
    break;

  case 20:
#line 489 "parser.yy"
                     {
		SCM id = SCM_EOL;
		Output_def * od = unsmob<Output_def> (yyvsp[0]);

		if (to_boolean (od->c_variable ("is-paper")))
			id = ly_symbol2scm ("$defaultpaper");
		else if (to_boolean (od->c_variable ("is-midi")))
			id = ly_symbol2scm ("$defaultmidi");
		else if (to_boolean (od->c_variable ("is-layout")))
			id = ly_symbol2scm ("$defaultlayout");

		parser->lexer_->set_identifier (id, yyvsp[0]);
	}
#line 3300 "./out/parser.cc"
    break;

  case 22:
#line 507 "parser.yy"
        {
		yyval = loc_on_copy (parser, (yyloc),
				  nested_property (yyvsp[-2], scm_reverse_x (yyvsp[0], SCM_EOL)));
	}
#line 3309 "./out/parser.cc"
    break;

  case 23:
#line 515 "parser.yy"
        {
		yyval = parser->lexer_->eval_scm_token (yyvsp[0], (yylsp[0]));
	}
#line 3317 "./out/parser.cc"
    break;

  case 29:
#line 530 "parser.yy"
        {
		yyval = parser->lexer_->eval_scm_token (yyvsp[0], (yylsp[0]));
	}
#line 3325 "./out/parser.cc"
    break;

  case 47:
#line 570 "parser.yy"
                                      {
		yyval = MAKE_SYNTAX (music_function, (yyloc),
				  yyvsp[-1], yyvsp[0]);
	}
#line 3334 "./out/parser.cc"
    break;

  case 48:
#line 578 "parser.yy"
        {
		yyval = scm_difference (yyvsp[0], SCM_UNDEFINED);
	}
#line 3342 "./out/parser.cc"
    break;

  case 50:
#line 583 "parser.yy"
        {
		yyval = scm_product (yyvsp[-1], yyvsp[0]);
	}
#line 3350 "./out/parser.cc"
    break;

  case 51:
#line 590 "parser.yy"
        {
		// FIXME: @$ does not contain a useful source location
		// for empty rules, and the only token in the whole
		// production, EMBEDDED_LILY, is synthetic and also
		// contains no source location.
		yyval = MAKE_SYNTAX (void_music, (yyloc));
	}
#line 3362 "./out/parser.cc"
    break;

  case 54:
#line 600 "parser.yy"
        {
		if (!unsmob<Music> (yyvsp[0]))
			yyval = MY_MAKE_MUSIC ("PostEvents", (yyloc))->unprotect ();
	}
#line 3371 "./out/parser.cc"
    break;

  case 55:
#line 605 "parser.yy"
        {
		if (scm_is_pair (yyvsp[0])) {
			Music *n = MY_MAKE_MUSIC ("NoteEvent", (yyloc));

			parser->default_duration_ = *unsmob<Duration> (yyvsp[-1]);
			n->set_property ("duration", yyvsp[-1]);
			n->set_property ("articulations",
					 scm_reverse_x (yyvsp[0], SCM_EOL));
			yyval = n->unprotect ();
		}
	}
#line 3387 "./out/parser.cc"
    break;

  case 56:
#line 616 "parser.yy"
                                                   {
		SCM tail = SCM_EOL;
		if (unsmob<Music> (yyvsp[-2]))
			tail = scm_cons (yyvsp[-2], tail);
		if (unsmob<Music> (yyvsp[-1]))
			tail = scm_cons (yyvsp[-1], tail);
		yyval = reverse_music_list (parser, (yyloc),
					 scm_append_x (scm_list_2 (yyvsp[0], tail)),
					 true, true);
		if (scm_is_pair (yyval)) // unpackaged list
			if (scm_is_null (scm_cdr (yyval)))
				yyval = scm_car (yyval); // single expression
			else
				yyval = MAKE_SYNTAX (sequential_music, (yyloc), yyval);
		else if (scm_is_null (yyval))
			yyval = MAKE_SYNTAX (void_music, (yyloc));
		// else already packaged post-event
	}
#line 3410 "./out/parser.cc"
    break;

  case 57:
#line 634 "parser.yy"
                {
		parser->error_level_ = 1;
                yyval = SCM_UNSPECIFIED;
	}
#line 3419 "./out/parser.cc"
    break;

  case 58:
#line 638 "parser.yy"
                                    {
		parser->error_level_ = 1;
                yyval = yyvsp[0];
	}
#line 3428 "./out/parser.cc"
    break;

  case 59:
#line 646 "parser.yy"
                    { yyval = SCM_UNSPECIFIED; }
#line 3434 "./out/parser.cc"
    break;

  case 60:
#line 647 "parser.yy"
                                           {

	}
#line 3442 "./out/parser.cc"
    break;

  case 61:
#line 650 "parser.yy"
                                         {
		// Evaluate and ignore #xxx, as opposed to \xxx
		parser->lexer_->eval_scm_token (yyvsp[0], (yylsp[0]));
	}
#line 3451 "./out/parser.cc"
    break;

  case 62:
#line 654 "parser.yy"
                                                   {
		if (ly_is_module (yyvsp[0]))
			ly_module_copy (scm_current_module (), yyvsp[0]);
		else if (!scm_is_eq (yyvsp[0], SCM_UNSPECIFIED))
			parser->parser_error ((yylsp[0]), _("bad expression type"));
	}
#line 3462 "./out/parser.cc"
    break;

  case 63:
#line 663 "parser.yy"
                                                {
		yyval = parser->lexer_->remove_scope ();
	}
#line 3470 "./out/parser.cc"
    break;

  case 64:
#line 669 "parser.yy"
        {
		parser->lexer_->add_scope (get_header (parser));
	}
#line 3478 "./out/parser.cc"
    break;

  case 65:
#line 671 "parser.yy"
                          {
		yyval = yyvsp[0];
	}
#line 3486 "./out/parser.cc"
    break;

  case 66:
#line 681 "parser.yy"
        {
		yyval = scm_string_to_symbol (yyvsp[0]);
	}
#line 3494 "./out/parser.cc"
    break;

  case 67:
#line 685 "parser.yy"
        {
		yyval = scm_string_to_symbol (yyvsp[0]);
	}
#line 3502 "./out/parser.cc"
    break;

  case 68:
#line 691 "parser.yy"
                                           {
	        parser->lexer_->set_identifier (yyvsp[-2], yyvsp[0]);
                yyval = SCM_UNSPECIFIED;
	}
#line 3511 "./out/parser.cc"
    break;

  case 69:
#line 695 "parser.yy"
                                                              {
		SCM path = scm_cons (yyvsp[-4], yyvsp[-2]);
		parser->lexer_->set_identifier (path, yyvsp[0]);
                yyval = SCM_UNSPECIFIED;
	}
#line 3521 "./out/parser.cc"
    break;

  case 70:
#line 700 "parser.yy"
                                                              {
		SCM path = scm_cons (yyvsp[-4], yyvsp[-2]);
		parser->lexer_->set_identifier (path, yyvsp[0]);
                yyval = SCM_UNSPECIFIED;
	}
#line 3531 "./out/parser.cc"
    break;

  case 71:
#line 706 "parser.yy"
        {
		if (scm_is_false (Lily::markup_function_p (yyvsp[0])))
		{
			parser->parser_error ((yylsp[0]), _ ("Not a markup function"));
		} else {
			Lily::define_markup_command_internal
				(scm_string_to_symbol (yyvsp[-2]), yyvsp[0]);
		}
		yyval = SCM_UNSPECIFIED;
	}
#line 3546 "./out/parser.cc"
    break;

  case 74:
#line 723 "parser.yy"
        {
		yyval = scm_reverse_x (yyvsp[-2], yyvsp[0]);
	}
#line 3554 "./out/parser.cc"
    break;

  case 75:
#line 727 "parser.yy"
        {
		yyval = scm_reverse_x (yyvsp[-2], yyvsp[0]);
	}
#line 3562 "./out/parser.cc"
    break;

  case 76:
#line 731 "parser.yy"
        {
		yyval = scm_reverse_x (yyvsp[0], SCM_EOL);
		if (Music *m = unsmob<Music> (yyvsp[-1]))
		{
			if (m->is_mus_type ("post-event-wrapper"))
				yyval = scm_append
					(scm_list_2 (m->get_property ("elements"),
						     yyval));
			else
				yyval = scm_cons (yyvsp[-1], yyval);
		}
		if (scm_is_pair (yyval)
		    && scm_is_null (scm_cdr (yyval)))
			yyval = scm_car (yyval);
		else
		{
			Music * m = MY_MAKE_MUSIC ("PostEvents", (yyloc));
			m->set_property ("elements", yyval);
			yyval = m->unprotect ();
		}
	}
#line 3588 "./out/parser.cc"
    break;

  case 91:
#line 770 "parser.yy"
        {
		yyval = MAKE_SYNTAX (partial_music_function, (yyloc),
				  scm_reverse_x (yyvsp[-1], SCM_EOL));
	}
#line 3597 "./out/parser.cc"
    break;

  case 92:
#line 780 "parser.yy"
        {
		yyval = scm_acons (yyvsp[-1], yyvsp[0], SCM_EOL);
	}
#line 3605 "./out/parser.cc"
    break;

  case 93:
#line 784 "parser.yy"
        {
		yyval = scm_acons (yyvsp[-1], yyvsp[0], SCM_EOL);
	}
#line 3613 "./out/parser.cc"
    break;

  case 94:
#line 788 "parser.yy"
        {
		yyval = scm_acons (yyvsp[-1], yyvsp[0], SCM_EOL);
	}
#line 3621 "./out/parser.cc"
    break;

  case 95:
#line 792 "parser.yy"
        {
		yyval = scm_acons (yyvsp[-3], yyvsp[-1], yyvsp[0]);
	}
#line 3629 "./out/parser.cc"
    break;

  case 96:
#line 796 "parser.yy"
        {
		yyval = scm_acons (yyvsp[-3], yyvsp[-1], yyvsp[0]);
	}
#line 3637 "./out/parser.cc"
    break;

  case 97:
#line 800 "parser.yy"
        {
		yyval = scm_acons (yyvsp[-3], yyvsp[-1], yyvsp[0]);
	}
#line 3645 "./out/parser.cc"
    break;

  case 98:
#line 804 "parser.yy"
        {
		yyval = scm_acons (yyvsp[-4], yyvsp[-1], yyvsp[0]);
	}
#line 3653 "./out/parser.cc"
    break;

  case 99:
#line 808 "parser.yy"
        {
		yyval = scm_acons (yyvsp[-4], yyvsp[-1], yyvsp[0]);
	}
#line 3661 "./out/parser.cc"
    break;

  case 100:
#line 812 "parser.yy"
        {
		yyval = scm_acons (yyvsp[-4], yyvsp[-1], yyvsp[0]);
	}
#line 3669 "./out/parser.cc"
    break;

  case 102:
#line 820 "parser.yy"
        {
		if (SCM_UNBNDP (yyvsp[-1]))
			yyval = scm_list_1 (SCM_BOOL_F);
		else
			yyval = scm_cons
				(scm_list_3 (Syntax::property_override_function,
					     scm_cdr (yyvsp[-1]), scm_car (yyvsp[-1])),
				 SCM_EOL);
	}
#line 3683 "./out/parser.cc"
    break;

  case 103:
#line 830 "parser.yy"
        {
		if (SCM_UNBNDP (yyvsp[-1]))
			yyval = scm_list_1 (SCM_BOOL_F);
		else
			yyval = scm_cons
				(scm_list_3 (Syntax::property_set_function,
					     scm_cadr (yyvsp[-1]), scm_car (yyvsp[-1])),
				 SCM_EOL);
	}
#line 3697 "./out/parser.cc"
    break;

  case 104:
#line 840 "parser.yy"
        {
		if (SCM_UNBNDP (yyvsp[-2]))
			yyval = scm_list_1 (SCM_BOOL_F);
		else
			yyval = scm_cons
				(scm_list_3 (Syntax::property_override_function,
					     scm_cdr (yyvsp[-2]), scm_car (yyvsp[-2])),
				 yyvsp[0]);
	}
#line 3711 "./out/parser.cc"
    break;

  case 105:
#line 850 "parser.yy"
        {
		if (SCM_UNBNDP (yyvsp[-2]))
			yyval = scm_list_1 (SCM_BOOL_F);
		else
			yyval = scm_cons
				(scm_list_3 (Syntax::property_set_function,
					     scm_cadr (yyvsp[-2]), scm_car (yyvsp[-2])),
				 yyvsp[0]);
	}
#line 3725 "./out/parser.cc"
    break;

  case 106:
#line 861 "parser.yy"
        {
		if (SCM_UNBNDP (yyvsp[-2]))
			yyvsp[-2] = SCM_INUM0;
		yyvsp[0] = MAKE_SYNTAX (partial_markup, (yylsp[0]), yyvsp[0]);
		parser->lexer_->pop_state ();
// This relies on partial_function always being followed by ETC
		yyval = scm_list_1 (scm_list_3 (MAKE_SYNTAX (partial_text_script, (yyloc), yyvsp[0]),
					     yyvsp[0], yyvsp[-2]));
	}
#line 3739 "./out/parser.cc"
    break;

  case 107:
#line 871 "parser.yy"
        {
		if (SCM_UNBNDP (yyvsp[-1]))
			yyvsp[-1] = SCM_INUM0;
		yyval = scm_acons (Syntax::create_script_function, scm_list_1 (yyvsp[-1]), yyvsp[0]);
	}
#line 3749 "./out/parser.cc"
    break;

  case 108:
#line 877 "parser.yy"
        {
		if (SCM_UNBNDP (yyvsp[0]))
			yyvsp[0] = SCM_INUM0;
		yyval = scm_acons (Syntax::create_script_function, scm_list_1 (yyvsp[0]), SCM_EOL);
	}
#line 3759 "./out/parser.cc"
    break;

  case 109:
#line 886 "parser.yy"
        {
		yyval = yyvsp[-1];
		Context_def *td = unsmob<Context_def> (yyval);
		if (!td) {
			yyval = Context_def::make_scm ();
			td = unsmob<Context_def> (yyval);
		}
		td->origin ()->set_spot ((yyloc));
	}
#line 3773 "./out/parser.cc"
    break;

  case 111:
#line 900 "parser.yy"
        {
		parser->lexer_->push_note_state (Lily::pitchnames);
	}
#line 3781 "./out/parser.cc"
    break;

  case 112:
#line 904 "parser.yy"
        {
		parser->lexer_->pop_state ();
		yyval = yyvsp[0];
	}
#line 3790 "./out/parser.cc"
    break;

  case 113:
#line 912 "parser.yy"
             {
		yyval = SCM_UNSPECIFIED;
	}
#line 3798 "./out/parser.cc"
    break;

  case 114:
#line 915 "parser.yy"
                                            {
		if (!SCM_UNBNDP (yyvsp[0])) {
			Context_def *td = unsmob<Context_def> (yyval);
			if (!td) {
				yyval = Context_def::make_scm ();
				td = unsmob<Context_def> (yyval);
			}
			unsmob<Context_def> (yyval)->add_context_mod (yyvsp[0]);
		}
	}
#line 3813 "./out/parser.cc"
    break;

  case 115:
#line 925 "parser.yy"
                                                     {
                Context_def *td = unsmob<Context_def> (yyval);
		if (!td) {
			yyval = Context_def::make_scm ();
			td = unsmob<Context_def> (yyval);
		}
                SCM new_mods = unsmob<Context_mod> (yyvsp[0])->get_mods ();
                for (SCM m = new_mods; scm_is_pair (m); m = scm_cdr (m)) {
                    td->add_context_mod (scm_car (m));
                }
	}
#line 3829 "./out/parser.cc"
    break;

  case 116:
#line 936 "parser.yy"
                                                {
		Context_def *td = unsmob<Context_def> (yyvsp[-1]);
		if (scm_is_eq (yyvsp[0], SCM_UNSPECIFIED))
			;
		else if (!td && unsmob<Context_def> (yyvsp[0]))
			yyval = yyvsp[0];
		else {
			if (!td) {
				yyval = Context_def::make_scm ();
				td = unsmob<Context_def> (yyval);
			}
			if (unsmob<Music> (yyvsp[0])) {
				SCM proc = parser->lexer_->lookup_identifier ("context-mod-music-handler");
				yyvsp[0] = scm_call_1 (proc, yyvsp[0]);
			}
			if (Context_mod *cm = unsmob<Context_mod> (yyvsp[0])) {
				for (SCM m = cm->get_mods (); scm_is_pair (m); m = scm_cdr (m)) {
					td->add_context_mod (scm_car (m));
				}
			} else
				parser->parser_error ((yylsp[0]), _ ("not a context mod"));
		}
	}
#line 3857 "./out/parser.cc"
    break;

  case 117:
#line 964 "parser.yy"
                                {
		yyval = yyvsp[-1];
		unsmob<Book> (yyval)->origin ()->set_spot ((yyloc));
		pop_paper (parser);
		parser->lexer_->set_identifier (ly_symbol2scm ("$current-book"), SCM_BOOL_F);
	}
#line 3868 "./out/parser.cc"
    break;

  case 118:
#line 976 "parser.yy"
        {
		Book *book = new Book;
		init_papers (parser);
		book->paper_ = dynamic_cast<Output_def*> (unsmob<Output_def> (parser->lexer_->lookup_identifier ("$defaultpaper"))->clone ());
		book->paper_->unprotect ();
		push_paper (parser, book->paper_);
		book->header_ = get_header (parser);
                yyval = book->unprotect ();
		parser->lexer_->set_identifier (ly_symbol2scm ("$current-book"), yyval);
	}
#line 3883 "./out/parser.cc"
    break;

  case 119:
#line 986 "parser.yy"
                          {
		parser->lexer_->set_identifier (ly_symbol2scm ("$current-book"), yyvsp[0]);
	}
#line 3891 "./out/parser.cc"
    break;

  case 120:
#line 989 "parser.yy"
                                {
		unsmob<Book> (yyvsp[-1])->paper_ = unsmob<Output_def> (yyvsp[0]);
		set_paper (parser, unsmob<Output_def> (yyvsp[0]));
	}
#line 3900 "./out/parser.cc"
    break;

  case 121:
#line 993 "parser.yy"
                                   {
		SCM proc = parser->lexer_->lookup_identifier ("book-bookpart-handler");
		scm_call_2 (proc, yyvsp[-1], yyvsp[0]);
	}
#line 3909 "./out/parser.cc"
    break;

  case 122:
#line 997 "parser.yy"
                                {
		SCM proc = parser->lexer_->lookup_identifier ("book-score-handler");
		scm_call_2 (proc, yyvsp[-1], yyvsp[0]);
	}
#line 3918 "./out/parser.cc"
    break;

  case 123:
#line 1001 "parser.yy"
                                    {
		SCM proc = parser->lexer_->lookup_identifier ("book-music-handler");
		scm_call_2 (proc, yyvsp[-1], yyvsp[0]);
	}
#line 3927 "./out/parser.cc"
    break;

  case 124:
#line 1005 "parser.yy"
                                {
		SCM proc = parser->lexer_->lookup_identifier ("book-text-handler");
		scm_call_2 (proc, yyvsp[-1], scm_list_1 (yyvsp[0]));
	}
#line 3936 "./out/parser.cc"
    break;

  case 125:
#line 1009 "parser.yy"
                                     {
		SCM proc = parser->lexer_->lookup_identifier ("book-text-handler");
		scm_call_2 (proc, yyvsp[-1], yyvsp[0]);
	}
#line 3945 "./out/parser.cc"
    break;

  case 126:
#line 1013 "parser.yy"
                              {
		// Evaluate and ignore #xxx, as opposed to \xxx
		parser->lexer_->eval_scm_token (yyvsp[0], (yylsp[0]));
	}
#line 3954 "./out/parser.cc"
    break;

  case 127:
#line 1018 "parser.yy"
        {
		SCM out = SCM_UNDEFINED;
		if (Text_interface::is_markup (yyvsp[0]))
			out = scm_list_1 (yyvsp[0]);
		else if (Text_interface::is_markup_list (yyvsp[0]))
			out = yyvsp[0];
		if (scm_is_pair (out))
		{
			SCM proc = parser->lexer_->lookup_identifier ("book-text-handler");
			scm_call_2 (proc, yyvsp[-1], out);
		} else if (unsmob<Score> (yyvsp[0]))
		{
			SCM proc = parser->lexer_->lookup_identifier ("book-score-handler");
			scm_call_2 (proc, yyvsp[-1], yyvsp[0]);
		} else if (Output_def *od = unsmob<Output_def> (yyvsp[0])) {
			if (to_boolean (od->lookup_variable (ly_symbol2scm ("is-paper")))) {
				unsmob<Book> (yyvsp[-1])->paper_ = od;
				set_paper (parser, od);
			} else {
				parser->parser_error ((yylsp[0]), _ ("need \\paper for paper block"));
			}
		} else if (ly_is_module (yyvsp[0]))
		{
			ly_module_copy (unsmob<Book> (yyvsp[-1])->header_, yyvsp[0]);
		} else if (!scm_is_eq (yyvsp[0], SCM_UNSPECIFIED))
			parser->parser_error ((yylsp[0]), _("bad expression type"));
	}
#line 3986 "./out/parser.cc"
    break;

  case 128:
#line 1046 "parser.yy"
        {
		parser->lexer_->add_scope (unsmob<Book> (yyvsp[0])->header_);
	}
#line 3994 "./out/parser.cc"
    break;

  case 130:
#line 1049 "parser.yy"
                          {
                Book *book = unsmob<Book> (yyvsp[-1]);
		book->paper_ = 0;
		book->scores_ = SCM_EOL;
		book->bookparts_ = SCM_EOL;
	}
#line 4005 "./out/parser.cc"
    break;

  case 131:
#line 1058 "parser.yy"
                                       {
		yyval = yyvsp[-1];
		unsmob<Book> (yyval)->origin ()->set_spot ((yyloc));
		parser->lexer_->set_identifier (ly_symbol2scm ("$current-bookpart"), SCM_BOOL_F);
	}
#line 4015 "./out/parser.cc"
    break;

  case 132:
#line 1066 "parser.yy"
        {
		Book *book = new Book;
                yyval = book->unprotect ();
		parser->lexer_->set_identifier (ly_symbol2scm ("$current-bookpart"), yyval);
	}
#line 4025 "./out/parser.cc"
    break;

  case 133:
#line 1071 "parser.yy"
                          {
		parser->lexer_->set_identifier (ly_symbol2scm ("$current-bookpart"), yyvsp[0]);
	}
#line 4033 "./out/parser.cc"
    break;

  case 134:
#line 1074 "parser.yy"
                                    {
		unsmob<Book> (yyval)->paper_ = unsmob<Output_def> (yyvsp[0]);
	}
#line 4041 "./out/parser.cc"
    break;

  case 135:
#line 1077 "parser.yy"
                                    {
		SCM proc = parser->lexer_->lookup_identifier ("bookpart-score-handler");
		scm_call_2 (proc, yyvsp[-1], yyvsp[0]);
	}
#line 4050 "./out/parser.cc"
    break;

  case 136:
#line 1081 "parser.yy"
                                        {
		SCM proc = parser->lexer_->lookup_identifier ("bookpart-music-handler");
		scm_call_2 (proc, yyvsp[-1], yyvsp[0]);
	}
#line 4059 "./out/parser.cc"
    break;

  case 137:
#line 1085 "parser.yy"
                                    {
		SCM proc = parser->lexer_->lookup_identifier ("bookpart-text-handler");
		scm_call_2 (proc, yyvsp[-1], scm_list_1 (yyvsp[0]));
	}
#line 4068 "./out/parser.cc"
    break;

  case 138:
#line 1089 "parser.yy"
                                         {
		SCM proc = parser->lexer_->lookup_identifier ("bookpart-text-handler");
		scm_call_2 (proc, yyvsp[-1], yyvsp[0]);
	}
#line 4077 "./out/parser.cc"
    break;

  case 139:
#line 1093 "parser.yy"
                                  {
		// Evaluate and ignore #xxx, as opposed to \xxx
		parser->lexer_->eval_scm_token (yyvsp[0], (yylsp[0]));
	}
#line 4086 "./out/parser.cc"
    break;

  case 140:
#line 1098 "parser.yy"
        {
		SCM out = SCM_UNDEFINED;
		if (Text_interface::is_markup (yyvsp[0]))
			out = scm_list_1 (yyvsp[0]);
		else if (Text_interface::is_markup_list (yyvsp[0]))
			out = yyvsp[0];
		if (scm_is_pair (out))
		{
			SCM proc = parser->lexer_->lookup_identifier ("bookpart-text-handler");
			scm_call_2 (proc, yyvsp[-1], out);
		} else if (unsmob<Score> (yyvsp[0]))
		{
			SCM proc = parser->lexer_->lookup_identifier ("bookpart-score-handler");
			scm_call_2 (proc, yyvsp[-1], yyvsp[0]);
		} else if (Output_def *od = unsmob<Output_def> (yyvsp[0])) {
			if (to_boolean (od->lookup_variable (ly_symbol2scm ("is-paper")))) {
				unsmob<Book> (yyvsp[-1])->paper_ = od;
			} else {
				parser->parser_error ((yylsp[0]), _ ("need \\paper for paper block"));
			}
		} else if (ly_is_module (yyvsp[0])) {
			Book *book = unsmob<Book> (yyvsp[-1]);
			if (!ly_is_module (book->header_))
				book->header_ = ly_make_module (false);
			ly_module_copy (book->header_, yyvsp[0]);
		} else if (!scm_is_eq (yyvsp[0], SCM_UNSPECIFIED))
			parser->parser_error ((yylsp[0]), _("bad expression type"));
	}
#line 4119 "./out/parser.cc"
    break;

  case 141:
#line 1127 "parser.yy"
        {
                Book *book = unsmob<Book> (yyvsp[0]);
		if (!ly_is_module (book->header_))
			book->header_ = ly_make_module (false);
		parser->lexer_->add_scope (book->header_);
	}
#line 4130 "./out/parser.cc"
    break;

  case 143:
#line 1133 "parser.yy"
                              {
                Book *book = unsmob<Book> (yyvsp[-1]);
		book->paper_ = 0;
		book->scores_ = SCM_EOL;
	}
#line 4140 "./out/parser.cc"
    break;

  case 144:
#line 1141 "parser.yy"
                                        {
		unsmob<Score> (yyvsp[-1])->origin ()->set_spot ((yyloc));
		yyval = yyvsp[-1];
	}
#line 4149 "./out/parser.cc"
    break;

  case 145:
#line 1148 "parser.yy"
                    {
		if (!unsmob<Score> (yyvsp[0])) {
			parser->parser_error ((yylsp[0]), _("Missing music in \\score"));
			yyval = (new Score)->unprotect ();
			if (scm_is_pair (yyvsp[0]) && ly_is_module (scm_car (yyvsp[0])))
			{
				unsmob<Score> (yyval)->set_header (scm_car (yyvsp[0]));
				yyvsp[0] = scm_cdr (yyvsp[0]);
			}
			for (SCM p = scm_reverse_x (yyvsp[0], SCM_EOL);
			     scm_is_pair (p); p = scm_cdr (p))
			{
				unsmob<Score> (yyval)->
					add_output_def (unsmob<Output_def> (scm_car (p)));
			}
		}
	}
#line 4171 "./out/parser.cc"
    break;

  case 146:
#line 1165 "parser.yy"
                           {
		unsmob<Score> (yyval)->error_found_ = true;
	}
#line 4179 "./out/parser.cc"
    break;

  case 150:
#line 1178 "parser.yy"
        {
		yyval = SCM_EOL;
	}
#line 4187 "./out/parser.cc"
    break;

  case 151:
#line 1182 "parser.yy"
        {
		Output_def *od = unsmob<Output_def> (yyvsp[0]);
		if (od) {
			if (to_boolean (od->lookup_variable (ly_symbol2scm ("is-paper"))))
			{
				parser->parser_error ((yylsp[0]), _("\\paper cannot be used in \\score, use \\layout instead"));
				od = 0;
				yyvsp[0] = SCM_UNSPECIFIED;
			}
		} else if (!unsmob<Score> (yyval)) {
			if (unsmob<Music> (yyvsp[0])) {
				yyvsp[0] = Lily::scorify_music (yyvsp[0]);
			}
			if (unsmob<Score> (yyvsp[0]))
			{
				yyval = yyvsp[0];
				yyvsp[0] = SCM_UNSPECIFIED;
			}
		}
		Score *score = unsmob<Score> (yyval);
		if (score && scm_is_pair (yyvsp[-1])) {
			if (ly_is_module (scm_car (yyvsp[-1])))
			{
				score->set_header (scm_car (yyvsp[-1]));
				yyvsp[-1] = scm_cdr (yyvsp[-1]);
			}
			for (SCM p = scm_reverse_x (yyvsp[-1], SCM_EOL);
			     scm_is_pair (p); p = scm_cdr (p))
			{
				score->add_output_def (unsmob<Output_def> (scm_car (p)));
			}
		}
		if (od) {
			if (score)
				score->add_output_def (od);
			else if (scm_is_pair (yyval) && ly_is_module (scm_car (yyval)))
				scm_set_cdr_x (yyval, scm_cons (yyvsp[0], scm_cdr (yyval)));
			else
				yyval = scm_cons (yyvsp[0], yyval);
		} else if (ly_is_module (yyvsp[0])) {
			SCM module = SCM_UNSPECIFIED;
			if (score) {
				module = score->get_header ();
				if (!ly_is_module (module))
				{
					module = ly_make_module (false);
					score->set_header (module);
				}
			} else if (scm_is_pair (yyval) && ly_is_module (scm_car (yyval)))
				module = scm_car (yyval);
			else {
				module = ly_make_module (false);
				yyval = scm_cons (module, yyval);
			}
			ly_module_copy (module, yyvsp[0]);
		} else if (!scm_is_eq (yyvsp[0], SCM_UNSPECIFIED))
			parser->parser_error ((yylsp[0]), _("Spurious expression in \\score"));
	}
#line 4250 "./out/parser.cc"
    break;

  case 152:
#line 1241 "parser.yy"
        {
		if (Score *score = unsmob<Score> (yyvsp[0])) {
			if (!ly_is_module (score->get_header ()))
				score->set_header (ly_make_module (false));
			parser->lexer_->add_scope (score->get_header ());
		} else {
			if (!scm_is_pair (yyvsp[0]) || !ly_is_module (scm_car (yyvsp[0])))
				yyvsp[0] = scm_cons (ly_make_module (false), yyvsp[0]);
			parser->lexer_->add_scope (scm_car (yyvsp[0]));
		}
	}
#line 4266 "./out/parser.cc"
    break;

  case 153:
#line 1252 "parser.yy"
        {
		yyval = yyvsp[-2];
	}
#line 4274 "./out/parser.cc"
    break;

  case 154:
#line 1263 "parser.yy"
                   {
                Output_def *od = unsmob<Output_def> (yyvsp[0]);

		if (!to_boolean (od->lookup_variable (ly_symbol2scm ("is-paper"))))
		{
			parser->parser_error ((yylsp[0]), _ ("need \\paper for paper block"));
			yyval = get_paper (parser)->unprotect ();
		}
	}
#line 4288 "./out/parser.cc"
    break;

  case 155:
#line 1276 "parser.yy"
                            {
		if (scm_is_pair (yyvsp[-1]))
			yyval = scm_car (yyvsp[-1]);

		parser->lexer_->remove_scope ();
		parser->lexer_->pop_state ();
	}
#line 4300 "./out/parser.cc"
    break;

  case 156:
#line 1286 "parser.yy"
              {
                Output_def *p = get_paper (parser);
		p->input_origin_ = (yyloc);
		parser->lexer_->add_scope (p->scope_);
                yyval = p->unprotect ();
	}
#line 4311 "./out/parser.cc"
    break;

  case 157:
#line 1292 "parser.yy"
                  {
		Output_def *p = get_midi (parser);
		yyval = p->unprotect ();
		parser->lexer_->add_scope (p->scope_);
	}
#line 4321 "./out/parser.cc"
    break;

  case 158:
#line 1297 "parser.yy"
                        {
		Output_def *p = get_layout (parser);

		parser->lexer_->add_scope (p->scope_);
		yyval = p->unprotect ();
	}
#line 4332 "./out/parser.cc"
    break;

  case 159:
#line 1306 "parser.yy"
                        {
		parser->lexer_->push_initial_state ();
		yyval = yyvsp[0];
	}
#line 4341 "./out/parser.cc"
    break;

  case 162:
#line 1323 "parser.yy"
                                             {
		unsmob<Output_def> (yyvsp[-1])->input_origin_.set_spot ((yyloc));
		// This is a stupid trick to mark the beginning of the
		// body for deciding whether to allow
		// embedded_scm_active to have an output definition
		yyval = scm_list_1 (yyvsp[-1]);
	}
#line 4353 "./out/parser.cc"
    break;

  case 163:
#line 1330 "parser.yy"
                                      {
		if (scm_is_pair (yyvsp[-1]))
			yyval = scm_car (yyvsp[-1]);
	}
#line 4362 "./out/parser.cc"
    break;

  case 164:
#line 1335 "parser.yy"
        {
		// We don't switch into note mode for Scheme functions
		// here.  Does not seem warranted/required in output
		// definitions.
		if (scm_is_pair (yyvsp[-1]))
		{
			Output_def *o = unsmob<Output_def> (yyvsp[0]);
			if (o) {
				o->input_origin_.set_spot ((yyloc));
				yyvsp[-1] = o->self_scm ();
				parser->lexer_->remove_scope ();
				parser->lexer_->add_scope (o->scope_);
				yyvsp[0] = SCM_UNSPECIFIED;
			} else
				yyvsp[-1] = scm_car (yyvsp[-1]);
		}
		if (unsmob<Context_def> (yyvsp[0]))
			assign_context_def (unsmob<Output_def> (yyvsp[-1]), yyvsp[0]);
		// Seems unlikely, but let's be complete:
		else if (unsmob<Music> (yyvsp[0]))
		{
			SCM proc = parser->lexer_->lookup_identifier
				("output-def-music-handler");
			scm_call_2 (proc, yyvsp[-1], yyvsp[0]);
		} else if (!scm_is_eq (yyvsp[0], SCM_UNSPECIFIED))
			parser->parser_error ((yylsp[0]), _("bad expression type"));
		yyval = yyvsp[-1];
	}
#line 4395 "./out/parser.cc"
    break;

  case 165:
#line 1363 "parser.yy"
                                    {
		if (scm_is_pair (yyvsp[-1]))
			yyval = scm_car (yyvsp[-1]);
		// Evaluate and ignore #xxx, as opposed to \xxx
		parser->lexer_->eval_scm_token (yyvsp[0], (yylsp[0]));
	}
#line 4406 "./out/parser.cc"
    break;

  case 166:
#line 1370 "parser.yy"
        {
		if (scm_is_pair (yyvsp[0]))
			yyvsp[0] = scm_car (yyvsp[0]);
		parser->lexer_->push_note_state (Lily::pitchnames);
	}
#line 4416 "./out/parser.cc"
    break;

  case 167:
#line 1375 "parser.yy"
        {
		parser->lexer_->pop_state ();
		if (unsmob<Context_def> (yyvsp[0]))
			assign_context_def (unsmob<Output_def> (yyvsp[-2]), yyvsp[0]);
		else {

			SCM proc = parser->lexer_->lookup_identifier
				     ("output-def-music-handler");
			scm_call_2 (proc, yyvsp[-2], yyvsp[0]);
		}
		yyval = yyvsp[-2];
	}
#line 4433 "./out/parser.cc"
    break;

  case 168:
#line 1387 "parser.yy"
                                {

	}
#line 4441 "./out/parser.cc"
    break;

  case 169:
#line 1393 "parser.yy"
                                                {
		yyval = MAKE_SYNTAX (tempo, (yyloc), SCM_EOL, yyvsp[-2], yyvsp[0]);
	}
#line 4449 "./out/parser.cc"
    break;

  case 170:
#line 1396 "parser.yy"
                                                        {
		yyval = MAKE_SYNTAX (tempo, (yyloc), yyvsp[-3], yyvsp[-2], yyvsp[0]);
	}
#line 4457 "./out/parser.cc"
    break;

  case 171:
#line 1399 "parser.yy"
                     {
		yyval = MAKE_SYNTAX (tempo, (yyloc), yyvsp[0]);
	}
#line 4465 "./out/parser.cc"
    break;

  case 172:
#line 1408 "parser.yy"
                    {
		yyval = SCM_EOL;
	}
#line 4473 "./out/parser.cc"
    break;

  case 173:
#line 1411 "parser.yy"
                                    {
		if (unsmob<Music> (yyvsp[0]))
			yyval = scm_cons (yyvsp[0], yyvsp[-1]);
	}
#line 4482 "./out/parser.cc"
    break;

  case 174:
#line 1415 "parser.yy"
                           {
		Music *m = MY_MAKE_MUSIC("Music", (yyloc));
		// ugh. code dup
		m->set_property ("error-found", SCM_BOOL_T);
		yyval = scm_cons (m->self_scm (), yyvsp[-1]);
		m->unprotect (); /* UGH */
	}
#line 4494 "./out/parser.cc"
    break;

  case 175:
#line 1426 "parser.yy"
        {
		yyval = reverse_music_list (parser, (yyloc), yyvsp[-1], true, false);
	}
#line 4502 "./out/parser.cc"
    break;

  case 179:
#line 1438 "parser.yy"
        {
	        yyval = make_music_from_simple (parser, (yylsp[0]), yyvsp[0]);
                if (!unsmob<Music> (yyval))
		{
                        parser->parser_error ((yylsp[0]), _ ("music expected"));
			yyval = MAKE_SYNTAX (void_music, (yyloc));
		}
	}
#line 4515 "./out/parser.cc"
    break;

  case 182:
#line 1452 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 4523 "./out/parser.cc"
    break;

  case 183:
#line 1456 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 4531 "./out/parser.cc"
    break;

  case 184:
#line 1460 "parser.yy"
        {
		Music *n = MY_MAKE_MUSIC ("NoteEvent", (yyloc));

		parser->default_duration_ = *unsmob<Duration> (yyvsp[-1]);
		n->set_property ("duration", yyvsp[-1]);

		if (scm_is_pair (yyvsp[0]))
			n->set_property ("articulations",
					 scm_reverse_x (yyvsp[0], SCM_EOL));
		yyval = n->unprotect ();
	}
#line 4547 "./out/parser.cc"
    break;

  case 185:
#line 1475 "parser.yy"
        {
		if (scm_is_eq (yyvsp[0], SCM_UNSPECIFIED)
		    || unsmob<Music> (yyvsp[0]))
			yyval = yyvsp[0];
		else if (parser->lexer_->is_lyric_state ()
			   && Text_interface::is_markup (yyvsp[0]))
			MYBACKUP (LYRIC_ELEMENT, yyvsp[0], (yylsp[0]));
		else {
			(yyloc).warning (_ ("Ignoring non-music expression"));
			yyval = SCM_UNSPECIFIED;
		}
	}
#line 4564 "./out/parser.cc"
    break;

  case 188:
#line 1498 "parser.yy"
        {
		yyval = MAKE_SYNTAX (repeat, (yyloc), yyvsp[-2], yyvsp[-1], yyvsp[0], SCM_EOL);
	}
#line 4572 "./out/parser.cc"
    break;

  case 189:
#line 1502 "parser.yy"
        {
		yyval = MAKE_SYNTAX (repeat, (yyloc), yyvsp[-4], yyvsp[-3], yyvsp[-2], yyvsp[0]);
	}
#line 4580 "./out/parser.cc"
    break;

  case 190:
#line 1508 "parser.yy"
                                     {
		yyval = MAKE_SYNTAX (sequential_music, (yyloc), yyvsp[0]);
	}
#line 4588 "./out/parser.cc"
    break;

  case 191:
#line 1511 "parser.yy"
                            {
		yyval = MAKE_SYNTAX (sequential_music, (yyloc), yyvsp[0]);
	}
#line 4596 "./out/parser.cc"
    break;

  case 192:
#line 1517 "parser.yy"
                                       {
		yyval = MAKE_SYNTAX (simultaneous_music, (yyloc), yyvsp[0]);
	}
#line 4604 "./out/parser.cc"
    break;

  case 193:
#line 1520 "parser.yy"
                                                                {
		yyval = MAKE_SYNTAX (simultaneous_music, (yyloc),
				  reverse_music_list (parser, (yyloc), yyvsp[-1],
						      true, false));
	}
#line 4614 "./out/parser.cc"
    break;

  case 197:
#line 1535 "parser.yy"
        {
		parser->lexer_->push_note_state (Lily::pitchnames);
	}
#line 4622 "./out/parser.cc"
    break;

  case 198:
#line 1538 "parser.yy"
        {
                parser->lexer_->pop_state ();
                yyval = yyvsp[-1];
        }
#line 4631 "./out/parser.cc"
    break;

  case 199:
#line 1543 "parser.yy"
        {
		if (unsmob<Music> (yyvsp[0])) {
			SCM proc = parser->lexer_->lookup_identifier ("context-mod-music-handler");
			yyvsp[0] = scm_call_1 (proc, yyvsp[0]);
		}
		if (unsmob<Context_mod> (yyvsp[0]))
			yyval = yyvsp[0];
		else {
			// let's permit \with #*unspecified* to go for
			// an empty context mod
			if (!scm_is_eq (yyvsp[0], SCM_UNSPECIFIED))
				parser->parser_error ((yylsp[0]), _ ("not a context mod"));
			yyval = Context_mod ().smobbed_copy ();
		}
	}
#line 4651 "./out/parser.cc"
    break;

  case 202:
#line 1571 "parser.yy"
        {
		if (scm_is_pair (yyvsp[0]))
			yyval = scm_append_x (scm_reverse_x (yyvsp[0], SCM_EOL));
        }
#line 4660 "./out/parser.cc"
    break;

  case 203:
#line 1584 "parser.yy"
             {
		yyval = SCM_EOL;
	}
#line 4668 "./out/parser.cc"
    break;

  case 204:
#line 1588 "parser.yy"
        {
		if (Context_mod *m = unsmob<Context_mod> (yyvsp[0]))
			yyval = scm_cons (m->get_mods (), yyvsp[-1]);
	}
#line 4677 "./out/parser.cc"
    break;

  case 205:
#line 1600 "parser.yy"
             {
            yyval = Context_mod ().smobbed_copy ();
        }
#line 4685 "./out/parser.cc"
    break;

  case 206:
#line 1603 "parser.yy"
                                        {
		if (!SCM_UNBNDP (yyvsp[0]))
			unsmob<Context_mod> (yyvsp[-1])->add_context_mod (yyvsp[0]);
        }
#line 4694 "./out/parser.cc"
    break;

  case 207:
#line 1607 "parser.yy"
                                           {
		if (unsmob<Music> (yyvsp[0])) {
			SCM proc = parser->lexer_->lookup_identifier ("context-mod-music-handler");
			yyvsp[0] = scm_call_1 (proc, yyvsp[0]);
		}
		if (unsmob<Context_mod> (yyvsp[0]))
			unsmob<Context_mod> (yyval)->add_context_mods
				(unsmob<Context_mod> (yyvsp[0])->get_mods ());
		else if (!scm_is_eq (yyvsp[0], SCM_UNSPECIFIED))
			parser->parser_error ((yylsp[0]), _ ("not a context mod"));
        }
#line 4710 "./out/parser.cc"
    break;

  case 208:
#line 1621 "parser.yy"
                                                         {
		yyval = START_MAKE_SYNTAX (context_specification, yyvsp[-2], yyvsp[-1], yyvsp[0], SCM_BOOL_F);
	}
#line 4718 "./out/parser.cc"
    break;

  case 209:
#line 1624 "parser.yy"
                                                              {
		yyval = START_MAKE_SYNTAX (context_specification, yyvsp[-2], yyvsp[-1], yyvsp[0], SCM_BOOL_T);
	}
#line 4726 "./out/parser.cc"
    break;

  case 210:
#line 1630 "parser.yy"
                                                         {
		yyval = scm_acons (yyvsp[0], yyvsp[-1], SCM_EOL);
	}
#line 4734 "./out/parser.cc"
    break;

  case 211:
#line 1633 "parser.yy"
                                                                      {
		yyval = scm_acons (yyvsp[0], yyvsp[-1], yyvsp[-3]);
	}
#line 4742 "./out/parser.cc"
    break;

  case 215:
#line 1658 "parser.yy"
                                                  {
		yyval = MAKE_SYNTAX (lyric_combine, (yyloc), yyvsp[-1], SCM_EOL, yyvsp[0]);
	}
#line 4750 "./out/parser.cc"
    break;

  case 216:
#line 1662 "parser.yy"
        {
		yyval = MAKE_SYNTAX (lyric_combine, (yyloc), yyvsp[-1], yyvsp[-3], yyvsp[0]);
	}
#line 4758 "./out/parser.cc"
    break;

  case 220:
#line 1675 "parser.yy"
        {
		Input i;
		i.set_location ((yylsp[-2]), (yylsp[-1]));
		yyval = FINISH_MAKE_SYNTAX (yyvsp[-2], i, yyvsp[-1]);
		yyval = MAKE_SYNTAX (add_lyrics, (yyloc), yyval, scm_reverse_x (yyvsp[0], SCM_EOL));
	}
#line 4769 "./out/parser.cc"
    break;

  case 221:
#line 1682 "parser.yy"
        {
		yyval = FINISH_MAKE_SYNTAX (yyvsp[-1], (yyloc), yyvsp[0]);
	}
#line 4777 "./out/parser.cc"
    break;

  case 222:
#line 1686 "parser.yy"
        {
		yyval = FINISH_MAKE_SYNTAX (yyvsp[-1], (yyloc), yyvsp[0]);
	}
#line 4785 "./out/parser.cc"
    break;

  case 225:
#line 1695 "parser.yy"
        {
		yyval = MAKE_SYNTAX (add_lyrics, (yyloc), yyvsp[-1], scm_reverse_x (yyvsp[0], SCM_EOL));
	}
#line 4793 "./out/parser.cc"
    break;

  case 229:
#line 1707 "parser.yy"
                                        { yyval = yyvsp[0]; }
#line 4799 "./out/parser.cc"
    break;

  case 230:
#line 1708 "parser.yy"
                                        { yyval = yyvsp[0]; }
#line 4805 "./out/parser.cc"
    break;

  case 232:
#line 1767 "parser.yy"
        {
		yyval = scm_append (scm_list_2 (yyvsp[-2], scm_reverse_x (yyvsp[0], SCM_EOL)));
	}
#line 4813 "./out/parser.cc"
    break;

  case 233:
#line 1771 "parser.yy"
        {
		yyval = scm_append (scm_list_2 (yyvsp[-2], scm_reverse_x (yyvsp[0], SCM_EOL)));
	}
#line 4821 "./out/parser.cc"
    break;

  case 235:
#line 1779 "parser.yy"
        {
		yyval = scm_append_x (scm_list_2 (yyvsp[0], yyvsp[-2]));
	}
#line 4829 "./out/parser.cc"
    break;

  case 236:
#line 1783 "parser.yy"
        {
		yyval = scm_append_x (scm_list_2 (yyvsp[0], yyvsp[-2]));
	}
#line 4837 "./out/parser.cc"
    break;

  case 238:
#line 1793 "parser.yy"
        {
		yyval = make_reverse_key_list (yyvsp[0]);
		if (SCM_UNBNDP (yyval)) {
			parser->parser_error ((yylsp[0]), _("not a key"));
			yyval = SCM_EOL;
		}
	}
#line 4849 "./out/parser.cc"
    break;

  case 239:
#line 1805 "parser.yy"
        {
		yyval = scm_string_to_symbol (yyvsp[0]);
	}
#line 4857 "./out/parser.cc"
    break;

  case 241:
#line 1814 "parser.yy"
        {
		yyval = try_word_variants (Lily::key_list_p, yyvsp[0]);
		if (SCM_UNBNDP (yyval)) {
			parser->parser_error ((yylsp[0]), _("not a key"));
			yyval = SCM_EOL;
		} else
			yyval = scm_reverse (yyval);
	}
#line 4870 "./out/parser.cc"
    break;

  case 242:
#line 1823 "parser.yy"
        {
		yyval = scm_list_1 (yyvsp[0]);
	}
#line 4878 "./out/parser.cc"
    break;

  case 244:
#line 1831 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]), yyvsp[0], yyvsp[-1], yyvsp[-2]);
	}
#line 4886 "./out/parser.cc"
    break;

  case 245:
#line 1835 "parser.yy"
        {
		SCM n = scm_difference (yyvsp[0], SCM_UNDEFINED);
		if (scm_is_true (scm_call_1 (yyvsp[-3], n)))
			yyval = scm_cons (n, yyvsp[-2]);
		else {
			Music *t = MY_MAKE_MUSIC ("FingeringEvent", (yylsp[0]));
			t->set_property ("digit", yyvsp[0]);
			yyval = check_scheme_arg (parser, (yylsp[-1]), t->unprotect (),
					       yyvsp[-2], yyvsp[-3], n);
		}
	}
#line 4902 "./out/parser.cc"
    break;

  case 246:
#line 1847 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[-1]),
				       scm_difference (yyvsp[0], SCM_UNDEFINED),
				       yyvsp[-2], yyvsp[-3]);
	}
#line 4912 "./out/parser.cc"
    break;

  case 247:
#line 1853 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[-1]),
				       scm_difference (yyvsp[0], SCM_UNDEFINED),
				       yyvsp[-2], yyvsp[-3]);
	}
#line 4922 "./out/parser.cc"
    break;

  case 248:
#line 1859 "parser.yy"
        {
		if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
			yyval = scm_cons (yyvsp[0], yyvsp[-1]);
		else
			yyval = check_scheme_arg (parser, (yylsp[0]),
					       make_music_from_simple
					       (parser, (yylsp[0]), yyvsp[0]),
					       yyvsp[-1], yyvsp[-2]);
	}
#line 4936 "./out/parser.cc"
    break;

  case 249:
#line 1869 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]), yyvsp[0], yyvsp[-1], yyvsp[-2]);
	}
#line 4944 "./out/parser.cc"
    break;

  case 250:
#line 1873 "parser.yy"
        {
		if (scm_is_true (scm_call_1 (yyvsp[-1], yyvsp[0])))
			yyval = scm_cons (yyvsp[0], yyvsp[-2]);
		else
			yyval = check_scheme_arg (parser, (yylsp[0]),
					       make_music_from_simple
					       (parser, (yylsp[0]), yyvsp[0]),
					       yyvsp[-2], yyvsp[-1]);
	}
#line 4958 "./out/parser.cc"
    break;

  case 251:
#line 1883 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]), yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 4966 "./out/parser.cc"
    break;

  case 252:
#line 1887 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]), yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 4974 "./out/parser.cc"
    break;

  case 253:
#line 1891 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]), yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 4982 "./out/parser.cc"
    break;

  case 254:
#line 1895 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]), yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 4990 "./out/parser.cc"
    break;

  case 255:
#line 1899 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]), yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 4998 "./out/parser.cc"
    break;

  case 256:
#line 1903 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]), yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 5006 "./out/parser.cc"
    break;

  case 257:
#line 1911 "parser.yy"
        {
		yyval = make_music_from_simple (parser, (yyloc),
					     make_duration (yyvsp[-3], scm_to_int (yyvsp[-2]), yyvsp[-1]));
		Music *m = unsmob<Music> (yyval);
		assert (m);
		if (scm_is_pair (yyvsp[0]))
			m->set_property ("articulations",
					 scm_reverse_x (yyvsp[0], SCM_EOL));
	}
#line 5020 "./out/parser.cc"
    break;

  case 258:
#line 1924 "parser.yy"
        {
		yyval = yyvsp[-1];
		SCM res = try_string_variants (yyvsp[-2], yyvsp[0]);
		if (!SCM_UNBNDP (res))
			if (scm_is_pair (res))
				MYREPARSE ((yylsp[0]), yyvsp[-2], SYMBOL_LIST, res);
			else
				MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, res);
		else if (scm_is_true
			 (scm_call_1
			  (yyvsp[-2], make_music_from_simple
			   (parser, (yylsp[0]), yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], STRING, yyvsp[0]);
		else
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]);
	}
#line 5041 "./out/parser.cc"
    break;

  case 259:
#line 1941 "parser.yy"
        {
		yyval = yyvsp[-1];
		if (scm_is_true
		    (scm_call_1
		     (yyvsp[-2], make_music_from_simple
		      (parser, (yylsp[0]), yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], PITCH_IDENTIFIER, yyvsp[0]);
		else
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]);
	}
#line 5056 "./out/parser.cc"
    break;

  case 260:
#line 1952 "parser.yy"
        {
		yyval = yyvsp[-1];
		if (scm_is_true
		    (scm_call_1
		     (yyvsp[-2], make_music_from_simple
		      (parser, (yylsp[0]), yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], TONICNAME_PITCH, yyvsp[0]);
		else
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]);
	}
#line 5071 "./out/parser.cc"
    break;

  case 261:
#line 1963 "parser.yy"
        {
		yyval = yyvsp[-1];
		SCM res = try_string_variants (yyvsp[-2], yyvsp[0]);
		if (!SCM_UNBNDP (res))
			if (scm_is_pair (res))
				MYREPARSE ((yylsp[0]), yyvsp[-2], SYMBOL_LIST, res);
			else
				MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, res);
		else if (scm_is_true
			 (scm_call_1
			  (yyvsp[-2], make_music_from_simple
			   (parser, (yylsp[0]), yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], STRING, yyvsp[0]);
		else
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]);
	}
#line 5092 "./out/parser.cc"
    break;

  case 262:
#line 1980 "parser.yy"
        {
		yyval = yyvsp[-1];
		SCM res = try_word_variants (yyvsp[-2], yyvsp[0]);
		if (!SCM_UNBNDP (res))
			if (scm_is_pair (res))
				MYREPARSE ((yylsp[0]), yyvsp[-2], SYMBOL_LIST, res);
			else
				MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, res);
		else if (scm_is_true
			 (scm_call_1
			  (yyvsp[-2], make_music_from_simple
			   (parser, (yylsp[0]), yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], STRING, yyvsp[0]);
		else
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]);
	}
#line 5113 "./out/parser.cc"
    break;

  case 263:
#line 1997 "parser.yy"
        {
		yyval = yyvsp[-1];
		if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]);
		else if (scm_is_true
			 (scm_call_1
			  (yyvsp[-2], make_music_from_simple
			   (parser, (yylsp[0]), yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], STRING, yyvsp[0]);
		else
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]);
	}
#line 5130 "./out/parser.cc"
    break;

  case 264:
#line 2010 "parser.yy"
        {
		yyval = yyvsp[-1];
		if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
			// May be 3 \cm or similar
			MYREPARSE ((yylsp[0]), yyvsp[-2], REAL, yyvsp[0]);
		else if (scm_is_true (scm_call_1 (yyvsp[-2], scm_list_1 (yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], SYMBOL_LIST, scm_list_1 (yyvsp[0]));
		else {
			SCM d = make_duration (yyvsp[0]);
			if (!SCM_UNBNDP (d)) {
				if (scm_is_true (scm_call_1 (yyvsp[-2], d)))
					MYREPARSE ((yylsp[0]), yyvsp[-2], DURATION_IDENTIFIER, d);
				else if (scm_is_true
					 (scm_call_1
					  (yyvsp[-2], make_music_from_simple (parser, (yylsp[0]), d))))
					MYREPARSE ((yylsp[0]), yyvsp[-2], DURATION_ARG, d);
				else
					MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]); // trigger error
			} else
				MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]); // trigger error
		}
	}
#line 5157 "./out/parser.cc"
    break;

  case 265:
#line 2033 "parser.yy"
        {
		yyval = yyvsp[-1];
		if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
			MYREPARSE ((yylsp[0]), yyvsp[-2], DURATION_IDENTIFIER, yyvsp[0]);
		else if (scm_is_true
			 (scm_call_1
			  (yyvsp[-2], make_music_from_simple (parser, (yylsp[0]), yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], DURATION_ARG, yyvsp[0]);
		else
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]); // trigger error
	}
#line 5173 "./out/parser.cc"
    break;

  case 267:
#line 2052 "parser.yy"
        {
		if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
			yyval = scm_cons (yyvsp[0], yyvsp[-1]);
		else {
			yyval = make_music_from_simple (parser, (yylsp[0]), yyvsp[0]);
			if (scm_is_true (scm_call_1 (yyvsp[-2], yyval)))
				yyval = scm_cons (yyval, yyvsp[-1]);
			else
			{
				yyval = scm_cons (loc_on_copy (parser, (yylsp[-1]), yyvsp[-3]), yyvsp[-1]);
				MYBACKUP (SCM_ARG, yyvsp[0], (yylsp[0]));
			}
		}
	}
#line 5192 "./out/parser.cc"
    break;

  case 268:
#line 2067 "parser.yy"
        {
		if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
		{
			yyval = scm_cons (yyvsp[0], yyvsp[-1]);
		} else {
			yyval = scm_cons (loc_on_copy (parser, (yylsp[-1]), yyvsp[-3]), yyvsp[-1]);
			MYBACKUP (EVENT_IDENTIFIER, yyvsp[0], (yylsp[0]));
		}
	}
#line 5206 "./out/parser.cc"
    break;

  case 269:
#line 2077 "parser.yy"
        {
		if (scm_is_true
		    (scm_call_1
		     (yyvsp[-2], make_music_from_simple
		      (parser, (yylsp[0]), yyvsp[0]))))
		{
			yyval = yyvsp[-1];
			MYREPARSE ((yylsp[0]), yyvsp[-2], PITCH_IDENTIFIER, yyvsp[0]);
		} else if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
			yyval = scm_cons (yyvsp[0], yyvsp[-1]);
		else {
			yyval = scm_cons (loc_on_copy (parser, (yylsp[-1]), yyvsp[-3]), yyvsp[-1]);
			MYBACKUP (PITCH_IDENTIFIER, yyvsp[0], (yylsp[0]));
		}
	}
#line 5226 "./out/parser.cc"
    break;

  case 270:
#line 2093 "parser.yy"
        {
		if (scm_is_true
		    (scm_call_1
		     (yyvsp[-2], make_music_from_simple
		      (parser, (yylsp[0]), yyvsp[0]))))
		{
			yyval = yyvsp[-1];
			MYREPARSE ((yylsp[0]), yyvsp[-2], TONICNAME_PITCH, yyvsp[0]);
		} else if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
			yyval = scm_cons (yyvsp[0], yyvsp[-1]);
		else {
			yyval = scm_cons (loc_on_copy (parser, (yylsp[-1]), yyvsp[-3]), yyvsp[-1]);
			MYBACKUP (TONICNAME_PITCH, yyvsp[0], (yylsp[0]));
		}
	}
#line 5246 "./out/parser.cc"
    break;

  case 271:
#line 2109 "parser.yy"
        {
		if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
			yyval = scm_cons (yyvsp[0], yyvsp[-1]);
		else {
			yyval = scm_cons (loc_on_copy (parser, (yylsp[-1]), yyvsp[-3]), yyvsp[-1]);
			MYBACKUP (SCM_IDENTIFIER, yyvsp[0], (yylsp[0]));
		}
	}
#line 5259 "./out/parser.cc"
    break;

  case 272:
#line 2118 "parser.yy"
        {
		yyval = yyvsp[-1];
		if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
			// May be 3 \cm or similar
			MYREPARSE ((yylsp[0]), yyvsp[-2], REAL, yyvsp[0]);
		else if (scm_is_true (scm_call_1 (yyvsp[-2], scm_list_1 (yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], SYMBOL_LIST, scm_list_1 (yyvsp[0]));
		else {
			SCM d = make_duration (yyvsp[0]);
			if (!SCM_UNBNDP (d)) {
				if (scm_is_true (scm_call_1 (yyvsp[-2], d)))
					MYREPARSE ((yylsp[0]), yyvsp[-2], DURATION_IDENTIFIER, d);
				else if (scm_is_true
					 (scm_call_1
					  (yyvsp[-2], make_music_from_simple (parser, (yylsp[0]), d))))
					MYREPARSE ((yylsp[0]), yyvsp[-2], DURATION_ARG, d);
				else {
					yyval = scm_cons (loc_on_copy (parser, (yylsp[-1]), yyvsp[-3]), yyvsp[-1]);
					MYBACKUP (UNSIGNED, yyvsp[0], (yylsp[0]));
				}
			} else {
				yyval = scm_cons (loc_on_copy (parser, (yylsp[-1]), yyvsp[-3]), yyvsp[-1]);
				MYBACKUP (UNSIGNED, yyvsp[0], (yylsp[0]));
			}
		}
	}
#line 5290 "./out/parser.cc"
    break;

  case 273:
#line 2145 "parser.yy"
        {
		if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
		{
			yyval = yyvsp[-1];
			MYREPARSE ((yylsp[0]), yyvsp[-2], REAL, yyvsp[0]);
		} else {
			yyval = scm_cons (loc_on_copy (parser, (yylsp[-1]), yyvsp[-3]), yyvsp[-1]);
			MYBACKUP (REAL, yyvsp[0], (yylsp[0]));
		}
	}
#line 5305 "./out/parser.cc"
    break;

  case 274:
#line 2156 "parser.yy"
        {
		if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
		{
			yyval = scm_cons (yyvsp[0], yyvsp[-1]);
		} else {
			yyval = scm_cons (loc_on_copy (parser, (yylsp[-1]), yyvsp[-3]), yyvsp[-1]);
			MYBACKUP (NUMBER_IDENTIFIER, yyvsp[0], (yylsp[0]));
		}
	}
#line 5319 "./out/parser.cc"
    break;

  case 275:
#line 2166 "parser.yy"
        {
		SCM n = scm_difference (yyvsp[0], SCM_UNDEFINED);
		if (scm_is_true (scm_call_1 (yyvsp[-3], n))) {
			yyval = yyvsp[-2];
			MYREPARSE ((yylsp[0]), yyvsp[-3], REAL, n);
		} else {
			Music *t = MY_MAKE_MUSIC ("FingeringEvent", (yylsp[0]));
			t->set_property ("digit", yyvsp[0]);
			yyval = t->unprotect ();
			if (scm_is_true (scm_call_1 (yyvsp[-3], yyval)))
				yyval = scm_cons (yyval, yyvsp[-2]);
			else {
				yyval = scm_cons (loc_on_copy (parser, (yylsp[-2]), yyvsp[-4]), yyvsp[-2]);
				MYBACKUP (UNSIGNED, yyvsp[0], (yylsp[0]));
				parser->lexer_->push_extra_token ((yylsp[-1]), '-');
			}
		}
	}
#line 5342 "./out/parser.cc"
    break;

  case 276:
#line 2185 "parser.yy"
        {
		SCM n = scm_difference (yyvsp[0], SCM_UNDEFINED);
		if (scm_is_true (scm_call_1 (yyvsp[-3], n))) {
			MYREPARSE ((yylsp[0]), yyvsp[-3], REAL, n);
			yyval = yyvsp[-2];
		} else {
			yyval = scm_cons (loc_on_copy (parser, (yylsp[-2]), yyvsp[-4]), yyvsp[-2]);
			MYBACKUP (REAL, n, (yylsp[0]));
		}
	}
#line 5357 "./out/parser.cc"
    break;

  case 277:
#line 2196 "parser.yy"
        {
		SCM n = scm_difference (yyvsp[0], SCM_UNDEFINED);
		if (scm_is_true (scm_call_1 (yyvsp[-3], n))) {
			yyval = scm_cons (n, yyvsp[-2]);
		} else {
			yyval = scm_cons (loc_on_copy (parser, (yylsp[-2]), yyvsp[-4]), yyvsp[-2]);
			MYBACKUP (NUMBER_IDENTIFIER, n, (yylsp[0]));
		}
	}
#line 5371 "./out/parser.cc"
    break;

  case 278:
#line 2206 "parser.yy"
        {
		yyval = yyvsp[-1];
		if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
			MYREPARSE ((yylsp[0]), yyvsp[-2], DURATION_IDENTIFIER, yyvsp[0]);
		else if (scm_is_true
			 (scm_call_1
			  (yyvsp[-2], make_music_from_simple (parser, (yylsp[0]), yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], DURATION_ARG, yyvsp[0]);
		else {
			yyval = scm_cons (loc_on_copy (parser, (yylsp[-1]), yyvsp[-3]), yyvsp[-1]);
			MYBACKUP (DURATION_IDENTIFIER, yyvsp[0], (yylsp[0]));
		}
	}
#line 5389 "./out/parser.cc"
    break;

  case 279:
#line 2220 "parser.yy"
        {
		SCM res = try_string_variants (yyvsp[-2], yyvsp[0]);
		if (!SCM_UNBNDP (res))
			if (scm_is_pair (res)) {
				yyval = yyvsp[-1];
				MYREPARSE ((yylsp[0]), yyvsp[-2], SYMBOL_LIST, res);
			}
			else
				yyval = scm_cons (res, yyvsp[-1]);
		else {
			yyval = scm_cons (loc_on_copy (parser, (yylsp[-1]), yyvsp[-3]), yyvsp[-1]);
			MYBACKUP (SCM_IDENTIFIER, yyvsp[0], (yylsp[0]));
		}
	}
#line 5408 "./out/parser.cc"
    break;

  case 280:
#line 2235 "parser.yy"
        {
		SCM res = try_string_variants (yyvsp[-2], yyvsp[0]);
		if (!SCM_UNBNDP (res))
			if (scm_is_pair (res)) {
				yyval = yyvsp[-1];
				MYREPARSE ((yylsp[0]), yyvsp[-2], SYMBOL_LIST, res);
			}
			else
				yyval = scm_cons (res, yyvsp[-1]);
		else {
			yyval = scm_cons (loc_on_copy (parser, (yylsp[-1]), yyvsp[-3]), yyvsp[-1]);
			MYBACKUP (STRING, yyvsp[0], (yylsp[0]));
		}
	}
#line 5427 "./out/parser.cc"
    break;

  case 281:
#line 2250 "parser.yy"
        {
		SCM res = try_word_variants (yyvsp[-2], yyvsp[0]);
		if (!SCM_UNBNDP (res))
			if (scm_is_pair (res)) {
				yyval = yyvsp[-1];
				MYREPARSE ((yylsp[0]), yyvsp[-2], SYMBOL_LIST, res);
			}
			else
				yyval = scm_cons (res, yyvsp[-1]);
		else {
			yyval = scm_cons (loc_on_copy (parser, (yylsp[-1]), yyvsp[-3]), yyvsp[-1]);
			MYBACKUP (STRING, yyvsp[0], (yylsp[0]));
		}
	}
#line 5446 "./out/parser.cc"
    break;

  case 282:
#line 2265 "parser.yy"
        {
		if (scm_is_true (scm_call_1 (yyvsp[-1], yyvsp[0])))
			yyval = scm_cons (yyvsp[0], yyvsp[-2]);
		else
			yyval = check_scheme_arg (parser, (yylsp[0]),
					       make_music_from_simple
					       (parser, (yylsp[0]), yyvsp[0]),
					       yyvsp[-2], yyvsp[-1]);
	}
#line 5460 "./out/parser.cc"
    break;

  case 283:
#line 2275 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]),
				       yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 5469 "./out/parser.cc"
    break;

  case 284:
#line 2280 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]),
				       yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 5478 "./out/parser.cc"
    break;

  case 285:
#line 2285 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]),
				       yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 5487 "./out/parser.cc"
    break;

  case 286:
#line 2290 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]), yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 5495 "./out/parser.cc"
    break;

  case 288:
#line 2298 "parser.yy"
        {
		yyval = scm_cons (loc_on_copy (parser, (yylsp[0]), yyvsp[-3]), yyvsp[-1]);
	}
#line 5503 "./out/parser.cc"
    break;

  case 290:
#line 2306 "parser.yy"
        {
		yyval = scm_cons (loc_on_copy (parser, (yylsp[0]), yyvsp[-2]), yyvsp[0]);
	}
#line 5511 "./out/parser.cc"
    break;

  case 291:
#line 2325 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 5519 "./out/parser.cc"
    break;

  case 292:
#line 2329 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 5527 "./out/parser.cc"
    break;

  case 293:
#line 2333 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 5535 "./out/parser.cc"
    break;

  case 294:
#line 2337 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 5543 "./out/parser.cc"
    break;

  case 295:
#line 2344 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 5551 "./out/parser.cc"
    break;

  case 296:
#line 2348 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 5559 "./out/parser.cc"
    break;

  case 297:
#line 2352 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 5567 "./out/parser.cc"
    break;

  case 298:
#line 2356 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 5575 "./out/parser.cc"
    break;

  case 299:
#line 2362 "parser.yy"
                            {
		yyval = SCM_EOL;
	}
#line 5583 "./out/parser.cc"
    break;

  case 300:
#line 2366 "parser.yy"
        {
		if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
			yyval = scm_cons (yyvsp[0], yyvsp[-1]);
		else
			yyval = check_scheme_arg (parser, (yylsp[0]),
					       make_music_from_simple
					       (parser, (yylsp[0]), yyvsp[0]),
					       yyvsp[-1], yyvsp[-2]);
	}
#line 5597 "./out/parser.cc"
    break;

  case 301:
#line 2376 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]),
				       yyvsp[0], yyvsp[-1], yyvsp[-2]);
	}
#line 5606 "./out/parser.cc"
    break;

  case 302:
#line 2381 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]),
				       yyvsp[0], yyvsp[-1], yyvsp[-2]);
	}
#line 5615 "./out/parser.cc"
    break;

  case 303:
#line 2386 "parser.yy"
        {
		SCM n = scm_difference (yyvsp[0], SCM_UNDEFINED);
		yyval = check_scheme_arg (parser, (yylsp[0]), n, yyvsp[-2], yyvsp[-3]);
	}
#line 5624 "./out/parser.cc"
    break;

  case 304:
#line 2391 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]),
				       yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 5633 "./out/parser.cc"
    break;

  case 305:
#line 2396 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]),
				       yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 5642 "./out/parser.cc"
    break;

  case 306:
#line 2401 "parser.yy"
        {
		if (scm_is_true (scm_call_1 (yyvsp[-1], yyvsp[0])))
			yyval = scm_cons (yyvsp[0], yyvsp[-2]);
		else
			yyval = check_scheme_arg (parser, (yylsp[0]),
					       make_music_from_simple
					       (parser, (yylsp[0]), yyvsp[0]),
					       yyvsp[-2], yyvsp[-1]);
	}
#line 5656 "./out/parser.cc"
    break;

  case 307:
#line 2411 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]),
				       yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 5665 "./out/parser.cc"
    break;

  case 308:
#line 2416 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]),
				       yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 5674 "./out/parser.cc"
    break;

  case 309:
#line 2421 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]),
				       yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 5683 "./out/parser.cc"
    break;

  case 310:
#line 2426 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]), yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 5691 "./out/parser.cc"
    break;

  case 311:
#line 2433 "parser.yy"
        {
		yyval = yyvsp[-1];
		SCM res = try_string_variants (yyvsp[-2], yyvsp[0]);
		if (!SCM_UNBNDP (res))
			if (scm_is_pair (res))
				MYREPARSE ((yylsp[0]), yyvsp[-2], SYMBOL_LIST, res);
			else
				MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, res);
		else if (scm_is_true
			 (scm_call_1
			  (yyvsp[-2], make_music_from_simple (parser, (yylsp[0]), yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], LYRIC_ELEMENT, yyvsp[0]);
		else
			// This is going to flag a syntax error, we
			// know the predicate to be false.
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]);
	}
#line 5713 "./out/parser.cc"
    break;

  case 312:
#line 2451 "parser.yy"
        {
		yyval = yyvsp[-1];
		if (scm_is_true
		    (scm_call_1
		     (yyvsp[-2], make_music_from_simple
		      (parser, (yylsp[0]), yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], PITCH_IDENTIFIER, yyvsp[0]);
		else
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]);
	}
#line 5728 "./out/parser.cc"
    break;

  case 313:
#line 2462 "parser.yy"
        {
		yyval = yyvsp[-1];
		if (scm_is_true
		    (scm_call_1
		     (yyvsp[-2], make_music_from_simple
		      (parser, (yylsp[0]), yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], TONICNAME_PITCH, yyvsp[0]);
		else
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]);
	}
#line 5743 "./out/parser.cc"
    break;

  case 314:
#line 2473 "parser.yy"
        {
		yyval = yyvsp[-1];
		SCM res = try_string_variants (yyvsp[-2], yyvsp[0]);
		if (!SCM_UNBNDP (res))
			if (scm_is_pair (res))
				MYREPARSE ((yylsp[0]), yyvsp[-2], SYMBOL_LIST, res);
			else
				MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, res);
		else if (scm_is_true
			 (scm_call_1
			  (yyvsp[-2], make_music_from_simple (parser, (yylsp[0]), yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], LYRIC_ELEMENT, yyvsp[0]);
		else
			// This is going to flag a syntax error, we
			// know the predicate to be false.
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]);
	}
#line 5765 "./out/parser.cc"
    break;

  case 315:
#line 2491 "parser.yy"
        {
		yyval = yyvsp[-1];
		SCM res = try_word_variants (yyvsp[-2], yyvsp[0]);
		if (!SCM_UNBNDP (res))
			if (scm_is_pair (res))
				MYREPARSE ((yylsp[0]), yyvsp[-2], SYMBOL_LIST, res);
			else
				MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, res);
		else if (scm_is_true
			 (scm_call_1
			  (yyvsp[-2], make_music_from_simple (parser, (yylsp[0]), yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], LYRIC_ELEMENT, yyvsp[0]);
		else
			// This is going to flag a syntax error, we
			// know the predicate to be false.
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]);
	}
#line 5787 "./out/parser.cc"
    break;

  case 316:
#line 2509 "parser.yy"
        {
		yyval = yyvsp[-1];
		if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]);
		else if (scm_is_true
			 (scm_call_1
			  (yyvsp[-2], make_music_from_simple (parser, (yylsp[0]), yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], LYRIC_ELEMENT, yyvsp[0]);
		else
			// This is going to flag a syntax error, we
			// know the predicate to be false.
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]);
	}
#line 5805 "./out/parser.cc"
    break;

  case 317:
#line 2523 "parser.yy"
        {
		yyval = yyvsp[-1];
		if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
			// May be 3 \cm or similar
			MYREPARSE ((yylsp[0]), yyvsp[-2], REAL, yyvsp[0]);
		else if (scm_is_true (scm_call_1 (yyvsp[-2], scm_list_1 (yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], SYMBOL_LIST, scm_list_1 (yyvsp[0]));
		else {
			SCM d = make_duration (yyvsp[0]);
			if (!SCM_UNBNDP (d)) {
				if (scm_is_true (scm_call_1 (yyvsp[-2], d)))
					MYREPARSE ((yylsp[0]), yyvsp[-2], DURATION_IDENTIFIER, d);
				else if (scm_is_true
					 (scm_call_1
					  (yyvsp[-2], make_music_from_simple (parser, (yylsp[0]), d))))
					MYREPARSE ((yylsp[0]), yyvsp[-2], DURATION_ARG, d);
				else
					MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]); // trigger error
			} else
				MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]); // trigger error
		}
	}
#line 5832 "./out/parser.cc"
    break;

  case 318:
#line 2546 "parser.yy"
        {
		yyval = yyvsp[-1];
		if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
			MYREPARSE ((yylsp[0]), yyvsp[-2], DURATION_IDENTIFIER, yyvsp[0]);
		else if (scm_is_true
			 (scm_call_1
			  (yyvsp[-2], make_music_from_simple (parser, (yylsp[0]), yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], DURATION_ARG, yyvsp[0]);
		else
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]); // trigger error
	}
#line 5848 "./out/parser.cc"
    break;

  case 319:
#line 2558 "parser.yy"
        {
		yyval = yyvsp[-2];
		SCM n = scm_difference (yyvsp[0], SCM_UNDEFINED);
		if (scm_is_true (scm_call_1 (yyvsp[-3], n)))
			MYREPARSE ((yylsp[0]), yyvsp[-3], REAL, n);
		else {
			Music *t = MY_MAKE_MUSIC ("FingeringEvent", (yylsp[0]));
			t->set_property ("digit", yyvsp[0]);
			SCM m = t->unprotect ();
			if (scm_is_true (scm_call_1 (yyvsp[-3], m)))
				MYREPARSE ((yylsp[0]), yyvsp[-3], SCM_ARG, m);
			else
				MYREPARSE ((yylsp[0]), yyvsp[-3], SCM_ARG, yyvsp[0]);
		}
	}
#line 5868 "./out/parser.cc"
    break;

  case 320:
#line 2574 "parser.yy"
        {
		yyval = yyvsp[-2];
		SCM n = scm_difference (yyvsp[0], SCM_UNDEFINED);
		MYREPARSE ((yylsp[0]), yyvsp[-3], REAL, n);
	}
#line 5878 "./out/parser.cc"
    break;

  case 322:
#line 2584 "parser.yy"
        {
		yyval = scm_cons (loc_on_copy (parser, (yylsp[0]), yyvsp[-3]), yyvsp[-1]);
	}
#line 5886 "./out/parser.cc"
    break;

  case 325:
#line 2593 "parser.yy"
        {
		yyval = scm_cons (loc_on_copy (parser, (yylsp[0]), yyvsp[-2]), yyvsp[0]);
	}
#line 5894 "./out/parser.cc"
    break;

  case 326:
#line 2599 "parser.yy"
                                        {
		yyval = MAKE_SYNTAX (music_function, (yyloc),
				  yyvsp[-1], yyvsp[0]);
	}
#line 5903 "./out/parser.cc"
    break;

  case 327:
#line 2607 "parser.yy"
             { yyval = SCM_EOL; }
#line 5909 "./out/parser.cc"
    break;

  case 328:
#line 2608 "parser.yy"
                            {
		yyval = yyvsp[0];
	}
#line 5917 "./out/parser.cc"
    break;

  case 329:
#line 2620 "parser.yy"
        {
		parser->lexer_->push_lyric_state ();
	}
#line 5925 "./out/parser.cc"
    break;

  case 330:
#line 2623 "parser.yy"
        {
		parser->lexer_->pop_state ();
		yyval = yyvsp[0];
	}
#line 5934 "./out/parser.cc"
    break;

  case 332:
#line 2631 "parser.yy"
                                              {
		if (scm_is_eq (yyvsp[-1], ly_symbol2scm ("chords")))
		{
		  yyval = MAKE_SYNTAX (unrelativable_music, (yyloc), yyvsp[0]);
		}
		else
		{
		  yyval = yyvsp[0];
		}
		parser->lexer_->pop_state ();
	}
#line 5950 "./out/parser.cc"
    break;

  case 333:
#line 2642 "parser.yy"
                                                                                   {
		yyval = MAKE_SYNTAX (context_specification, (yyloc), yyvsp[-2], SCM_EOL, yyvsp[-1], SCM_BOOL_T, yyvsp[0]);
		if (scm_is_eq (yyvsp[-2], ly_symbol2scm ("ChordNames")))
		{
		  yyval = MAKE_SYNTAX (unrelativable_music, (yyloc), yyval);
		}
		parser->lexer_->pop_state ();
	}
#line 5963 "./out/parser.cc"
    break;

  case 334:
#line 2653 "parser.yy"
                 {
		parser->lexer_->push_note_state (Lily::pitchnames);

		yyval = ly_symbol2scm ("notes");
	}
#line 5973 "./out/parser.cc"
    break;

  case 335:
#line 2659 "parser.yy"
                {
		parser->lexer_->push_note_state (Lily::drum_pitch_names);

		yyval = ly_symbol2scm ("drums");
	}
#line 5983 "./out/parser.cc"
    break;

  case 336:
#line 2664 "parser.yy"
                     {
		parser->lexer_->push_figuredbass_state ();

		yyval = ly_symbol2scm ("figures");
	}
#line 5993 "./out/parser.cc"
    break;

  case 337:
#line 2669 "parser.yy"
                    {
		parser->lexer_->chordmodifier_tab_ =
			alist_to_hashq (Lily::chordmodifiers);
		parser->lexer_->push_chord_state (Lily::pitchnames);
		yyval = ly_symbol2scm ("chords");

	}
#line 6005 "./out/parser.cc"
    break;

  case 338:
#line 2677 "parser.yy"
                { parser->lexer_->push_lyric_state ();
		yyval = ly_symbol2scm ("lyrics");
	}
#line 6013 "./out/parser.cc"
    break;

  case 339:
#line 2683 "parser.yy"
              {
		parser->lexer_->push_note_state (Lily::drum_pitch_names);

		yyval = ly_symbol2scm ("DrumStaff");
	}
#line 6023 "./out/parser.cc"
    break;

  case 340:
#line 2688 "parser.yy"
                  {
		parser->lexer_->push_figuredbass_state ();

		yyval = ly_symbol2scm ("FiguredBass");
	}
#line 6033 "./out/parser.cc"
    break;

  case 341:
#line 2693 "parser.yy"
                 {
		parser->lexer_->chordmodifier_tab_ =
			alist_to_hashq (Lily::chordmodifiers);
		parser->lexer_->push_chord_state (Lily::pitchnames);
		yyval = ly_symbol2scm ("ChordNames");
	}
#line 6044 "./out/parser.cc"
    break;

  case 342:
#line 2700 "parser.yy"
                { parser->lexer_->push_lyric_state ();
		yyval = ly_symbol2scm ("Lyrics");
	}
#line 6052 "./out/parser.cc"
    break;

  case 343:
#line 2706 "parser.yy"
                                         {
		yyval = MAKE_SYNTAX (context_change, (yyloc), yyvsp[-2], yyvsp[0]);
	}
#line 6060 "./out/parser.cc"
    break;

  case 344:
#line 2713 "parser.yy"
                         {
		yyval = scm_reverse_x (yyvsp[0], SCM_EOL);
	}
#line 6068 "./out/parser.cc"
    break;

  case 345:
#line 2719 "parser.yy"
                          {
		yyval = scm_list_3 (ly_symbol2scm ("assign"), yyvsp[-2], yyvsp[0]);
	}
#line 6076 "./out/parser.cc"
    break;

  case 346:
#line 2722 "parser.yy"
                       {
		yyval = scm_list_2 (ly_symbol2scm ("unset"), yyvsp[0]);
	}
#line 6084 "./out/parser.cc"
    break;

  case 347:
#line 2725 "parser.yy"
                                         {
		if (scm_ilength (yyvsp[-2]) < 2) {
			parser->parser_error ((yylsp[-2]), _("bad grob property path"));
			yyval = SCM_UNDEFINED;
		} else {
			yyval = scm_cons (ly_symbol2scm ("push"),
				       scm_cons2 (scm_car (yyvsp[-2]),
						  yyvsp[0],
						  scm_cdr (yyvsp[-2])));
		}
	}
#line 6100 "./out/parser.cc"
    break;

  case 348:
#line 2736 "parser.yy"
                            {
		yyval = scm_cons (ly_symbol2scm ("pop"), yyvsp[0]);
	}
#line 6108 "./out/parser.cc"
    break;

  case 349:
#line 2766 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 6116 "./out/parser.cc"
    break;

  case 350:
#line 2773 "parser.yy"
        {
		if (scm_is_null (yyvsp[0])
		    || scm_is_null (scm_cdr (yyvsp[0])))
			MYBACKUP (SCM_ARG, yyvsp[0], (yylsp[0]));
		else
			MYBACKUP (SYMBOL_LIST, scm_reverse_x (yyvsp[0], SCM_EOL), (yylsp[0]));
	}
#line 6128 "./out/parser.cc"
    break;

  case 352:
#line 2786 "parser.yy"
        {
		yyval = scm_append_x (scm_list_2 (yyvsp[0], yyvsp[-2]));
	}
#line 6136 "./out/parser.cc"
    break;

  case 353:
#line 2790 "parser.yy"
        {
		yyval = scm_append_x (scm_list_2 (yyvsp[0], yyvsp[-2]));
	}
#line 6144 "./out/parser.cc"
    break;

  case 354:
#line 2794 "parser.yy"
        {
		yyval = scm_append_x (scm_list_2 (yyvsp[0], yyvsp[-1]));
	}
#line 6152 "./out/parser.cc"
    break;

  case 355:
#line 2800 "parser.yy"
                 { yyval = ly_symbol2scm ("consists"); }
#line 6158 "./out/parser.cc"
    break;

  case 356:
#line 2801 "parser.yy"
                 { yyval = ly_symbol2scm ("remove"); }
#line 6164 "./out/parser.cc"
    break;

  case 357:
#line 2803 "parser.yy"
                  { yyval = ly_symbol2scm ("accepts"); }
#line 6170 "./out/parser.cc"
    break;

  case 358:
#line 2804 "parser.yy"
                       { yyval = ly_symbol2scm ("default-child"); }
#line 6176 "./out/parser.cc"
    break;

  case 359:
#line 2805 "parser.yy"
                 { yyval = ly_symbol2scm ("denies"); }
#line 6182 "./out/parser.cc"
    break;

  case 360:
#line 2807 "parser.yy"
                { yyval = ly_symbol2scm ("alias"); }
#line 6188 "./out/parser.cc"
    break;

  case 361:
#line 2808 "parser.yy"
               { yyval = ly_symbol2scm ("translator-type"); }
#line 6194 "./out/parser.cc"
    break;

  case 362:
#line 2809 "parser.yy"
                      { yyval = ly_symbol2scm ("description"); }
#line 6200 "./out/parser.cc"
    break;

  case 363:
#line 2810 "parser.yy"
               { yyval = ly_symbol2scm ("context-name"); }
#line 6206 "./out/parser.cc"
    break;

  case 364:
#line 2814 "parser.yy"
                           { yyval = yyvsp[0]; }
#line 6212 "./out/parser.cc"
    break;

  case 365:
#line 2815 "parser.yy"
                                 {
		yyval = scm_list_2 (yyvsp[-1], yyvsp[0]);
	}
#line 6220 "./out/parser.cc"
    break;

  case 366:
#line 2818 "parser.yy"
                                 {
		yyval = scm_list_2 (yyvsp[-1], yyvsp[0]);
	}
#line 6228 "./out/parser.cc"
    break;

  case 367:
#line 2822 "parser.yy"
        {
		if (!scm_is_string (yyvsp[0])
		    && !scm_is_eq (yyvsp[-1], ly_symbol2scm ("consists"))
		    && !scm_is_eq (yyvsp[-1], ly_symbol2scm ("remove")))
		{
			yyval = SCM_EOL;
			parser->parser_error ((yylsp[-1]), _ ("only \\consists and \\remove take non-string argument."));
		}
		else
		{
			yyval = scm_list_2 (yyvsp[-1], yyvsp[0]);
		}
	}
#line 6246 "./out/parser.cc"
    break;

  case 368:
#line 2840 "parser.yy"
        {
		SCM l = scm_reverse_x (yyvsp[0], SCM_EOL);
		if (scm_is_pair (l)
		    && to_boolean
		    (scm_object_property (scm_car (l),
					  ly_symbol2scm ("is-grob?"))))
			l = scm_cons (ly_symbol2scm ("Bottom"), l);
		if (scm_is_null (l) || scm_is_null (scm_cdr (l))) {
			parser->parser_error ((yylsp[0]), _ ("bad grob property path"));
			l = SCM_UNDEFINED;
		}
		yyval = l;
	}
#line 6264 "./out/parser.cc"
    break;

  case 369:
#line 2858 "parser.yy"
        {
		if (!SCM_UNBNDP (yyvsp[0]) && scm_is_null (scm_cddr (yyvsp[0])))
		{
			parser->parser_error ((yylsp[0]), _ ("bad grob property path"));
			yyval = SCM_UNDEFINED;
		}
	}
#line 6276 "./out/parser.cc"
    break;

  case 370:
#line 2866 "parser.yy"
        {
		if (!SCM_UNBNDP (yyvsp[-1])) {
			yyval = scm_append_x (scm_list_2 (yyvsp[-1], yyvsp[0]));
			if (scm_is_null (scm_cddr (yyval))) {
				parser->parser_error ((yyloc), _ ("bad grob property path"));
				yyval = SCM_UNDEFINED;
			}
		}

	}
#line 6291 "./out/parser.cc"
    break;

  case 371:
#line 2881 "parser.yy"
        {
		SCM l = scm_reverse_x (yyvsp[0], SCM_EOL);
		switch (scm_ilength (l)) {
		case 1:
			l = scm_cons (ly_symbol2scm ("Bottom"), l);
		case 2:
			break;
		default:
			parser->parser_error ((yylsp[0]), _ ("bad context property path"));
			l = SCM_UNDEFINED;
		}
		yyval = l;
	}
#line 6309 "./out/parser.cc"
    break;

  case 372:
#line 2913 "parser.yy"
        {
		yyvsp[0] = scm_reverse_x (yyvsp[0], SCM_EOL);
		if (scm_is_null (yyvsp[0])
		    || to_boolean
		    (scm_object_property (scm_car (yyvsp[0]),
					  ly_symbol2scm ("is-grob?")))) {
			yyval = ly_symbol2scm ("Bottom");
			parser->lexer_->push_extra_token ((yylsp[0]), SCM_IDENTIFIER, yyvsp[0]);
		} else {
			yyval = scm_car (yyvsp[0]);
			parser->lexer_->push_extra_token ((yylsp[0]), SCM_IDENTIFIER,
							  scm_cdr (yyvsp[0]));
		}
	}
#line 6328 "./out/parser.cc"
    break;

  case 373:
#line 2930 "parser.yy"
                                           {
		if (SCM_UNBNDP (yyvsp[-2]))
			yyval = MAKE_SYNTAX (void_music, (yyloc));
		else
			yyval = MAKE_SYNTAX (property_override, (yyloc),
					  scm_car (yyvsp[-2]),
					  scm_cdr (yyvsp[-2]),
					  yyvsp[0]);
	}
#line 6342 "./out/parser.cc"
    break;

  case 374:
#line 2939 "parser.yy"
                                                  {
		yyval = MAKE_SYNTAX (property_revert, (yyloc), yyvsp[-1], yyvsp[0]);
	}
#line 6350 "./out/parser.cc"
    break;

  case 375:
#line 2942 "parser.yy"
                                           {
		if (SCM_UNBNDP (yyvsp[-2]))
			yyval = MAKE_SYNTAX (void_music, (yyloc));
		else
			yyval = MAKE_SYNTAX (property_set, (yyloc),
					  scm_car (yyvsp[-2]),
					  scm_cadr (yyvsp[-2]),
					  yyvsp[0]);
	}
#line 6364 "./out/parser.cc"
    break;

  case 376:
#line 2951 "parser.yy"
                                  {
		if (SCM_UNBNDP (yyvsp[0]))
			yyval = MAKE_SYNTAX (void_music, (yyloc));
		else
			yyval = MAKE_SYNTAX (property_unset, (yyloc),
					  scm_car (yyvsp[0]),
					  scm_cadr (yyvsp[0]));
	}
#line 6377 "./out/parser.cc"
    break;

  case 383:
#line 2972 "parser.yy"
        {
		if (Text_interface::is_markup (yyvsp[0])) {
			yyval = yyvsp[0];
		} else {
			parser->parser_error ((yylsp[0]), (_ ("markup expected")));
			yyval = scm_string (SCM_EOL);
		}
	}
#line 6390 "./out/parser.cc"
    break;

  case 386:
#line 2985 "parser.yy"
        {
		if (scm_is_string (yyvsp[0])) {
			yyval = yyvsp[0];
		} else {
			parser->parser_error ((yylsp[0]), (_ ("simple string expected")));
			yyval = scm_string (SCM_EOL);
		}
	}
#line 6403 "./out/parser.cc"
    break;

  case 387:
#line 2996 "parser.yy"
               {
		yyval = scm_string_to_symbol (yyvsp[0]);
	}
#line 6411 "./out/parser.cc"
    break;

  case 388:
#line 3000 "parser.yy"
        {
		if (!is_regular_identifier (yyvsp[0], false))
			parser->parser_error ((yylsp[0]), (_ ("symbol expected")));
		yyval = scm_string_to_symbol (yyvsp[0]);
	}
#line 6421 "./out/parser.cc"
    break;

  case 389:
#line 3006 "parser.yy"
        {
		// This is a bit of overkill but makes the same
		// routine responsible for all symbol interpretations.
		yyval = try_string_variants (Guile_user::symbol_p, yyvsp[0]);
		if (SCM_UNBNDP (yyval))
		{
			parser->parser_error ((yylsp[0]), (_ ("symbol expected")));
			// Generate a unique symbol in case it is used
			// for an assignment or similar
			yyval = scm_make_symbol (ly_string2scm ("undefined"));
		}
	}
#line 6438 "./out/parser.cc"
    break;

  case 394:
#line 3033 "parser.yy"
        {
		yyval = scm_difference (yyvsp[0], SCM_UNDEFINED);
	}
#line 6446 "./out/parser.cc"
    break;

  case 396:
#line 3038 "parser.yy"
        {
		yyval = scm_reverse_x (yyvsp[-2], yyvsp[0]);
	}
#line 6454 "./out/parser.cc"
    break;

  case 397:
#line 3042 "parser.yy"
        {
		yyval = scm_reverse_x (yyvsp[-2], yyvsp[0]);
	}
#line 6462 "./out/parser.cc"
    break;

  case 398:
#line 3048 "parser.yy"
                                   {
		// Let the rhythmic music iterator sort this mess out.
		if (scm_is_pair (yyvsp[0])) {
			unsmob<Music> (yyval)->set_property ("articulations",
							 scm_reverse_x (yyvsp[0], SCM_EOL));
		}
	}
#line 6474 "./out/parser.cc"
    break;

  case 399:
#line 3055 "parser.yy"
                                                                  {
		yyval = MAKE_SYNTAX (repetition_chord, (yyloc),
				  yyvsp[-1], scm_reverse_x (yyvsp[0], SCM_EOL));
	}
#line 6483 "./out/parser.cc"
    break;

  case 400:
#line 3059 "parser.yy"
                                                                    {
		yyval = MAKE_SYNTAX (multi_measure_rest, (yyloc), yyvsp[-1],
				  scm_reverse_x (yyvsp[0], SCM_EOL));
	}
#line 6492 "./out/parser.cc"
    break;

  case 403:
#line 3070 "parser.yy"
        {
		Music *m = unsmob<Music> (yyvsp[-2]);
		SCM dur = unsmob<Duration> (yyvsp[-1])->smobbed_copy ();
		SCM es = m->get_property ("elements");
		SCM postevs = scm_reverse_x (yyvsp[0], SCM_EOL);

		for (SCM s = es; scm_is_pair (s); s = scm_cdr (s))
		  unsmob<Music> (scm_car (s))->set_property ("duration", dur);
		es = ly_append2 (es, postevs);

		m->set_property ("elements", es);
		m->set_spot (parser->lexer_->override_input ((yyloc)));
		yyval = m->self_scm ();
	}
#line 6511 "./out/parser.cc"
    break;

  case 404:
#line 3088 "parser.yy"
        {
		yyval = MAKE_SYNTAX (event_chord, (yyloc),
				  reverse_music_list (parser, (yyloc),
						      yyvsp[-1], false, false));
	}
#line 6521 "./out/parser.cc"
    break;

  case 405:
#line 3094 "parser.yy"
        {
		yyval = MAKE_SYNTAX (event_chord, (yyloc), scm_reverse_x (yyvsp[-1], SCM_EOL));
	}
#line 6529 "./out/parser.cc"
    break;

  case 406:
#line 3100 "parser.yy"
                                { yyval = SCM_EOL; }
#line 6535 "./out/parser.cc"
    break;

  case 407:
#line 3101 "parser.yy"
                                                 {
		if (unsmob<Music> (yyvsp[0]))
			yyval = scm_cons (yyvsp[0], yyvsp[-1]);
	}
#line 6544 "./out/parser.cc"
    break;

  case 408:
#line 3109 "parser.yy"
        {
		bool q = to_boolean (yyvsp[-2]);
		bool ex = to_boolean (yyvsp[-3]);
		SCM check = yyvsp[-1];
		SCM post = yyvsp[0];

		Music *n = MY_MAKE_MUSIC ("NoteEvent", (yyloc));
		n->set_property ("pitch", yyvsp[-4]);
		if (q)
			n->set_property ("cautionary", SCM_BOOL_T);
                if (ex || q)
			n->set_property ("force-accidental", SCM_BOOL_T);

		if (scm_is_pair (post)) {
			SCM arts = scm_reverse_x (post, SCM_EOL);
			n->set_property ("articulations", arts);
		}
		if (scm_is_number (check))
		{
			int q = scm_to_int (check);
			n->set_property ("absolute-octave", scm_from_int (q-1));
		}

		yyval = n->unprotect ();
	}
#line 6574 "./out/parser.cc"
    break;

  case 409:
#line 3134 "parser.yy"
                                           {
		Music *n = MY_MAKE_MUSIC ("NoteEvent", (yyloc));
		n->set_property ("drum-type", yyvsp[-1]);

		if (scm_is_pair (yyvsp[0])) {
			SCM arts = scm_reverse_x (yyvsp[0], SCM_EOL);
			n->set_property ("articulations", arts);
		}
		yyval = n->unprotect ();
	}
#line 6589 "./out/parser.cc"
    break;

  case 410:
#line 3145 "parser.yy"
        {
		Music *m = unsmob<Music> (yyvsp[0]);

		if (m && !m->is_mus_type ("post-event")) {
			while (m && m->is_mus_type ("music-wrapper-music")) {
				yyval = m->get_property ("element");
				m = unsmob<Music> (yyval);
			}

			if (!(m && m->is_mus_type ("rhythmic-event"))) {
				parser->parser_error ((yyloc), _ ("not a rhythmic event"));
				yyval = SCM_UNSPECIFIED;
			}
		}
	}
#line 6609 "./out/parser.cc"
    break;

  case 415:
#line 3170 "parser.yy"
                                        {
		yyval = MAKE_SYNTAX (music_function, (yyloc),
				  yyvsp[-1], yyvsp[0]);
	}
#line 6618 "./out/parser.cc"
    break;

  case 416:
#line 3177 "parser.yy"
                    {
		yyval = SCM_EOL;
	}
#line 6626 "./out/parser.cc"
    break;

  case 417:
#line 3180 "parser.yy"
                                 {
		yyval = yyvsp[-1];
		if (Music *m = unsmob<Music> (yyvsp[0]))
		{
			if (m->is_mus_type ("post-event-wrapper"))
			{
				for (SCM p = m->get_property ("elements");
				     scm_is_pair (p);
				     p = scm_cdr (p))
				{
					yyval = scm_cons (scm_car (p), yyval);
				}
			} else {
				m->set_spot (parser->lexer_->override_input ((yylsp[0])));
				yyval = scm_cons (yyvsp[0], yyval);
			}
		}
	}
#line 6649 "./out/parser.cc"
    break;

  case 418:
#line 3201 "parser.yy"
                             {
		yyval = yyvsp[0];
	}
#line 6657 "./out/parser.cc"
    break;

  case 419:
#line 3204 "parser.yy"
                                         {
		Music *m = unsmob<Music> (yyvsp[0]);
		if (!m->is_mus_type ("post-event")) {
			parser->parser_error ((yylsp[0]), _ ("post-event expected"));
			yyval = SCM_UNSPECIFIED;
		} else {
			m->set_spot (parser->lexer_->override_input ((yyloc)));
			if (!SCM_UNBNDP (yyvsp[-1]))
				m->set_property ("direction", yyvsp[-1]);
			yyval = yyvsp[0];
		}
	}
#line 6674 "./out/parser.cc"
    break;

  case 420:
#line 3216 "parser.yy"
                 {
		if (!parser->lexer_->is_lyric_state ())
			parser->parser_error ((yylsp[0]), _ ("have to be in Lyric mode for lyrics"));
		yyval = MY_MAKE_MUSIC ("HyphenEvent", (yyloc))->unprotect ();
	}
#line 6684 "./out/parser.cc"
    break;

  case 421:
#line 3221 "parser.yy"
                   {
		if (!parser->lexer_->is_lyric_state ())
			parser->parser_error ((yylsp[0]), _ ("have to be in Lyric mode for lyrics"));
		yyval = MY_MAKE_MUSIC ("ExtenderEvent", (yyloc))->unprotect ();
	}
#line 6694 "./out/parser.cc"
    break;

  case 422:
#line 3226 "parser.yy"
                                          {
		if (Music *m = unsmob<Music> (yyvsp[0])) {
			m->set_spot (parser->lexer_->override_input ((yyloc)));
			if (!SCM_UNBNDP (yyvsp[-1]))
			{
				m->set_property ("direction", yyvsp[-1]);
			}
		}
		yyval = yyvsp[0];
	}
#line 6709 "./out/parser.cc"
    break;

  case 423:
#line 3236 "parser.yy"
                                          {
		Music *m = unsmob<Music> (yyvsp[0]);
		m->set_spot (parser->lexer_->override_input ((yyloc)));
		if (!SCM_UNBNDP (yyvsp[-1]))
			m->set_property ("direction", yyvsp[-1]);
		yyval = yyvsp[0];
	}
#line 6721 "./out/parser.cc"
    break;

  case 424:
#line 3244 "parser.yy"
        {
		Music *m = unsmob<Music> (yyvsp[0]);
		m->set_spot (parser->lexer_->override_input ((yyloc)));
		m->set_property ("direction", scm_from_int (UP));
		yyval = yyvsp[0];
	}
#line 6732 "./out/parser.cc"
    break;

  case 425:
#line 3251 "parser.yy"
        {
		Music *m = unsmob<Music> (yyvsp[0]);
		m->set_spot (parser->lexer_->override_input ((yyloc)));
		m->set_property ("direction", scm_from_int (DOWN));
		yyval = yyvsp[0];
	}
#line 6743 "./out/parser.cc"
    break;

  case 427:
#line 3261 "parser.yy"
                        {
		unsmob<Music> (yyvsp[0])->set_spot (parser->lexer_->override_input ((yyloc)));
		yyval = yyvsp[0];
	}
#line 6752 "./out/parser.cc"
    break;

  case 428:
#line 3268 "parser.yy"
                   {
		Music *s = MY_MAKE_MUSIC ("StringNumberEvent", (yyloc));
		s->set_property ("string-number", yyvsp[0]);
		yyval = s->unprotect ();
	}
#line 6762 "./out/parser.cc"
    break;

  case 430:
#line 3277 "parser.yy"
                                {
		yyval = yyvsp[0];
	}
#line 6770 "./out/parser.cc"
    break;

  case 431:
#line 3280 "parser.yy"
                        {
               Music *a = MY_MAKE_MUSIC ("TremoloEvent", (yyloc));
               a->set_property ("tremolo-type", yyvsp[0]);
               yyval = a->unprotect ();
        }
#line 6780 "./out/parser.cc"
    break;

  case 433:
#line 3289 "parser.yy"
                     {
		yyval = yyvsp[0];
	}
#line 6788 "./out/parser.cc"
    break;

  case 434:
#line 3292 "parser.yy"
                              {
		SCM s = parser->lexer_->lookup_identifier ("dash" + ly_scm2string (yyvsp[0]));
		if (scm_is_string (s)) {
			Music *a = MY_MAKE_MUSIC ("ArticulationEvent", (yyloc));
			a->set_property ("articulation-type", s);
			yyval = a->unprotect ();
		} else {
			Music *original = unsmob<Music> (s);
			if (original && original->is_mus_type ("post-event")) {
				Music *a = original->clone ();
				// origin will be set by post_event_nofinger
				yyval = a->unprotect ();
			} else {
				parser->parser_error ((yylsp[0]), _ ("expecting string or post-event as script definition"));
				yyval = SCM_UNSPECIFIED;
			}
		}
	}
#line 6811 "./out/parser.cc"
    break;

  case 435:
#line 3313 "parser.yy"
             { yyval = SCM_EOL; }
#line 6817 "./out/parser.cc"
    break;

  case 436:
#line 3314 "parser.yy"
                     { yyval = yyvsp[0]; }
#line 6823 "./out/parser.cc"
    break;

  case 437:
#line 3319 "parser.yy"
        {
                yyval = SCM_INUM0;
	}
#line 6831 "./out/parser.cc"
    break;

  case 440:
#line 3328 "parser.yy"
               {
		if (scm_is_eq (SCM_INUM0, yyvsp[0]))
			yyval = SCM_UNDEFINED;
	}
#line 6840 "./out/parser.cc"
    break;

  case 441:
#line 3335 "parser.yy"
             {
		yyval = scm_from_int (1);
	}
#line 6848 "./out/parser.cc"
    break;

  case 442:
#line 3338 "parser.yy"
                          {
		yyval = scm_oneplus (yyvsp[-1]);
	}
#line 6856 "./out/parser.cc"
    break;

  case 443:
#line 3344 "parser.yy"
            {
		yyval = scm_from_int (-1);
	}
#line 6864 "./out/parser.cc"
    break;

  case 444:
#line 3347 "parser.yy"
                         {
		yyval = scm_oneminus (yyvsp[-1]);
	}
#line 6872 "./out/parser.cc"
    break;

  case 445:
#line 3353 "parser.yy"
                              {
                if (!scm_is_eq (SCM_INUM0, yyvsp[0]))
                {
                        Pitch p = *unsmob<Pitch> (yyvsp[-1]);
                        p = p.transposed (Pitch (scm_to_int (yyvsp[0]), 0));
                        yyval = p.smobbed_copy ();
                }
	}
#line 6885 "./out/parser.cc"
    break;

  case 446:
#line 3368 "parser.yy"
                               {
                if (!scm_is_eq (SCM_INUM0, yyvsp[0]))
                {
                        Pitch p = *unsmob<Pitch> (yyvsp[-1]);
                        p = p.transposed (Pitch (scm_to_int (yyvsp[0]), 0));
                        yyval = p.smobbed_copy ();
                }
	}
#line 6898 "./out/parser.cc"
    break;

  case 448:
#line 3380 "parser.yy"
                                  {
                if (!scm_is_eq (SCM_INUM0, yyvsp[0]))
                {
                        Pitch p = *unsmob<Pitch> (yyvsp[-1]);
                        p = p.transposed (Pitch (scm_to_int (yyvsp[0]), 0));
                        yyval = p.smobbed_copy ();
                }
	}
#line 6911 "./out/parser.cc"
    break;

  case 451:
#line 3396 "parser.yy"
                    {
		Music *t = MY_MAKE_MUSIC ("TextScriptEvent", (yyloc));
		t->set_property ("text", yyvsp[0]);
		yyval = t->unprotect ();
	}
#line 6921 "./out/parser.cc"
    break;

  case 452:
#line 3401 "parser.yy"
                 {
		Music *t = MY_MAKE_MUSIC ("TextScriptEvent", (yyloc));
		t->set_property ("text",
			make_simple_markup (yyvsp[0]));
		yyval = t->unprotect ();
	}
#line 6932 "./out/parser.cc"
    break;

  case 453:
#line 3407 "parser.yy"
                 {
		// Flag a warning? could be unintentional
		Music *t = MY_MAKE_MUSIC ("TextScriptEvent", (yyloc));
		t->set_property ("text",
			make_simple_markup (yyvsp[0]));
		yyval = t->unprotect ();
	}
#line 6944 "./out/parser.cc"
    break;

  case 454:
#line 3415 "parser.yy"
        {
		// Could be using this for every gen_text_def but for speed
		yyval = MAKE_SYNTAX (create_script, (yylsp[0]), yyvsp[0]);
	}
#line 6953 "./out/parser.cc"
    break;

  case 455:
#line 3422 "parser.yy"
                 {
		Music *t = MY_MAKE_MUSIC ("FingeringEvent", (yyloc));
		t->set_property ("digit", yyvsp[0]);
		yyval = t->unprotect ();
	}
#line 6963 "./out/parser.cc"
    break;

  case 456:
#line 3430 "parser.yy"
                        {
		yyval = scm_from_ascii_string ("Hat");
	}
#line 6971 "./out/parser.cc"
    break;

  case 457:
#line 3433 "parser.yy"
                        {
		yyval = scm_from_ascii_string ("Plus");
	}
#line 6979 "./out/parser.cc"
    break;

  case 458:
#line 3436 "parser.yy"
                        {
		yyval = scm_from_ascii_string ("Dash");
	}
#line 6987 "./out/parser.cc"
    break;

  case 459:
#line 3439 "parser.yy"
                        {
		yyval = scm_from_ascii_string ("Bang");
	}
#line 6995 "./out/parser.cc"
    break;

  case 460:
#line 3442 "parser.yy"
                        {
		yyval = scm_from_ascii_string ("Larger");
	}
#line 7003 "./out/parser.cc"
    break;

  case 461:
#line 3445 "parser.yy"
                        {
		yyval = scm_from_ascii_string ("Dot");
	}
#line 7011 "./out/parser.cc"
    break;

  case 462:
#line 3448 "parser.yy"
              {
		yyval = scm_from_ascii_string ("Underscore");
	}
#line 7019 "./out/parser.cc"
    break;

  case 463:
#line 3454 "parser.yy"
                { yyval = scm_from_int (DOWN); }
#line 7025 "./out/parser.cc"
    break;

  case 464:
#line 3455 "parser.yy"
                { yyval = scm_from_int (UP); }
#line 7031 "./out/parser.cc"
    break;

  case 465:
#line 3456 "parser.yy"
                { yyval = SCM_UNDEFINED; }
#line 7037 "./out/parser.cc"
    break;

  case 466:
#line 3460 "parser.yy"
        {
		yyval = SCM_UNDEFINED;
	}
#line 7045 "./out/parser.cc"
    break;

  case 467:
#line 3463 "parser.yy"
                                {
		yyval = yyvsp[0];
		parser->default_duration_ = *unsmob<Duration> (yyval);
	}
#line 7054 "./out/parser.cc"
    break;

  case 468:
#line 3472 "parser.yy"
        {
		if (SCM_UNBNDP (yyval))
			yyval = parser->default_duration_.smobbed_copy ();
	}
#line 7063 "./out/parser.cc"
    break;

  case 469:
#line 3479 "parser.yy"
                                {
		yyval = make_duration (yyvsp[-1], scm_to_int (yyvsp[0]));
		if (SCM_UNBNDP (yyval))
		{
			parser->parser_error ((yylsp[-1]), _ ("not a duration"));
			yyval = Duration ().smobbed_copy ();
		}
	}
#line 7076 "./out/parser.cc"
    break;

  case 470:
#line 3487 "parser.yy"
                                        {
		yyval = make_duration (yyvsp[-1], scm_to_int (yyvsp[0]));
	}
#line 7084 "./out/parser.cc"
    break;

  case 471:
#line 3493 "parser.yy"
                                   {
		yyval = make_duration (yyvsp[-1], 0, yyvsp[0]);
	}
#line 7092 "./out/parser.cc"
    break;

  case 472:
#line 3499 "parser.yy"
                        {
		yyval = SCM_INUM0;
	}
#line 7100 "./out/parser.cc"
    break;

  case 473:
#line 3502 "parser.yy"
                   {
		yyval = scm_oneplus (yyvsp[-1]);
	}
#line 7108 "./out/parser.cc"
    break;

  case 474:
#line 3509 "parser.yy"
        {
		yyval = SCM_UNDEFINED;
	}
#line 7116 "./out/parser.cc"
    break;

  case 475:
#line 3513 "parser.yy"
        {
		if (!SCM_UNBNDP (yyvsp[-2]))
			yyval = scm_product (yyvsp[-2], yyvsp[0]);
		else
			yyval = yyvsp[0];
	}
#line 7127 "./out/parser.cc"
    break;

  case 476:
#line 3520 "parser.yy"
        {
		if (!SCM_UNBNDP (yyvsp[-2]))
			yyval = scm_product (yyvsp[-2], scm_divide (scm_car (yyvsp[0]),
							  scm_cdr (yyvsp[0])));
		else
			yyval = scm_divide (scm_car (yyvsp[0]), scm_cdr (yyvsp[0]));
	}
#line 7139 "./out/parser.cc"
    break;

  case 477:
#line 3530 "parser.yy"
                {
		yyval = scm_from_int (parser->default_tremolo_type_);
	}
#line 7147 "./out/parser.cc"
    break;

  case 478:
#line 3533 "parser.yy"
                       {
		if (SCM_UNBNDP (make_duration (yyvsp[0]))) {
			parser->parser_error ((yylsp[0]), _ ("not a duration"));
			yyval = scm_from_int (parser->default_tremolo_type_);
		} else {
			yyval = yyvsp[0];
			parser->default_tremolo_type_ = scm_to_int (yyvsp[0]);
		}
	}
#line 7161 "./out/parser.cc"
    break;

  case 483:
#line 3550 "parser.yy"
        {
		// as an integer, it needs to be non-negative, and otherwise
		// it needs to be suitable as a markup.
		if (scm_is_integer (yyvsp[0])
		    ? scm_is_true (scm_negative_p (yyvsp[0]))
		    : !Text_interface::is_markup (yyvsp[0]))
		{
			parser->parser_error ((yylsp[0]), _ ("bass number expected"));
			yyval = SCM_INUM0;
		}
	}
#line 7177 "./out/parser.cc"
    break;

  case 484:
#line 3564 "parser.yy"
                { yyval = ly_rational2scm (FLAT_ALTERATION); }
#line 7183 "./out/parser.cc"
    break;

  case 485:
#line 3565 "parser.yy"
                { yyval = ly_rational2scm (SHARP_ALTERATION); }
#line 7189 "./out/parser.cc"
    break;

  case 486:
#line 3566 "parser.yy"
                { yyval = scm_from_int (0); }
#line 7195 "./out/parser.cc"
    break;

  case 487:
#line 3570 "parser.yy"
                     {
		Music *bfr = MY_MAKE_MUSIC ("BassFigureEvent", (yyloc));
		yyval = bfr->unprotect ();
	}
#line 7204 "./out/parser.cc"
    break;

  case 488:
#line 3574 "parser.yy"
                       {
		Music *bfr = MY_MAKE_MUSIC ("BassFigureEvent", (yyloc));
		yyval = bfr->self_scm ();

		if (scm_is_number (yyvsp[0]))
			bfr->set_property ("figure", yyvsp[0]);
		else if (Text_interface::is_markup (yyvsp[0]))
			bfr->set_property ("text", yyvsp[0]);

		bfr->unprotect ();
	}
#line 7220 "./out/parser.cc"
    break;

  case 489:
#line 3585 "parser.yy"
                          {
		yyval = yyvsp[-1];
		unsmob<Music> (yyvsp[-1])->set_property ("bracket-stop", SCM_BOOL_T);
	}
#line 7229 "./out/parser.cc"
    break;

  case 490:
#line 3589 "parser.yy"
                                              {
		Music *m = unsmob<Music> (yyvsp[-1]);
		if (scm_to_double (yyvsp[0])) {
			SCM salter = m->get_property ("alteration");
			SCM alter = scm_is_number (salter) ? salter : scm_from_int (0);
			m->set_property ("alteration",
					 scm_sum (alter, yyvsp[0]));
		} else {
			m->set_property ("alteration", scm_from_int (0));
		}
	}
#line 7245 "./out/parser.cc"
    break;

  case 491:
#line 3600 "parser.yy"
                                                 {
		Music *m = unsmob<Music> (yyvsp[-1]);
		m->set_property (yyvsp[0], SCM_BOOL_T);
	}
#line 7254 "./out/parser.cc"
    break;

  case 492:
#line 3608 "parser.yy"
                        {
		yyval = ly_symbol2scm ("augmented");
	}
#line 7262 "./out/parser.cc"
    break;

  case 493:
#line 3611 "parser.yy"
                        {
		yyval = ly_symbol2scm ("no-continuation");
	}
#line 7270 "./out/parser.cc"
    break;

  case 494:
#line 3614 "parser.yy"
                        {
		yyval = ly_symbol2scm ("diminished");
	}
#line 7278 "./out/parser.cc"
    break;

  case 495:
#line 3617 "parser.yy"
                      {
		yyval = ly_symbol2scm ("augmented-slash");
	}
#line 7286 "./out/parser.cc"
    break;

  case 496:
#line 3623 "parser.yy"
                    {
		yyval = yyvsp[0];
	}
#line 7294 "./out/parser.cc"
    break;

  case 497:
#line 3626 "parser.yy"
                          {
		yyval = yyvsp[0];
		unsmob<Music> (yyval)->set_property ("bracket-start", SCM_BOOL_T);
	}
#line 7303 "./out/parser.cc"
    break;

  case 498:
#line 3633 "parser.yy"
                        {
		yyval = SCM_EOL;
	}
#line 7311 "./out/parser.cc"
    break;

  case 499:
#line 3636 "parser.yy"
                                     {
		yyval = scm_cons (yyvsp[0], yyvsp[-1]);
	}
#line 7319 "./out/parser.cc"
    break;

  case 500:
#line 3642 "parser.yy"
               { yyval = SCM_BOOL_F; }
#line 7325 "./out/parser.cc"
    break;

  case 501:
#line 3643 "parser.yy"
               { yyval = SCM_BOOL_T; }
#line 7331 "./out/parser.cc"
    break;

  case 502:
#line 3651 "parser.yy"
                                                                                                                     {
		if (!parser->lexer_->is_note_state ())
			parser->parser_error ((yylsp[-7]), _ ("have to be in Note mode for notes"));
		if (!SCM_UNBNDP (yyvsp[-2]))
		{
			// It's possible to get here without a
			// duration, like when there is no
			// octave_check but a question mark.  But we
			// point out the most frequent error of an
			// interspersed duration specifically
			if (!SCM_UNBNDP (yyvsp[-3]))
				parser->parser_error ((yylsp[-2]), _ ("octave marks must precede duration"));
			else
				parser->parser_error ((yylsp[-2]), _ ("badly placed octave marks"));
			// Try sorting the quotes to where they likely belong
			if (scm_is_number (yyvsp[-4])) {
				yyvsp[-4] = scm_sum (yyvsp[-4], yyvsp[-2]);
			} else {
				yyvsp[-7] = unsmob<Pitch> (yyvsp[-7])->transposed
					(Pitch (scm_to_int (yyvsp[-2]), 0)).smobbed_copy ();
			}
		}

		if (!SCM_UNBNDP (yyvsp[-6])
                    || !SCM_UNBNDP (yyvsp[-5])
                    || scm_is_number (yyvsp[-4])
                    || !SCM_UNBNDP (yyvsp[-3])
		    || scm_is_true (yyvsp[-1])
		    || scm_is_pair (yyvsp[0]))
		{
			Music *n = 0;
			if (scm_is_true (yyvsp[-1]))
				n = MY_MAKE_MUSIC ("RestEvent", (yyloc));
			else
				n = MY_MAKE_MUSIC ("NoteEvent", (yyloc));

			n->set_property ("pitch", yyvsp[-7]);
			if (SCM_UNBNDP (yyvsp[-3]))
				n->set_property ("duration",
						 parser->default_duration_.smobbed_copy ());
			else
				n->set_property ("duration", yyvsp[-3]);

			if (scm_is_number (yyvsp[-4]))
			{
				int q = scm_to_int (yyvsp[-4]);
				n->set_property ("absolute-octave", scm_from_int (q-1));
			}

			if (to_boolean (yyvsp[-5]))
				n->set_property ("cautionary", SCM_BOOL_T);
			if (to_boolean (yyvsp[-6]) || to_boolean (yyvsp[-5]))
				n->set_property ("force-accidental", SCM_BOOL_T);
			if (scm_is_pair (yyvsp[0]))
				n->set_property ("articulations",
						 scm_reverse_x (yyvsp[0], SCM_EOL));
			yyval = n->unprotect ();
		}
	}
#line 7395 "./out/parser.cc"
    break;

  case 503:
#line 3710 "parser.yy"
                                {
		if (!parser->lexer_->is_chord_state ())
                        parser->parser_error ((yylsp[-1]), _ ("have to be in Chord mode for chords"));
		if (scm_is_pair (yyvsp[0])) {
			if (unsmob<Pitch> (yyvsp[-1]))
				yyvsp[-1] = make_chord_elements ((yylsp[-1]),
							  yyvsp[-1],
							  parser->default_duration_.smobbed_copy (),
							  SCM_EOL);

			SCM elts = ly_append2 (yyvsp[-1], scm_reverse_x (yyvsp[0], SCM_EOL));

			yyval = MAKE_SYNTAX (event_chord, (yylsp[-1]), elts);
		} else if (!unsmob<Pitch> (yyvsp[-1]))
			yyval = MAKE_SYNTAX (event_chord, (yylsp[-1]), yyvsp[-1]);
		// A mere pitch drops through.
	}
#line 7417 "./out/parser.cc"
    break;

  case 504:
#line 3730 "parser.yy"
                                              {
		Music *n = MY_MAKE_MUSIC ("NoteEvent", (yyloc));
		n->set_property ("duration", yyvsp[0]);
		n->set_property ("drum-type", yyvsp[-1]);

		yyval = n->unprotect ();
	}
#line 7429 "./out/parser.cc"
    break;

  case 505:
#line 3737 "parser.yy"
                                                        {
		Music *ev = 0;
 		if (ly_scm2string (yyvsp[-1]) == "s") {
			/* Space */
			ev = MY_MAKE_MUSIC ("SkipEvent", (yyloc));
		  }
		else {
			ev = MY_MAKE_MUSIC ("RestEvent", (yyloc));

		    }
		ev->set_property ("duration", yyvsp[0]);
 		yyval = ev->unprotect ();
	}
#line 7447 "./out/parser.cc"
    break;

  case 506:
#line 3753 "parser.yy"
                    {
		if (!parser->lexer_->is_lyric_state ())
			parser->parser_error ((yylsp[0]), _ ("markup outside of text script or \\lyricmode"));
		yyval = yyvsp[0];
	}
#line 7457 "./out/parser.cc"
    break;

  case 507:
#line 3758 "parser.yy"
                 {
		if (!parser->lexer_->is_lyric_state ())
			parser->parser_error ((yylsp[0]), _f ("not a note name: %s", ly_scm2string (yyvsp[0])));
		yyval = yyvsp[0];
	}
#line 7467 "./out/parser.cc"
    break;

  case 508:
#line 3763 "parser.yy"
                 {
		if (!parser->lexer_->is_lyric_state ())
			parser->parser_error ((yylsp[0]), _ ("string outside of text script or \\lyricmode"));
		yyval = yyvsp[0];
	}
#line 7477 "./out/parser.cc"
    break;

  case 510:
#line 3772 "parser.yy"
                                                             {
		yyval = MAKE_SYNTAX (lyric_event, (yyloc), yyvsp[-2], yyvsp[-1]);
		if (scm_is_pair (yyvsp[0]))
			unsmob<Music> (yyval)->set_property
				("articulations", scm_reverse_x (yyvsp[0], SCM_EOL));
	}
#line 7488 "./out/parser.cc"
    break;

  case 511:
#line 3782 "parser.yy"
                                                    {
		if (SCM_UNBNDP (yyvsp[0]))
			yyval = yyvsp[-1];
		else
			yyval = make_chord_elements ((yyloc), yyvsp[-1], yyvsp[0], SCM_EOL);
	}
#line 7499 "./out/parser.cc"
    break;

  case 512:
#line 3788 "parser.yy"
                                                                                   {
		SCM its = scm_reverse_x (yyvsp[0], SCM_EOL);
		yyval = make_chord_elements ((yyloc), yyvsp[-3], yyvsp[-2], scm_cons (yyvsp[-1], its));
	}
#line 7508 "./out/parser.cc"
    break;

  case 513:
#line 3795 "parser.yy"
             {
		yyval = SCM_EOL;
	}
#line 7516 "./out/parser.cc"
    break;

  case 514:
#line 3798 "parser.yy"
                                 {
		yyval = scm_cons (yyvsp[0], yyval);
	}
#line 7524 "./out/parser.cc"
    break;

  case 515:
#line 3804 "parser.yy"
                    {
		yyval = ly_symbol2scm ("chord-colon");
	}
#line 7532 "./out/parser.cc"
    break;

  case 516:
#line 3807 "parser.yy"
                      {
		yyval = ly_symbol2scm ("chord-caret");
	}
#line 7540 "./out/parser.cc"
    break;

  case 517:
#line 3810 "parser.yy"
                                        {
 		yyval = scm_list_2 (ly_symbol2scm ("chord-slash"), yyvsp[0]);
	}
#line 7548 "./out/parser.cc"
    break;

  case 518:
#line 3813 "parser.yy"
                                       {
		yyval = scm_list_2 (ly_symbol2scm ("chord-bass"), yyvsp[0]);
	}
#line 7556 "./out/parser.cc"
    break;

  case 519:
#line 3819 "parser.yy"
                        {
		yyval = yyvsp[0];
	}
#line 7564 "./out/parser.cc"
    break;

  case 520:
#line 3822 "parser.yy"
                       {
		yyval = scm_reverse_x (yyvsp[0], SCM_EOL);
	}
#line 7572 "./out/parser.cc"
    break;

  case 521:
#line 3825 "parser.yy"
                          {
		yyval = yyvsp[0];
	}
#line 7580 "./out/parser.cc"
    break;

  case 522:
#line 3831 "parser.yy"
                    { yyval = scm_cons (yyvsp[0], SCM_EOL); }
#line 7586 "./out/parser.cc"
    break;

  case 523:
#line 3832 "parser.yy"
                                       {
		yyval = scm_cons (yyvsp[0], yyval);
	}
#line 7594 "./out/parser.cc"
    break;

  case 524:
#line 3838 "parser.yy"
                 {
		yyval = make_chord_step (yyvsp[0], 0);
        }
#line 7602 "./out/parser.cc"
    break;

  case 525:
#line 3841 "parser.yy"
                       {
		yyval = make_chord_step (yyvsp[-1], SHARP_ALTERATION);
	}
#line 7610 "./out/parser.cc"
    break;

  case 526:
#line 3844 "parser.yy"
                               {
		yyval = make_chord_step (yyvsp[-1], FLAT_ALTERATION);
	}
#line 7618 "./out/parser.cc"
    break;

  case 527:
#line 3850 "parser.yy"
                        {
		yyval = yyvsp[0];
	}
#line 7626 "./out/parser.cc"
    break;

  case 528:
#line 3853 "parser.yy"
                                              {
		yyval = scm_cons (yyvsp[-2], yyvsp[0]);
	}
#line 7634 "./out/parser.cc"
    break;

  case 529:
#line 3865 "parser.yy"
                                          {
		yyval = scm_sum (yyvsp[-2], yyvsp[0]);
	}
#line 7642 "./out/parser.cc"
    break;

  case 530:
#line 3868 "parser.yy"
                                            {
		yyval = scm_difference (yyvsp[-2], yyvsp[0]);
	}
#line 7650 "./out/parser.cc"
    break;

  case 532:
#line 3875 "parser.yy"
                      {
		yyval = yyvsp[0];
	}
#line 7658 "./out/parser.cc"
    break;

  case 533:
#line 3878 "parser.yy"
                                          {
		yyval = scm_product (yyvsp[-2], yyvsp[0]);
	}
#line 7666 "./out/parser.cc"
    break;

  case 534:
#line 3881 "parser.yy"
                                          {
		yyval = scm_divide (yyvsp[-2], yyvsp[0]);
	}
#line 7674 "./out/parser.cc"
    break;

  case 535:
#line 3887 "parser.yy"
                           { /* %prec UNARY_MINUS */
		yyval = scm_difference (yyvsp[0], SCM_UNDEFINED);
	}
#line 7682 "./out/parser.cc"
    break;

  case 539:
#line 3897 "parser.yy"
        {
		yyval = scm_product (yyvsp[-1], yyvsp[0]);
	}
#line 7690 "./out/parser.cc"
    break;

  case 542:
#line 3905 "parser.yy"
                                        {
		yyval = scm_product (yyvsp[-1], yyvsp[0]);
	}
#line 7698 "./out/parser.cc"
    break;

  case 544:
#line 3913 "parser.yy"
        {
		if (!scm_is_integer (yyvsp[0])
		    || scm_is_true (scm_negative_p (yyvsp[0])))
		{
			parser->parser_error ((yylsp[0]), _("not an unsigned integer"));
			yyval = SCM_INUM0;
		}
	}
#line 7711 "./out/parser.cc"
    break;

  case 545:
#line 3922 "parser.yy"
        {
		if (!scm_is_integer (yyvsp[0])
		    || scm_is_true (scm_negative_p (yyvsp[0])))
		{
			parser->parser_error ((yylsp[0]), _("not an unsigned integer"));
			yyval = SCM_INUM0;
		}
	}
#line 7724 "./out/parser.cc"
    break;

  case 546:
#line 3933 "parser.yy"
                { yyval = SCM_UNDEFINED; }
#line 7730 "./out/parser.cc"
    break;

  case 547:
#line 3935 "parser.yy"
        {
                if (SCM_UNBNDP (yyvsp[-1]))
                        yyval = SCM_BOOL_T;
                else
                        yyval = scm_not (yyvsp[-1]);
        }
#line 7741 "./out/parser.cc"
    break;

  case 548:
#line 3950 "parser.yy"
        { yyval = SCM_UNDEFINED; }
#line 7747 "./out/parser.cc"
    break;

  case 549:
#line 3952 "parser.yy"
        {
                if (SCM_UNBNDP (yyvsp[-1]))
                        yyval = SCM_BOOL_T;
                else
                        yyval = scm_not (yyvsp[-1]);
        }
#line 7758 "./out/parser.cc"
    break;

  case 550:
#line 3962 "parser.yy"
                { parser->lexer_->push_markup_state (); }
#line 7764 "./out/parser.cc"
    break;

  case 551:
#line 3963 "parser.yy"
                    {
		yyval = yyvsp[0];
		parser->lexer_->pop_state ();
	}
#line 7773 "./out/parser.cc"
    break;

  case 552:
#line 3971 "parser.yy"
        {
		parser->lexer_->push_markup_state ();
	}
#line 7781 "./out/parser.cc"
    break;

  case 553:
#line 3987 "parser.yy"
        {
		yyval = yyvsp[0];
		parser->lexer_->pop_state ();
	}
#line 7790 "./out/parser.cc"
    break;

  case 554:
#line 3995 "parser.yy"
                               {
		yyval = yyvsp[0];
		parser->lexer_->pop_state ();
	}
#line 7799 "./out/parser.cc"
    break;

  case 555:
#line 4000 "parser.yy"
        {
		yyval = make_simple_markup (yyvsp[0]);
	}
#line 7807 "./out/parser.cc"
    break;

  case 556:
#line 4007 "parser.yy"
        {
		yyval = MAKE_SYNTAX (partial_markup, (yylsp[-1]), yyvsp[-1]);
		parser->lexer_->pop_state ();
	}
#line 7816 "./out/parser.cc"
    break;

  case 557:
#line 4014 "parser.yy"
                    {
		yyval = scm_list_2 (Lily::line_markup,  yyvsp[0]);
	}
#line 7824 "./out/parser.cc"
    break;

  case 558:
#line 4018 "parser.yy"
        {
		yyval = scm_car (MAKE_SYNTAX (composed_markup_list,
					   (yylsp[0]), yyvsp[-1], scm_list_1 (yyvsp[0])));
	}
#line 7833 "./out/parser.cc"
    break;

  case 559:
#line 4022 "parser.yy"
                               {
		yyval = yyvsp[0];
	}
#line 7841 "./out/parser.cc"
    break;

  case 560:
#line 4029 "parser.yy"
        {
		if (Text_interface::is_markup (yyvsp[0]))
			MYBACKUP (MARKUP_IDENTIFIER, yyvsp[0], (yylsp[0]));
		else if (Text_interface::is_markup_list (yyvsp[0]))
			MYBACKUP (MARKUPLIST_IDENTIFIER, yyvsp[0], (yylsp[0]));
		else {
			parser->parser_error ((yylsp[0]), _ ("not a markup"));
			MYBACKUP (MARKUP_IDENTIFIER, scm_string (SCM_EOL), (yylsp[0]));
		}
	}
#line 7856 "./out/parser.cc"
    break;

  case 562:
#line 4043 "parser.yy"
                             {
		yyval = yyvsp[0];
	}
#line 7864 "./out/parser.cc"
    break;

  case 564:
#line 4050 "parser.yy"
                           {
		yyval = yyvsp[0];
	}
#line 7872 "./out/parser.cc"
    break;

  case 565:
#line 4053 "parser.yy"
                              {
		yyval = scm_list_1 (yyvsp[0]);
	}
#line 7880 "./out/parser.cc"
    break;

  case 566:
#line 4057 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 7888 "./out/parser.cc"
    break;

  case 567:
#line 4060 "parser.yy"
                     {
		parser->lexer_->push_note_state (Lily::pitchnames);
	}
#line 7896 "./out/parser.cc"
    break;

  case 568:
#line 4062 "parser.yy"
                             {
		Score *sc = unsmob<Score> (yyvsp[-1]);
		sc->origin ()->set_spot ((yyloc));
		if (sc->defs_.empty ()) {
			Output_def *od = get_layout (parser);
			sc->add_output_def (od);
			od->unprotect ();
		}
		yyval = scm_list_1 (scm_list_2 (Lily::score_lines_markup_list, yyvsp[-1]));
		parser->lexer_->pop_state ();
	}
#line 7912 "./out/parser.cc"
    break;

  case 569:
#line 4076 "parser.yy"
                                                  {
		yyval = MAKE_SYNTAX (composed_markup_list,
				  (yylsp[0]), yyvsp[-1], yyvsp[0]);
	}
#line 7921 "./out/parser.cc"
    break;

  case 570:
#line 4083 "parser.yy"
                                        {
		yyval = scm_reverse_x (yyvsp[-1], SCM_EOL);
	}
#line 7929 "./out/parser.cc"
    break;

  case 571:
#line 4089 "parser.yy"
                        {  yyval = SCM_EOL; }
#line 7935 "./out/parser.cc"
    break;

  case 572:
#line 4090 "parser.yy"
                                         {
		yyval = scm_cons (yyvsp[0], yyvsp[-1]);
	}
#line 7943 "./out/parser.cc"
    break;

  case 573:
#line 4093 "parser.yy"
                                              {
		yyval = scm_reverse_x (yyvsp[0], yyvsp[-1]);
	}
#line 7951 "./out/parser.cc"
    break;

  case 574:
#line 4099 "parser.yy"
                                                           {
	  yyval = scm_cons (yyvsp[-1], scm_reverse_x(yyvsp[0], SCM_EOL));
	}
#line 7959 "./out/parser.cc"
    break;

  case 575:
#line 4105 "parser.yy"
                                                                     {
	  yyval = scm_cons (yyvsp[0], yyvsp[-1]);
	}
#line 7967 "./out/parser.cc"
    break;

  case 576:
#line 4108 "parser.yy"
                                                                {
	  yyval = check_scheme_arg (parser, (yylsp[0]), yyvsp[0], yyvsp[-1], yyvsp[-2]);
	}
#line 7975 "./out/parser.cc"
    break;

  case 577:
#line 4111 "parser.yy"
                                                          {
		yyval = check_scheme_arg (parser, (yylsp[0]), yyvsp[0], yyvsp[-1], yyvsp[-2]);
	}
#line 7983 "./out/parser.cc"
    break;

  case 578:
#line 4114 "parser.yy"
                              {
	  yyval = SCM_EOL;
	}
#line 7991 "./out/parser.cc"
    break;

  case 579:
#line 4120 "parser.yy"
                                       { yyval = yyvsp[0]; }
#line 7997 "./out/parser.cc"
    break;

  case 580:
#line 4121 "parser.yy"
                                                             {
	  yyval = scm_cons (yyvsp[0], yyvsp[-1]);
	}
#line 8005 "./out/parser.cc"
    break;

  case 581:
#line 4128 "parser.yy"
        {
		yyval = scm_list_1 (scm_cons (yyvsp[-1], scm_reverse_x (yyvsp[0], SCM_EOL)));
	}
#line 8013 "./out/parser.cc"
    break;

  case 582:
#line 4132 "parser.yy"
        {
		yyval = scm_cons (scm_cons (yyvsp[-1], scm_reverse_x (yyvsp[0], SCM_EOL)),
			       yyvsp[-2]);
	}
#line 8022 "./out/parser.cc"
    break;

  case 583:
#line 4140 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 8030 "./out/parser.cc"
    break;

  case 584:
#line 4144 "parser.yy"
        {
		yyval= yyvsp[0];
	}
#line 8038 "./out/parser.cc"
    break;

  case 585:
#line 4148 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 8046 "./out/parser.cc"
    break;

  case 586:
#line 4152 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 8054 "./out/parser.cc"
    break;

  case 587:
#line 4158 "parser.yy"
                                                                    {
	  yyval = scm_cons (yyvsp[-2], scm_reverse_x (yyvsp[0], SCM_EOL));
	}
#line 8062 "./out/parser.cc"
    break;

  case 588:
#line 4164 "parser.yy"
                                {
		yyval = scm_list_1 (yyvsp[0]);
	}
#line 8070 "./out/parser.cc"
    break;

  case 589:
#line 4167 "parser.yy"
                                                {
		yyval = scm_cons (yyvsp[0], yyvsp[-1]);
	}
#line 8078 "./out/parser.cc"
    break;

  case 592:
#line 4179 "parser.yy"
        {
		yyval = make_simple_markup (yyvsp[0]);
	}
#line 8086 "./out/parser.cc"
    break;

  case 594:
#line 4186 "parser.yy"
              {
		parser->lexer_->push_note_state (Lily::pitchnames);
	}
#line 8094 "./out/parser.cc"
    break;

  case 595:
#line 4188 "parser.yy"
                             {
		Score *sc = unsmob<Score> (yyvsp[-1]);
		sc->origin ()->set_spot ((yyloc));
		if (sc->defs_.empty ()) {
			Output_def *od = get_layout (parser);
			sc->add_output_def (od);
			od->unprotect ();
		}
		yyval = scm_list_2 (Lily::score_markup, yyvsp[-1]);
		parser->lexer_->pop_state ();
	}
#line 8110 "./out/parser.cc"
    break;

  case 596:
#line 4199 "parser.yy"
                                                         {
		yyval = scm_cons (yyvsp[-1], scm_reverse_x (yyvsp[0], SCM_EOL));
	}
#line 8118 "./out/parser.cc"
    break;

  case 597:
#line 4203 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 8126 "./out/parser.cc"
    break;

  case 598:
#line 4210 "parser.yy"
        {
		yyval = scm_car (MAKE_SYNTAX (composed_markup_list,
					   (yylsp[0]), yyvsp[-1], scm_list_1 (yyvsp[0])));
	}
#line 8135 "./out/parser.cc"
    break;

  case 599:
#line 4214 "parser.yy"
                        {
		yyval = yyvsp[0];
	}
#line 8143 "./out/parser.cc"
    break;


#line 8147 "./out/parser.cc"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (&yylloc, parser, retval, YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = YY_CAST (char *, YYSTACK_ALLOC (YY_CAST (YYSIZE_T, yymsg_alloc)));
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (&yylloc, parser, retval, yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }

  yyerror_range[1] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc, parser, retval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp, yylsp, parser, retval);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the lookahead.  YYLOC is available though.  */
  YYLLOC_DEFAULT (yyloc, yyerror_range, 2);
  *++yylsp = yyloc;

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;


#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (&yylloc, parser, retval, YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif


/*-----------------------------------------------------.
| yyreturn -- parsing is finished, return the result.  |
`-----------------------------------------------------*/
yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc, parser, retval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp, yylsp, parser, retval);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 4219 "parser.yy"


void
Lily_parser::set_yydebug (bool x)
{
	yydebug = x;
}

SCM
Lily_parser::do_yyparse ()
{
	return scm_c_with_fluid (Lily::f_parser,
				 self_scm (),
				 do_yyparse_trampoline,
				 static_cast <void *>(this));
}

SCM
Lily_parser::do_yyparse_trampoline (void *parser)
{
	SCM retval = SCM_UNDEFINED;
	yyparse (static_cast <Lily_parser *>(parser), &retval);
	return retval;
}



/*

It is a little strange to have this function in this file, but
otherwise, we have to import music classes into the lexer.

*/
int
Lily_lexer::try_special_identifiers (SCM *destination, SCM sid)
{
	if (unsmob<Book> (sid)) {
		Book *book =  unsmob<Book> (sid)->clone ();
		*destination = book->self_scm ();
		book->unprotect ();

		return BOOK_IDENTIFIER;
	} else if (scm_is_number (sid)) {
		*destination = sid;
		return NUMBER_IDENTIFIER;
	} else if (unsmob<Context_def> (sid))
	{
		*destination = unsmob<Context_def> (sid)->clone ()->unprotect ();
		return SCM_IDENTIFIER;
        } else if (unsmob<Context_mod> (sid)) {
                *destination = unsmob<Context_mod> (sid)->smobbed_copy ();
                return SCM_IDENTIFIER;
	} else if (Music *mus = unsmob<Music> (sid)) {
		mus = mus->clone ();
		*destination = mus->self_scm ();
		bool is_event = mus->is_mus_type ("post-event");
		mus->unprotect ();
		return is_event ? EVENT_IDENTIFIER : MUSIC_IDENTIFIER;
	} else if (unsmob<Pitch> (sid)) {
		*destination = unsmob<Pitch> (sid)->smobbed_copy ();
		return PITCH_IDENTIFIER;
	} else if (unsmob<Duration> (sid)) {
		*destination = unsmob<Duration> (sid)->smobbed_copy ();
		return DURATION_IDENTIFIER;
	} else if (unsmob<Output_def> (sid)) {
		*destination = unsmob<Output_def> (sid)->clone ()->unprotect ();
		return SCM_IDENTIFIER;
	} else if (unsmob<Score> (sid)) {
		*destination = unsmob<Score> (sid)->clone ()->unprotect ();
		return SCM_IDENTIFIER;
	} else if (scm_is_pair (sid)
		   && scm_is_pair (scm_car (sid))
		   && scm_is_true (Lily::key_p (scm_caar (sid)))) {
		*destination = sid;
		return LOOKUP_IDENTIFIER;
	}
	return -1;
}

SCM
get_next_unique_context_id ()
{
	return scm_from_ascii_string ("$uniqueContextId");
}


SCM
get_next_unique_lyrics_context_id ()
{
	static int new_context_count;
	char s[128];
	snprintf (s, sizeof (s)-1, "uniqueContext%d", new_context_count++);
	return scm_from_ascii_string (s);
}

// check_scheme_arg checks one argument with a given predicate for use
// in an argument list and throws a syntax error if it is unusable.
// The argument is prepended to the argument list in any case.  After
// throwing a syntax error, the argument list is terminated with #f as
// its last cdr in order to mark it as uncallable while not losing
// track of its total length.
//
// There are a few special considerations: if optional argument disp
// is given (otherwise it defaults to SCM_UNDEFINED), it will be used
// instead of arg in a prospective error message.  This is useful if
// arg is not the actual argument but rather a transformation of it.
//
// If arg itself is SCM_UNDEFINED, the predicate is considered false
// and an error message using disp is produced unconditionally.

SCM check_scheme_arg (Lily_parser *parser, Input loc,
		      SCM arg, SCM args, SCM pred, SCM disp)
{
	if (SCM_UNBNDP (arg))
		args = scm_cons (disp, args);
	else {
		args = scm_cons (arg, args);
		if (scm_is_true (scm_call_1 (pred, arg)))
			return args;
	}
	scm_set_cdr_x (scm_last_pair (args), SCM_EOL);
	MAKE_SYNTAX (argument_error, loc, scm_length (args), pred,
		     SCM_UNBNDP (disp) ? arg : disp);
	scm_set_cdr_x (scm_last_pair (args), SCM_BOOL_F);
	return args;
}

SCM loc_on_copy (Lily_parser *parser, Input loc, SCM arg)
{
	if (Music *m = unsmob<Music> (arg))
	{
		m = m->clone ();
		m->set_spot (parser->lexer_->override_input (loc));
		return m->unprotect ();
	}
	if (Book *b = unsmob<Book> (arg))
	{
		b = b->clone ();
		b->origin ()->set_spot (parser->lexer_->override_input (loc));
		return b->unprotect ();
	}
	if (Context_def *cd = unsmob<Context_def> (arg))
	{
		cd = cd->clone ();
		cd->origin ()->set_spot (parser->lexer_->override_input (loc));
		return cd->unprotect ();
	}
	if (Output_def *od = unsmob<Output_def> (arg))
	{
		od = od->clone ();
		od->input_origin_ = parser->lexer_->override_input (loc);
		return od->unprotect ();
	}
	if (Score *s = unsmob<Score> (arg))
	{
		s = s->clone ();
		s->origin ()->set_spot (parser->lexer_->override_input (loc));
		return s->unprotect ();
	}
	if (Context_mod *cm = unsmob<Context_mod> (arg))
	{
		return cm->smobbed_copy ();
	}
	return arg;
}

SCM
make_reverse_key_list (SCM keys)
{
	if (scm_is_true (Lily::key_p (keys)))
		return scm_list_1 (keys);
	if (scm_is_string (keys))
		return scm_list_1 (scm_string_to_symbol (keys));
	if (!ly_is_list (keys))
		return SCM_UNDEFINED;
	SCM res = SCM_EOL;
	for (; scm_is_pair (keys); keys = scm_cdr (keys))
	{
		SCM elt = scm_car (keys);
		if (scm_is_true (Lily::key_p (elt)))
			res = scm_cons (elt, res);
		else if (scm_is_string (elt))
			res = scm_cons (scm_string_to_symbol (elt), res);
		else return SCM_UNDEFINED;
	}
	return res;
}

SCM
try_string_variants (SCM pred, SCM str)
{
	// a matching predicate is always ok
	if (scm_is_true (scm_call_1 (pred, str)))
		return str;
	// a key may be interpreted as a list of keys if it helps
	if (scm_is_true (Lily::key_p (str))) {
		str = scm_list_1 (str);
		if (scm_is_true (scm_call_1 (pred, str)))
			return str;
		return SCM_UNDEFINED;
	}

	if (!scm_is_string (str))
		return SCM_UNDEFINED;

	// Let's attempt the symbol list interpretation first.

	str = scm_string_to_symbol (str);

	SCM lst = scm_list_1 (str);

	if (scm_is_true (scm_call_1 (pred, lst)))
		return lst;

	// Try the single symbol interpretation

	if (scm_is_true (scm_call_1 (pred, str)))
		return str;

	return SCM_UNDEFINED;
}

SCM
try_word_variants (SCM pred, SCM str)
{
	// str is always a string when we come here

	if (scm_is_true (scm_call_1 (pred, str)))
		return str;

	// If this cannot be a string representation of a symbol list,
	// we are through.

	if (!is_regular_identifier (str, true))
		return SCM_UNDEFINED;

	str = scm_string_split (str, SCM_MAKE_CHAR ('.'));
	for (SCM p = str; scm_is_pair (p); p = scm_cdr (p))
		scm_set_car_x (p, scm_string_split (scm_car (p),
						    SCM_MAKE_CHAR (',')));
	str = scm_append_x (str);
	for (SCM p = str; scm_is_pair (p); p = scm_cdr (p))
		scm_set_car_x (p, scm_string_to_symbol (scm_car (p)));

	// Let's attempt the symbol list interpretation first.

	if (scm_is_true (scm_call_1 (pred, str)))
		return str;

	// If there is just one symbol in the list, we might interpret
	// it as a single symbol

	if (scm_is_null (scm_cdr (str)))
	{
		str = scm_car (str);
		if (scm_is_true (scm_call_1 (pred, str)))
			return str;
	}

	return SCM_UNDEFINED;
}

bool
is_regular_identifier (SCM id, bool multiple)
{
  if (!scm_is_string (id))
	  return false;

  string str = ly_scm2string (id);

  bool middle = false;

  for (string::iterator it=str.begin(); it != str.end (); it++)
  {
	  int c = *it & 0xff;
	  if ((c >= 'a' && c <= 'z')
	      || (c >= 'A' && c <= 'Z')
	      || c > 0x7f)
		  middle = true;
	  else if (middle && (c == '-' || c == '_' || (multiple &&
						       (c == '.' || c == ','))))
		  middle = false;
	  else
		  return false;
  }
  return middle;
}

SCM
make_music_from_simple (Lily_parser *parser, Input loc, SCM simple)
{
	if (unsmob<Music> (simple))
		return simple;

	if (scm_is_symbol (simple))
	{
		SCM out = SCM_UNDEFINED;
		switch (parser->lexer_->scan_word (out, simple))
		{
		case DRUM_PITCH:
		{
			Music *n = MY_MAKE_MUSIC ("NoteEvent", loc);
			n->set_property ("duration", parser->default_duration_.smobbed_copy ());
			n->set_property ("drum-type", out);
			return n->unprotect ();
		}
		case NOTENAME_PITCH:
		case TONICNAME_PITCH:
			// Take the parsed pitch
			simple = out;
			break;
		// Don't scan CHORD_MODIFIER etc.
		}
	}

	if (parser->lexer_->is_note_state ()) {
		if (unsmob<Pitch> (simple)) {
			Music *n = MY_MAKE_MUSIC ("NoteEvent", loc);
			n->set_property ("duration", parser->default_duration_.smobbed_copy ());
			n->set_property ("pitch", simple);
			return n->unprotect ();
		}
		SCM d = simple;
		if (scm_is_integer (simple))
			d = make_duration (simple);
		if (unsmob<Duration> (d)) {
			Music *n = MY_MAKE_MUSIC ("NoteEvent", loc);
			n->set_property ("duration", d);
			return n->unprotect ();
		}
		return simple;
	} else if (parser->lexer_->is_lyric_state ()) {
		if (Text_interface::is_markup (simple))
			return MAKE_SYNTAX (lyric_event, loc, simple,
					    parser->default_duration_.smobbed_copy ());
	} else if (parser->lexer_->is_chord_state ()) {
		if (unsmob<Pitch> (simple))
			return MAKE_SYNTAX
				(event_chord,
				 loc,
				 make_chord_elements (loc, simple,
						      parser->default_duration_.smobbed_copy (),
						      SCM_EOL));
	}
	return simple;
}

Music *
make_music_with_input (SCM name, Input where)
{
       Music *m = make_music_by_name (name);
       m->set_spot (where);
       return m;
}

SCM
make_simple_markup (SCM a)
{
	return a;
}

SCM
make_duration (SCM d, int dots, SCM factor)
{
	Duration k;

	if (Duration *dur = unsmob<Duration> (d)) {
		if (!dots && SCM_UNBNDP (factor))
			return d;
		k = *dur;
		if (dots)
			k = Duration (k.duration_log (), k.dot_count () + dots)
				.compressed (k.factor ());
	} else {
		int t = scm_to_int (d);
		if (t > 0 && (t & (t-1)) == 0)
			k = Duration (intlog2 (t), dots);
		else
			return SCM_UNDEFINED;
	}

	if (!SCM_UNBNDP (factor))
		k = k.compressed (ly_scm2rational (factor));

	return k.smobbed_copy ();
}

SCM
make_chord_step (SCM step_scm, Rational alter)
{
	Pitch m (0, scm_to_int (step_scm) - 1, alter);

	// Notename/octave are normalized
	if (m.get_notename () == 6)
		m = m.transposed (Pitch (0, 0, FLAT_ALTERATION));

	return m.smobbed_copy ();
}


SCM
make_chord_elements (Input loc, SCM pitch, SCM dur, SCM modification_list)
{
	SCM res = Lily::construct_chord_elements (pitch, dur, modification_list);
	for (SCM s = res; scm_is_pair (s); s = scm_cdr (s))
	{
		unsmob<Music> (scm_car (s))->set_spot (loc);
	}
	return res;
}

// Return true if there are post events unaccounted for
bool
add_post_events (Music *m, SCM events)
{
	if (!scm_is_pair (events))
		return false;	// successfully added -- nothing

	while (m) {
		if (m->is_mus_type ("rhythmic-event")) {
			m->set_property
				("articulations",
				 scm_append_x (scm_list_2
					       (m->get_property ("articulations"),
						events)));
			return false;
		}
		if (m->is_mus_type ("event-chord")) {
			m->set_property
				("elements",
				 scm_append_x (scm_list_2
					       (m->get_property ("elements"),
						events)));
			return false;
		}
		if (m->is_mus_type ("sequential-music")) {
			SCM lp = scm_last_pair (m->get_property ("elements"));
			if (scm_is_pair (lp)) {
				m = unsmob<Music> (scm_car (lp));
				continue;
			}
			return true;
		}
		if (m->is_mus_type ("music-wrapper-music")
		    || m->is_mus_type ("time-scaled-music")) {
			m = unsmob<Music> (m->get_property ("element"));
			continue;
		}
		break;
	}
	return true;
}

// Returns either a list or a post-event
//
// If PRESERVE is true, unattachable post-events are not thrown away
// but rather added attached to empty chords.  If COMPRESS is true, a
// sequence consisting only of post-events may be returned as a single
// post-event.
SCM reverse_music_list (Lily_parser *parser, Input loc, SCM lst, bool preserve, bool compress)
{
	SCM res = SCM_EOL;	// Resulting reversed list
	SCM bad = SCM_EOL;	// Bad post events
	SCM post = SCM_EOL;	// current unattached events
	for (; scm_is_pair (lst); lst = scm_cdr (lst)) {
		SCM elt = scm_car (lst);
		Music *m = unsmob<Music> (elt);
		assert (m);
		if (m->is_mus_type ("post-event")) {
			post = scm_cons (elt, post);
			continue;
		}
		if (add_post_events (m, post)) {
			bad = scm_cons (scm_car (post), bad);
			if (preserve) {
				Music *p = unsmob<Music> (scm_car (post));
				res = scm_cons (MAKE_SYNTAX (event_chord,
							     *p->origin (),
							     post),
						res);
			}
		}
		post = SCM_EOL;
		res = scm_cons (elt, res);
	}
	if (scm_is_pair (post)) {
		if (scm_is_null (res) && compress) { // pure postevent list
			if (scm_is_null (scm_cdr (post)))
				return scm_car (post);
			Music *m = MY_MAKE_MUSIC ("PostEvents", loc);
			m->set_property ("elements", post);
			return m->unprotect ();
		}
		bad = ly_append2 (post, bad);
		if (preserve) {
			Music *p = unsmob<Music> (scm_car (post));
			res = scm_cons (MAKE_SYNTAX (event_chord,
						     *p->origin (),
						     post),
					res);
		}
	}
	for (; scm_is_pair (bad); bad = scm_cdr (bad))
	{
		Music *what = unsmob<Music> (scm_car (bad));
		if (preserve)
			what->origin ()->warning (_f ("Unattached %s",
						      what->name ()));
		else
			what->origin ()->warning (_f ("Dropping unattachable %s",
						      what->name ()));
	}
	return res;
}


int
yylex (YYSTYPE *s, YYLTYPE *loc, Lily_parser *parser)
{
	Lily_lexer *lex = parser->lexer_;

	lex->lexval_ = s;
	lex->lexloc_ = loc;
	int tok = lex->pop_extra_token ();
	if (tok >= 0)
		return tok;
	lex->prepare_for_next_token ();
	return lex->yylex ();
}
